import Bladex
import GenFX
import Auras
import Reference
import CharStats
import GameText
import MenuText
import darfuncs
import AuxFuncs
import Actions
import ItemTypes
import Basic_Funcs
import Damage
import Objects
import Sounds
import Scorer
import OnOff
import ObjStore
import B3DLib
import AbreCam
import whrandom
import NPCStats
import Raster
import Water
from math import pow
import copy

import PlayerTypes

GameText.MapList['NEWCONQUEST'] = 'NewConquest'


Bladex.SetSun(1,128,128,128) 


Reference.LavaInmune.append("Golem_stone")



char=Bladex.GetEntity("Player1")
cam=Bladex.GetEntity("Camera")




#################################################################################################################################################################################################


def GetText(s):
	return MenuText.GetMenuText(s)
	
def ClearText():
	global combshow
	combshow=0	
	GameText.ClearText()
	

LiveGame=1

def SetCamSave():
	print "Checking for save status"
	global LiveGame
	if LiveGame==1:
		LiveGame=0
	else:
  		cam.PViewType=0
  		import obj_def
		obj_def.InitNewStuff()
		
		if skystate==1:
			Bladex.SetSun(1,128,128,128) 
		else:
			Bladex.SetSun(1,-20,6,8)
			Raster.SetDomeColor(150,100,80)
		
		
  		print "This is a saved game"
  		
  	execfile("KeyFuncs.py")
	PlayerTypes.RemapKeys()

Bladex.AddScheduledFunc(Bladex.GetTime() + 2.0,SetCamSave,())



def CheckVenom():
	if char.Data.Poisoned:
		char.Data.Poisoned=0




Currentmusic=""
	
def ChangeMusic(music):
	Bladex.KillMusic()
	Bladex.ExeMusicEvent(Bladex.GetMusicEvent(music))
	global Currentmusic
	Currentmusic=music
	
	
def ResumeMusic():
	global Currentmusic
	Bladex.KillMusic()
	if Currentmusic!="":
		Bladex.ExeMusicEvent(Bladex.GetMusicEvent(Currentmusic))
		
	
	

	
	
def CleanTheCrap():
	ObjStore.CheckStore()
	ents = Bladex.nEntities()
	for id in range(ents):
		obj = Bladex.GetEntity(id)
		if obj:
			if obj.Kind == "Entity Pool":
				obj.RemoveFromWorld()
				obj.SubscribeToList("Pin")
			try:
				if obj.Kind=="Flecha" and obj.Scale>1.1 and not obj.Parent:
					obj.Position=100000,0,0
			except:
				pass

def DrownPlayer(finado):
	finado.Life = 0

def Drowned(sector, entity):
	per=Bladex.GetEntity(entity)	
	if not per.Person:
		return
	Waterlevel=42800
	Water.SplashWater(per.Position[0],Waterlevel-100,per.Position[2])
	if per.Name=="Player1":
		Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, DrownPlayer,(per,))
		cam.SType = 0
		cam.TType = 0
		print entity+" has fallen in the water. Can't Swim...."
	else:
		per.Life=0
		
		
############################## Armour ##### Allows aquiring armour protection while in MP skin.

def MyTakeArmour(entityname, usetype,):
	print "Using Armour"
	object = Bladex.GetEntity(entityname)
	if Reference.EntitiesObjectData.has_key(entityname):
		object_data = Reference.EntitiesObjectData[entityname]
	else:
		object_data = Reference.DefaultObjectData[object.Kind]
	object_flag = object_data[0]
	
	if char.CharTypeExt != object_data[1]:
		Actions.ReportMsg ("Type of armour not for me")
		return
	if char.Data.armour_level>=object_data[2]:
		Actions.ReportMsg ("Quality of armour not worthy")
		return
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, AuxFuncs.FadeTo, (0.5, 0.5))
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, MyTakeArmour2, (entityname,))


def MyTakeArmour2(entityname):
	object=Bladex.GetEntity(entityname)
	Data = char.Data
	if Reference.EntitiesObjectData.has_key(entityname):
		object_data = Reference.EntitiesObjectData[entityname]
	else:
		object_data = Reference.DefaultObjectData[object.Kind]

	ct = Bladex.GetCharType(char.CharType,char.CharTypeExt)

	sound=Bladex.CreateSound("..\\..\\Sounds\\cambio-armadura2.wav",entityname+"SoundNewArmour")
	sound.Volume=0.5
	sound.MinDistance=10000
	sound.MaxDistance=20000
	sound.PlayStereo()
	Data.armour_level=object_data[2]
	Data.armour_prot_factor=object_data[3]
	char.Data.DamageFactorNone  = 0.25
	char.Data.DamageFactorLight  = 0.50
	char.Data.DamageFactorHeavy = 0.80
	
	object.SubscribeToList("Pin")
	MPSkins=["KgtSkin1","KgtSkin2","BarSkin1","BarSkin2","DwfSkin1","DwfSkin2","AmzSkin1","AmzSkin2"]
	if not char.Kind == "Knight_N" and char.MeshName in MPSkins:
		print "I am not a Kinght and I have an MP skin"
		Actions.ReportMsg ("I have armour protection even though\nI am not actually wearing it.")
		return
	if char.Kind=="Knight_N":
		if object.Kind=="ArmaduraCaballeroCompleta":	
			newmesh="Knight_F"
			SwitchToArmourMesh(newmesh)
		elif char.MeshName in MPSkins:
			print "I AM a Kinght but I have an MP skin"
			Actions.ReportMsg ("I have armour protection even though\nI am not actually wearing it.")
			return
	if object_data[2]==0:
		SwitchToArmourMesh(ct.NoArmour)  
	elif object_data[2]==1:
		SwitchToArmourMesh(ct.LowArmour) 
	elif object_data[2]==2:
		SwitchToArmourMesh(ct.MedArmour) 
	elif object_data[2]==3:
		print "This should not happen"
	
	
def SwitchToArmourMesh(mesh):
	right= char.InvRight
	left= char.InvLeft
	rightback= char.InvRightBack
	leftback= char.InvLeftBack
	inv= char.GetInventory()
	inv.LinkRightHand ("")
	inv.LinkLeftHand ("")
	inv.LinkBack("")
	char.Data.UnlinkAll ("Player1", "")  # Dettatch arrows
	char.ResetWounds()
	char.SetMesh(mesh)
	if rightback:
		inv.LinkRightHand (rightback)
		inv.LinkRightBack(rightback)
	if leftback:
		inv.LinkLeftHand (leftback)
		inv.LinkLeftBack(leftback)
	if right:
		inv.LinkRightHand (right)
	if left:
		inv.LinkLeftHand (left)
	# to fix bug with taking objects later.....
	if char: 
		try:
			char.AnmEndedFunc("Player1")
		except:
			pass

	print "Armour Taken"



################################# FX 

def Powerup(name):
	time=Bladex.GetTime()
	aura=Auras.MakeAura("Player1",1.7, (1, 0.01, 1.0, 0, 0, 1),(),(),(2,  0.8, 0.9, 1.0, 0.6, 0.3  ,  0.2, 0.6, 0.8, 0.4, 1.0))
	aura.Data.AddEvent(time+0.7,(30, 1.0, 1.0, 0, 0, 1),(),(),(2,  0.8, 0.9, 1.0, 0.6, 0.3  ,  0.2, 0.6, 0.8, 0.4, 1.0))
	aura.Data.AddEvent(time+1.7,(240, 0.01, 1.0, 0, 0, 1),(),(),(2,  0.2, 0.2, 0.6, 0.6, 0.4  ,  0.0, 0.0, 0.6, 0.4, 0.5))


def ShockBolt1(x1,y1,z1,x,y,z,max):
	r=220
	g=200
	b=200
	r2=250
	g2=120
	b2=20
	r1=0
	g1=0
	b1=0
	sound=Bladex.CreateSound("..\\..\\Sounds\\RAYOS-ELECTRICOS.wav", "EBoltSnd")
	sound.Volume=1
	sound.MinDistance=1000000.0
	sound.MaxDistance=1000000.0
	sound.Play (x1,y1,z1,0)    #(o.Position[0], o.Position[1], o.Position[2], 0)
	ray=Bladex.CreateEntity("Ray"+str(z)+str(x), "Entity ElectricBolt", x1, y1, z1)
	ray.Target           = x, y, z
	ray.MaxAmplitude     = max
	ray.MinSectorLength  = 100000
	ray.Active           = 1
	ray.Damage           = 0
	ray.CoreGlowColor=240, 100, 240###
	ray.InnerGlowColor=10, 80, 10###
	

def ShockBolt2(x1,y1,z1,x,y,z,max):
	sound=Bladex.CreateSound("..\\..\\Sounds\\RAYOS-ELECTRICOS.wav", "EBolt2Snd")
	sound.Volume=1
	sound.Play(x1,y1,z1,0)#(o.Position[0], o.Position[1], o.Position[2], 0)
	ray2=Bladex.CreateEntity("Ray"+str(z)+str(x), "Entity ElectricBolt", x1, y1, z1)
	ray2.Target           = x, y, z
	ray2.MaxAmplitude     = max
	ray2.MinSectorLength  = 100000
	ray2.CoreGlowColor=240, 255, 240
	ray2.InnerGlowColor=10, 80, 10
	ray2.Active           = 1
	ray2.Damage           = 0
	
	
	
def SwordAppearsFX(ob,effect,ran):
	t = Bladex.GetTime()
	sound=Bladex.CreateSound("..\\..\\Sounds\\fuego-boo.wav", "SndAppSwrd")
	sound.Volume=1
	sound.Play(-66500, 28800,-58000, 0)
	FireBall2 = Bladex.CreateEntity("App"+str(t), "Entity Particle System Dobj", 0,0,0)
	FireBall2.ObjectName=ob
	FireBall2.ParticleType   = effect
	FireBall2.YGravity       = -600 # -1000
	FireBall2.Friction       = 1
	FireBall2.PPS            = 1024 # 2024
	FireBall2.Velocity       = 0,0, 0 # 0,800,0
	FireBall2.Time2Live      = 20 # 30
	FireBall2.RandomVelocity = ran
	FireBall2.DeathTime=Bladex.GetTime()+3.0
	
	
	

def ChangeRasterMode2(ent_name, mode):
	Bladex.GetEntity(ent_name).RasterMode=mode
	
	
	
	

def CKMagicallyAppearing(entity="BigGuy"):
	TimeEffect=12.0
	time=Bladex.GetTime()
	me=Bladex.GetEntity(entity)
	x,y,z=me.Position
	AuxFuncs.FadeObject(entity, 0.01, 1.0, TimeEffect)
	AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
	AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
	AuraParams2=(50 , 0.01, 1.0, 0, 1, 1)
	AuraGradient0=(2,  0.2, 0.4, 0.8, 1.0, 0.2  ,  0.0, 0.2, 0.8, 0.0, 0.7)
	AuraGradient1=(2,  0.8, 0.9, 1.0, 1.0, 0.2  ,  0.0, 0.2, 0.9, 0.1, 1.0)
	aura=Auras.MakeAura(entity, TimeEffect, AuraParams0, (), (), AuraGradient0)
	aura.Data.AddEvent (time+TimeEffect/2.0, AuraParams1, (), (), AuraGradient1)
	aura.Data.AddEvent (time+TimeEffect, AuraParams2, (), (), AuraGradient0)
	ps=Bladex.CreateEntity("PSPersonMagicallyAppearing", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=entity
	ps.ParticleType="FastEnergyConc"
	ps.PPS=200
	ps.YGravity=0.0
	ps.Friction=0.0
	ps.Velocity=0.0, 0.0, 0.0
	ps.RandomVelocity=0.5
	ps.NormalVelocity=-2.0
	ps.Time2Live=30
	ps.DeathTime=time+TimeEffect/2.0
	lite= Bladex.CreateEntity(entity+"_Lite","Entity Spot",x,y-1000,z)
	lite.Color       = 150,100,220
	lite.Intensity   = 0.0
	lite.Precission  = 0.07
	lite.CastShadows = 0
	lite.Visible     = 0
	lite.Flick=0 
	AuxFuncs.SpotIntensityVariation(lite.Name,0.01,20,3.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+TimeEffect-5,AuxFuncs.SpotIntensityVariation,(lite.Name,20,0.01,8,1,))
	
	
	
def EnemyMagicallyAppearing(enemy, xtm):
	TimeEffect=xtm
	time=Bladex.GetTime()
	char=Bladex.GetEntity(enemy)
	AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
	AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
	AuraParams2=(50 , 0.01, 1.0, 0, 1, 1)
	AuraGradient0=(2,  0.4, 0.4, 1.0, 1.0, 0.2  ,  0.0, 0.3, 0.9, 0.0, 0.7)
	AuraGradient1=(2,  0.1, 0.2, 0.9, 1.0, 0.2  ,  0.6, 0.6, 0.9, 0.1, 1.0)
	aura=Auras.MakeAura(enemy, TimeEffect, AuraParams0, (), (), AuraGradient0)
	aura.Data.AddEvent (time+TimeEffect/2.0, AuraParams1, (), (), AuraGradient1)
	aura.Data.AddEvent (time+TimeEffect, AuraParams2, (), (), AuraGradient0)
	ps=Bladex.CreateEntity("PSEnemyMagicallyAppearing", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=enemy
	ps.ParticleType="FastEnergyConc"
	ps.PPS=400  #200
	ps.YGravity=-800     #0.0 # -300! #-800 !!
	ps.Friction=0.5 ############0.01
	ps.Velocity=0.0, 0.0, 0.0
	ps.RandomVelocity=0.5
	ps.NormalVelocity=-2.0
	ps.Time2Live=30     # 30
	ps.DeathTime=time+TimeEffect/2.0
	
	

def Venomglow(enemy, xtm):
	time=Bladex.GetTime()
	TimeEffect=xtm
	AuraParams=(160, 1, 1, 0, 0, 0) #80
	AuraGradient=(2, 0.586, 0.735, 0.33, 0.2, 0.0, 0.73, 0.865, 0.214, 0.1, 0.5)
	aura=Auras.MakeAura(enemy, TimeEffect, AuraParams, (), (), AuraGradient)
	pg=Bladex.CreateEntity("PSVenomglow"+str(xtm), "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	pg.PersonName=enemy
	pg.ParticleType="GasVenenoso"
	pg.PPS=30
	pg.YGravity=-900 # 400 # 0
	pg.Friction=0.02
	pg.Velocity=0.0, 0.0, 0.0
	pg.RandomVelocity=1.0
	pg.NormalVelocity=0
	pg.Time2Live=60
	pg.DeathTime=time+TimeEffect/2.0



def Venomglow2(enemy, xtm):
	time=Bladex.GetTime()
	TimeEffect=xtm
	pg2=Bladex.CreateEntity("PSVenomglow"+str(time), "Entity Particle System Dobj", 0.0, 0.0, 0.0)
	pg2.ObjectName=enemy
	pg2.ParticleType="GasVenenoso"
	pg2.PPS=30
	pg2.YGravity=-500 # 400 # 0
	pg2.Friction=0.02
	pg2.Velocity=0.0, 0.0, 0.0
	pg2.RandomVelocity=5.0
	pg2.NormalVelocity=0
	pg2.Time2Live=60
	pg2.DeathTime=time+TimeEffect
	
	

def DeathAppears(PersonName, aura=1, Dtime=1.5):
	time=Bladex.GetTime()
	if aura:
		aura=Auras.MakeAura(PersonName,0.8,   ( 50, 1.0 , 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))
		aura.Data.AddEvent(time+0.4,          (150, 0.5 , 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))
		aura.Data.AddEvent(time+0.8,          (200, 0.01, 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))

	wps=Bladex.CreateEntity(PersonName+"WPS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	wps.PersonName=PersonName
	wps.ParticleType="DeathCloud"
	wps.Time2Live=32
	wps.RandomVelocity=2.0
	wps.Velocity=0,0,0
	wps.NormalVelocity=20
	wps.YGravity=0
	wps.DeathTime=Bladex.GetTime()+Dtime
	wps.PPS=1024



def SeePowup(entity,effect):
	esq = Bladex.GetEntity(entity)
	sound=Bladex.CreateSound("..\\..\\Sounds\\fuego-boo.wav", "SndFireball")
	sound.Volume=1
	sound.Play(esq.Position[0], esq.Position[1], esq.Position[2], 0)
	FireBall = Bladex.CreateEntity("Flash"+str(entity), "Entity Particle System D1", esq.Position[0],esq.Position[1],esq.Position[2])
	FireBall.ParticleType   = effect
	FireBall.YGravity       = -1000 # -1000
	FireBall.Friction       = 0
	FireBall.PPS            = 1024 # 2024
	FireBall.Velocity       = 0,800, 0 # 0,800,0
	FireBall.Time2Live      = 30 # 30
	FireBall.RandomVelocity = 35
	FireBall.DeathTime=Bladex.GetTime()+0.8


##################################################################################################################################################################################################



WayPoint=11000,-1500,-7000
OldWayPoint=11000,-1500,-7000
WayPointAngle=0
ShowCStats=0
deathCount=0
deadcheck=0
killcount=0


PlayerSkill = ["Godlike",
               "Gladiator",
               "Master of the Blade",
               "Expert Warrior",
               "Weapons Master",
               "Veteran Swordsman",
               "Skilled Swordsman",
               "Swordsman",
               "Apprentice Swordsman",
               "Trainee Swordsman",
               "Footsoldier",
               "Trainee Soldier",
               "Raw Recruit",
               "Peasant",
               "Weakling",
               "Orc Food",
               "Poor",
               "Very Poor",
               "Awful",
               "Hopeless",
               "Total Loser",
               "Absolute Tosser"]


######## Knightshade Combos


if char.Kind=="Barbarian_N":
	
	bar=Bladex.GetCharType("Barbarian_N","Bar")
	DKType="Knightshade_B"
	
	bar.AllowAttack("GM12_2H","B","GI_2H","","",DKType)		# Death Sweep
	bar.AllowAttack("GM41_2H","R","GM7_2H","","",DKType)		# Long Sword - hellswing
	
	bar.AllowAttack("GM32_AXE","R+B","GI_2H","","",DKType)				# Scythe
	bar.AllowAttack("GM32_AXE","&R+B","GI_2H","","",DKType)
	bar.AllowAttack("GM40_2H","R+L","GI_2H","","GI_2H_Window",DKType)		# Saw Sword - chaos killer
	
	
	#bar.AllowAttack("GM42_2H","R+L","GI_2H","","GI_2H_Window",DKType)          	# Destroyer ok
	#bar.AllowAttack("GM31_AXE","R+L","GM2_2H","","GM2_2H_Window",DKType)	        # Shredder  ok
	#bar.AssignTrail("GM31_AXE","","EstelaRoja1")
	#bar.AllowAttack("GM6_2H","B","GM1_2H","","GM1_2H_Window",DKType)		# Chaos Sword speed kill 
	#bar.AllowAttack("GM6_2H","&B","GM1_2H","","GM1_2H_Window",DKType)		
	#bar.AllowAttack("GM12_2H","L+B","GI_2H","","",DKType)		# Death Sweep
	
	#bar.AllowAttack("GM9_2H","F","GM3_2H","","",DKType)                # Big Sword
	
	#bar.AllowAttack("GM40_2H","R+L","GM1_2H","","GM1_2H_Window",DKType)		# Saw Sword - chaos killer
	
	#bar.AllowAttack("GM41_2H","R","GM7_2H","","",DKType)				# Long Sword - hellswing
	
	#bar.AllowAttack("GM32_AXE","R+B","GI_2H","","",DKType)				# Scythe
	#bar.AllowAttack("GM32_AXE","&R+B","GI_2H","","",DKType)
	
	
elif char.Kind=="Amazon_N":
	amz=Bladex.GetCharType("Amazon_N","Amz_N")
	DKType="Knightshade_A"
	amz.AllowAttack("GM24_SP","F+B","GM15_SP","","",DKType)				# Heavy Naginata
	amz.AllowAttack("GM32_SP","B+R","GI_SP","","GI_SP_Window",DKType)		# Spear
	amz.AllowAttack("GM33_SP","F+B","GI_SP","","GI_SP_Window",DKType)		# Harpoon
	amz.AllowAttack("GM10_SP","B","GM1_SP","","",DKType)				# Boathook
	amz.AllowAttack("GM26_SP","A+F","GM1_SP","","GM1_SP_Window",DKType)		# Crush Bo
	amz.AllowAttack("GM27_SP","L","GM3_SP","","",DKType)				# Naginata
	amz.AllowAttack("GM5_SP","L+R","GM3_SP","","GM3_SP_Window",DKType)		# Sharp Axe
	amz.AllowAttack("GM31_SP","L","GM6_SP","","",DKType)				# Axpear
	amz.AllowAttack("GM28_SP","A+B","GM8_SP","","",DKType)  		        # Demon Spear
	
	
	
elif char.Kind=="Dwarf_N":
	dwf=Bladex.GetCharType("Dwarf_N","Dwf_N")
	DKType="Knightshade_D"
	
	
	dwf.AllowAttack("GM11_1H","&F","GI_1H","","GI_1H_Window",DKType)		# Killer axe
	dwf.AllowAttack("GM17_1H","&B","GI_1H","","GI_1H_Window",DKType)		# Warhammer
	dwf.AllowAttack("GM29_1H","B+F","GM12_1H","","GM12_1H_Window",DKType)		# Double Mace
	dwf.AllowAttack("GM22_1H","B+R","GM12_1H","","GM12_1H_Window",DKType)		# Big Hammer
	dwf.AllowAttack("GM15_1H","&L","GM14_1H","","GM14_1H_Window",DKType)		# Hacha 4
	dwf.AllowAttack("GM32_1H","&R","GM16_1H","","GM16_1H_Window",DKType)		# Hacha 2
	

	dwf.AllowAttack("GM15_1H","&L","GM14_1H","","GM14_1H_Window","ProWarAxe")#### bonus combo Pro 8)
	dwf.AllowAttack("GM17_1H","&B","GI_1H","","GI_1H_Window","ProWarAxe")    #### bonus combo Pro 8)
	
else:
	
	DKType="Knightshade_K"
	kgt=Bladex.GetCharType("Knight_N","Kgt_N")
	
	kgt.AllowAttack("GM20_1H","B+R","GI_1H","","GI_1H_Window",DKType)		# mace
	kgt.AllowAttack("GM16_1H","L+B","GI_1H","","GI_1H_Window",DKType)		# sharp sword
	kgt.AllowAttack("GM34_1H","F+R","GI_1H","","GI_1H_Window",DKType)		# elf sword
	#kgt.AllowAttack("GM36_1H","B","GM23_1H","","GM23_1H_Window",DKType)
	kgt.AllowAttack("GM18_1H","F","GM23_1H","","",DKType)				# scimitar
		
	kgt.AllowAttack("GM39_1H","B","GM1_1H","","",DKType)				# hooksword
	kgt.AllowAttack("GM21_1H","L+R","GM1_1H","","GM1_1H_Window",DKType)		# heavy sword
	kgt.AllowAttack("GM5_1H","L","GM3_1H","","",DKType)				# curved sword
	kgt.AllowAttack("GM35_1H","F","GM6_1H","","",DKType)				# combat sword
	
	kgt.AllowAttack("GM34_1H","F+R","GI_1H","","GI_1H_Window","Orksword")   #### bonus combo Pro 8)
	kgt.AllowAttack("GM34_1H","F+R","GI_1H","","GI_1H_Window","EgyptSword") #### bonus combo Pro 8)
	




############### Stats

powerup1 = ""
powerup2 = ""
powerup3 = ""
powerup4 = ""
powerup5 = ""
powerup6 = ""
pupvenom = 0
puplight = 0
pupfire = 0
pupdrain = 0
pupice = 0
pupelec = 0
pupdest = 0
combmenu = 0
combshow = 0
powups=0


BLFontSmall="../../BODLoader/Letras BODLoader peq.bmp"
BLFontMed="../../BODLoader/Letras BODLoader med.bmp"
BLFontBig="../../BODLoader/Letras BODLoader gra.bmp"




def ShowInventory():
	global powerup1
	global powerup2
	global powerup3
	global powerup4
	global powerup5
	global powerup6
	global pupvenom
	global puplight
	global pupfire
	global pupdrain
	global pupice
	global pupelec
	global pupdest
	global combmenu
	global combshow
	if (combshow == 0):
  		if (combmenu == 1):
	    		if (pupvenom == 1):
				powerup1 = "Lethal Injection"
	    		if (pupfire == 1):
				powerup2 = "Soul Burner"
	    		if (puplight == 1):
				powerup3 = "White Lightning"
	    		if (pupdrain == 1):
				powerup4 = "Life Extractor"
	    		if (pupice == 1):
				powerup5 = "Spine Freezer"
	    		if (pupelec == 1):
				powerup6 = "Electrocution"
			if (pupdest == 1):
				powerup7 = "Destructor"
	    		
	    		ClearText()	
	    		combshow = 1
	   		
	   		GameText.WriteTextAux("- Knightshade Power Ups -\n" + str(powerup1) + str(powerup2) + str(powerup3) + str(powerup4) + str(powerup5) + str(powerup6) + str(powerup7), 300, 255,150,10, [], 160)
	  	else:
	    		ClearText()
	    		GameText.WriteTextAux("You must find Knightshade!",5.0,255,150,20,[],260)
	else:
		combshow = 0
		ClearText()



def ShowVersion ():
	GameText.WriteTextAux("Conquest Version 1.1\n"+"by Sir Random 2001\n"+"random(a)eircom.net",5.0,255,150,20,[],20)



def ConquestStats(time=300):
	global ShowCStats
	if ShowCStats==0:
		ShowCStats=1
		SkillLevel=deathCount
		if SkillLevel > len(PlayerSkill)-1:
			SkillLevel=len(PlayerSkill)-1
		global pupvenom
		global pupfire
		global pupdrain
		global puplight
		global pupice
		global pupelec
		global pupdest
		Showpups=""
		if (pupvenom+pupfire+pupdrain+puplight+pupice+pupelec==0):
			Showpups="\nNo Power-Ups found"
		if pupvenom==1: 
			Showpups=Showpups+"\nLethal Injection"
		if pupfire==1: 
			Showpups=Showpups+"\nSoul Burner"
		if pupdrain==1: 
			Showpups=Showpups+"\nLife Extractor"
		if puplight==1: 
			Showpups=Showpups+"\nWhite Lightning"
		if pupice==1: 
			Showpups=Showpups+"\nSpine Freezer"
		if pupelec==1: 
			Showpups=Showpups+"\nElectrocution"
		if pupdest==1: 
			Showpups=Showpups+"\nDestructor"

		ClearText()
		GameText.WriteTextAux("***** GAME STATS *****\n\nRANK:  "+str(PlayerSkill[SkillLevel])+"\nKILLS:  "+str(killcount)+"\nDEATHS:  "+str(deathCount)+"\n\n***** POWER UPS *****\n"+str(Showpups), time, 250,150,10,[],200)
	else:
		ShowCStats=0
		ClearText()		
		

####################################################################################
#                                                                                  #
#  Player ReSpawn + While Dead Functions adapted from Gladiator Mod by Josh Dahlby #
#                                                                                  # 
####################################################################################

Respawning=0


def PlayerDied (entity="Player1"):
	print "Player1 - DeathFuncCalled"
	if char.AnimName == "Dth_Fll2":
		print "fell off something........ arrrgh!!!"
		char.AnmEndedFunc= RespawnAfterFall
		return
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.2,PlayerDied2,())

def RespawnAfterFall(entity):
	Bladex.AddScheduledFunc(Bladex.GetTime() + 2.2,PlayerDied2,())
	char.AnmEndedFunc=None



def PlayerDied2 (entity="Player1"):
	Bladex.KillMusic()
	Bladex.ExeMusicEvent(Bladex.GetMusicEvent("GotKilled"))
	ClearText()
	global deathCount
	deathCount=deathCount+1
	if deathCount> len(PlayerSkill)-1:
		Exit()
		return
	
	
	global Respawning
	Respawning=1
	char.Wuea = Reference.WUEA_ENDED
	Bladex.DeactivateInput()
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.8, Scorer.SetVisible,(0,))	
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.1, AuxFuncs.FadeTo, (7.0, 0.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 10.0,ReSpawnX,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 7.0, ConquestStats,(7.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 11.0,ResetRespawnVar,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 14.0,ResumeMusic,())


def Exit():
	
	Bladex.DeactivateInput()
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.8, Scorer.SetVisible,(0,))	
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.1, AuxFuncs.FadeTo, (10.0, 100.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 4.0, ExitCap,(4.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 11.0, QuickExit,())



def QuickExit():
	import SaveGame		
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.0,SaveGame.MenuStart,(EntityName,))
	



def ExitCap():
	ClearText()
	GameText.WriteTextAux(GetText("You Have Run OutOf Lives"))
	
	
	
	
def ShowStats(time=30.0):
	ClearText()
	GameText.WriteTextAux(GetText("RANK:...."+str(PlayerSkill[skillCount])+"\n\nDEATHS:...................."+str(deathCount)+"\n\nKILLS..............."+str(killcount)), time, 255,170,10,[],200)




def EndReSpawnX():
	if char.Data.Invincibility == 3:
		char.Data.Invincibility = 0
		
		
def RelinkCam():
	char.Data.RelinkCamera()
		
		
def MyReSpawn (EntityName):		
	me = Bladex.GetEntity(EntityName)
	right= me.InvRight
	left= me.InvLeft
	rightback= me.InvRightBack
	leftback= me.InvLeftBack
	inv= me.GetInventory()
	if rightback:
		inv.LinkRightHand (rightback)
		inv.LinkBack(rightback)		
	if leftback:
		inv.LinkLeftHand (leftback)
		inv.LinkBack(leftback)	
	if right:
		inv.LinkRightHand (right)
	if left:
		inv.LinkLeftHand (left)	
	me.Life= CharStats.GetCharMaxLife(me.Kind, me.Level)
	me.Energy= CharStats.GetCharMaxEnergy(me.Kind, me.Level)
	me.ResetWounds()
	if me.Data.Poisoned:
		me.Data.UnVenom()
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,RelinkCam,())
	angle= me.Angle
	me.Orientation= (0.0, 3.62407746479e-007, 0.707107365131, -0.707106947899)
	me.Angle= angle

		


def ReSpawnX():
	if char.Life <= 0:
		char.PartialLevel = char.PartialLevel - (CharStats.GetCharExperienceCost(char.CharType,char.Level))
		if char.PartialLevel < 0:
			char.PartialLevel = 0
		Scorer.SetLevelBarValue(char.PartialLevel)
		Bladex.RemoveAfterFrameFunc("Fade")
		char.LaunchAnmType("Rlx")
		char.SelfIlum=0
		MyReSpawn("Player1")
		x,y,z=WayPoint
		char.Position = x,y,z
		char.Angle=WayPointAngle
		if char.Data.Invincibility == 0:
			char.Data.Invincibility = 3
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, EndReSpawnX,(), "EndReSpawnX")
		AuxFuncs.ResetScene()
		Bladex.AddScheduledFunc(Bladex.GetTime() + 0.0, AuxFuncs.FadeFrom, (3.5, 0.0,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, GenFX.PersonMagicallyAppearing,())
		SulphurSectorsEnable()
		
		
def ResetRespawnVar():
	global Respawning
	Respawning=0
	Bladex.AddScheduledFunc(Bladex.GetTime() + 1.2, Scorer.SetVisible,(1,))	



def KilledEnemy ():
	global killcount
	killcount=killcount+1
	print "Got the bugger"


def SetPlayerFuncs():
	char.Data.KilledEnemyFunc=KilledEnemy
	char.Data.DeathFunc=PlayerDied
	

Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,SetPlayerFuncs,())


###################################################################################################################################################################################################


def Saved():
	pass


def WSaved():
	char=Bladex.GetEntity("Player1")
	Powerup("Player1")
	pos=char.Position
	sound=Bladex.CreateSound("..\\..\\Sounds\\sesgado-especial-largo2.wav", "SndWaypoint")
	sound.Volume=1
	sound.Play(pos[0], pos[1], pos[2], 0)
	ClearText()
	GameText.WriteTextAux(GetText("Waypoint Saved"), 3.0, 180,200,255,[],30)
	CleanTheCrap()

def DumpMe(entity):
	thing=Bladex.GetEntity(entity)
	thing.Position=0,60000,0
	


def waydissap(entity):
	o=Bladex.GetEntity(entity)	
	SwordAppearsFX(o.Name,"EnergyDissip",20)
	o.Alpha=0
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,DumpMe,(entity,))


def SetWayTemp(x,y,z):
	global OldWayPoint
	global WayPoint
	OldWayPoint=WayPoint
	WayPoint=x,y,z
	CleanTheCrap()
	
def ResetWayPoint():
	global WayPoint
	WayPoint=OldWayPoint
	


def SetWay0():
	global WayPoint
	global WayPointAngle
	WayPoint=-13086,3000,5579
	WayPointAngle=3
	waydissap("way01")
	WSaved()
	


def SetWay1():
	global WayPoint
	global WayPointAngle
	WayPoint= -19961,23024,-54430  #-17000, 22500, -50000
	WayPointAngle=2
	waydissap("way1")
	char=Bladex.GetEntity("Player1")
	WSaved()
	

def SetWay2(sector, entity):
	if entity!="Player1":
		return
	global WayPoint
	global WayPointAngle
	WayPoint=23840,38702,-21959    
	WayPointAngle=3.5
	waydissap("way2")
	WSaved()
	sectway2.OnEnter=""

def SetWay3():
	global WayPoint
	global WayPointAngle
	WayPoint=45062,35609,-2162
	WayPointAngle=4.5
	waydissap("way3")
	WSaved()


def SetWay4():
	global WayPoint
	global WayPointAngle
	WayPoint=61000, 34900, -6000
	WayPointAngle=3
	waydissap("way4")
	WSaved()
	ActSally()


def SetWay5():
	global WayPoint
	global WayPointAngle
	WayPoint=88500, 38500, -60500
	WayPointAngle=4
	waydissap("way5")
	WSaved()


def SetWay6():
	global WayPoint
	global WayPointAngle
	WayPoint=148000, 38500, -60000
	WayPointAngle=4.5
	waydissap("way6")
	WSaved()
	UnhideGuardGolem()

def SetWay7():
	global WayPoint
	global WayPointAngle
	WayPoint=231500, 44000, -60000
	WayPointAngle=0
	CleanTheCrap()

################## Knightshade Powerups #################


def AddLightToShade(sector, entity):
	if entity != "Player1":
		return
	global puplight
	puplight=1
	dk.Data.AddLight()
	SeePowup("Powerup4","LargeFire")
	GameText.WriteTextAux(GetText("******** White Lightning ********\nPower-Up"), 5.0, 155,155,255,[],260)
	global powups
	powups=powups+1
	sectpowup2.OnEnter = None

def AddFireToShade(sector, entity):
	if entity != "Player1":
		return
	global pupfire
	pupfire=1
	dk.Data.AddFire()
	SeePowup("Powerup6","LargeFire")
	GameText.WriteTextAux(GetText("******** Soul Burner ********\nPower-Up"), 5.0, 255,155,20,[],260)
	global powups
	powups=powups+1
	sectpowup6.OnEnter = None

def AddVenomToShade(sector, entity):
	if entity != "Player1":
		return
	global pupvenom
	pupvenom=1
	dk.Data.AddVenom()
	SeePowup("Powerup1","LargeFire")
	GameText.WriteTextAux(GetText("******** Lethal Injection ********\nPower-Up"), 5.0, 100,200,100,[],260)
	global powups
	powups=powups+1
	sectpowup3.OnEnter = None

def AddDrainToShade(sector, entity):
	if entity != "Player1":
		return
	global pupdrain
	pupdrain=1
	dk.Data.AddDrain()
	SeePowup("Powerup3","LargeFire")
	GameText.WriteTextAux(GetText("******** Life Extractor ********\nPower-Up"), 5.0, 200,10,10,[],260)
	global powups
	powups=powups+1
	sectpowup4.OnEnter = None

def AddIceToShade(sector, entity):
	if entity != "Player1":
		return
	global pupice
	pupice=1
	dk.Data.AddIce()
	SeePowup("Powerup2","LargeFire")
	GameText.WriteTextAux(GetText("******** Spine Freezer ********\nPower-Up"), 5.0, 200,200,255,[],260)
	global powups
	powups=powups+1
	sectpowup5.OnEnter = None

def AddElectricToShade(sector, entity):
	if entity != "Player1":
		return
	global pupelec
	pupelec=1
	dk.Data.AddElectric()
	SeePowup("Powerup5","LargeFire")
	GameText.WriteTextAux(GetText("********* Electrocution *********"), 5.0, 0,0,255,[],260)
	global powups
	powups=powups+1
	sectpowup1.OnEnter = None
	
def AddDestructorToShade(sector, entity):
	if entity != "Player1":
		return
	global pupdest
	pupdest=1
	dk.Data.AddDestructor()
	SeePowup("Powerup7","LargeFire")
	GameText.WriteTextAux(GetText("********* Destructor *********"), 5.0, 0,128,255,[],260)
	global powups
	powups=powups+1
	sectpowup7.OnEnter = None

##############################################################################################################################################################################################
####### Custom Matrix


def GiraCamara(AngleVariation):
        Yvar=1000   #5000
        VecRot       = cam.TPos[0]-cam.Position[0], cam.TPos[1]-cam.Position[1], cam.TPos[2]-cam.Position[2]
        vtpos        = VecRot[0]*math.cos(AngleVariation)-VecRot[2]*math.sin(AngleVariation), VecRot[0], VecRot[0]*math.sin(AngleVariation)+VecRot[2]*math.cos(AngleVariation)
        cam.TPos     = vtpos[0]+cam.Position[0], cam.Position[1]+Yvar, vtpos[2]+cam.Position[2]
	global GcamfinTpos
	GcamfinTpos = cam.TPos
	
def InitGiroCamera(ESource = "Player1"):
        VecRot = 2*cam.TPos[0]-cam.Position[0], 2*cam.TPos[1]-cam.Position[1], 2*cam.TPos[2]-cam.Position[2]
        cam.ESource = ESource
        cam.SType   = 2
        cam.TType   = 0
        cam.TPos    = VecRot
	

MatrixTimeX = 0
MatrixCameraStateX = 0
MatrixPersonX = ""



def MatrixFXAfterFrameFuncX(time):
	global MatrixTimeX
	GiraCamara((time-MatrixTimeX)*0.2)
	MatrixTimeX = time


def StartMatrixFXX(ESource = "Player1", speed=0.5):
	global MatrixTimeX
	global MatrixCameraStateX
	
	InitGiroCamera(ESource)
	Bladex.SetTimeSpeed(speed)
	Bladex.RemoveAfterFrameFunc("MatrixFXX")
	Bladex.SetAfterFrameFunc("MatrixFXX",MatrixFXAfterFrameFuncX)
	MatrixTimeX = Bladex.GetTime()
	


def StopMatrixFXX():
	global MatrixTimeX
	Bladex.RemoveAfterFrameFunc("MatrixFXX")
	Bladex.SetTimeSpeed(1.0)
	cam.SetPersonView("Player1")
	cam.PViewType = 0
	cam.Cut()
	MatrixTimeX = 0
	

def StopMatrixFXXNoRes():
	global MatrixTimeX
	Bladex.RemoveAfterFrameFunc("MatrixFXX")
	Bladex.SetTimeSpeed(1.0)
	#cam.SetPersonView("Player1")
	#cam.PViewType = 0
	cam.Cut()##########
	MatrixTimeX = 0


###############################################################################################################################################################################################
###############################################################################################################################################################################################
############# Start Adventure


caminitpos=0,0,0
caminitTpos=0,0,0


def EndStrt4():
	Bladex.ActivateInput()
	Scorer.SetVisible(1)
	Bladex.SetListenerPosition(1)
	AuxFuncs.ResetScene()
	darfuncs.HideBadGuy("DramaSkel1")
	darfuncs.HideBadGuy("Ork3D")
	
	
def EndStrt3():
	Bladex.AddScheduledFunc(Bladex.GetTime()+1, EndStrt4, ())


def MovCc(Point,Target,Time):
	auxi1=cam.Position
	auxi2=cam.TPos
	AuxFuncs.MoveCamFromTo(auxi1[0], auxi1[1], auxi1[2], Point[0], Point[1], Point[2], auxi2[0],auxi2[1], auxi2[2],Target[0], Target[1], Target[2], Time, EndStrt3)


def EndStrt2():
	pos=char.Position
	Point=caminitpos[0],caminitpos[1],caminitpos[2]
	Target=char.Position[0],char.Position[1],char.Position[2]
	Time=3
	Bladex.AddScheduledFunc(Bladex.GetTime()+3, MovCc, (Point,Target,Time))
	
	
def MovCb(Point,Target,Time):
	auxi1=cam.Position
	auxi2=cam.TPos
	AuxFuncs.MoveCamFromTo(auxi1[0], auxi1[1], auxi1[2], Point[0], Point[1], Point[2], auxi2[0],auxi2[1], auxi2[2],Target[0], Target[1], Target[2], Time, EndStrt2)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.6,OrkWalk,())


def EndStrt1():
	Point=-18000,-19000,11000
	Target=-36000,40000,-29000
	Time=5
	Bladex.AddScheduledFunc(Bladex.GetTime()+5, MovCb, (Point,Target,Time))
	ChangeMusic("Atmos18")
	o=Bladex.GetEntity("DramaSkel1")
	o.GoToJogging = 0
	o.GoTo(15000,-18500,17000)
	GameText.WriteTextAux("*** The Rocky Valley ***", 5.0, 255,150,20,[],300)
	

def MovC(Point,Target,Time):
	global caminitpos
	global caminitTpos
	cpos=cam.Position
	cTpos=cam.TPos
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], Point[0], Point[1], Point[2], cTpos[0],cTpos[1], cTpos[2],Target[0], Target[1], Target[2], Time, EndStrt1)


def StrtM1():	
	Bladex.DeactivateInput()
	Point=29000,-24000,0
	Target=-26000,0,-2000
	Time=3
	MovC(Point,Target,Time)
	
	
def IntroPro():
	char.Position=11000,-1500,-7000
  	cam.PViewType=0
	Bladex.DeactivateInput()
	AuxFuncs.FadeFrom(4.0,0.6)
	Bladex.SetListenerPosition(2)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.5,StrtM1,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+6.5,WalkOn,())


def WalkOn():
	if char.GoTo(-3617,-1272,-1847):
		global caminitpos
		caminitpos =540,-3370,-2450
		caminitTpos=-9050,-910,-1050
		
		
		
def OrkWalk():
	ork3D.GoTo(-23976,7515,-16496)
	
	

########## Bridge Cave


def ActCaveOrk1():
	global Ork1Act
	if Ork1Act:
		return
	darfuncs.UnhideBadGuy("Ork1")
	Ork1Act=1
	
	
def UnhideCaveOrks2_3():
	darfuncs.UnhideBadGuy("Ork2")
	darfuncs.UnhideBadGuy("Ork3")
	
	
def ActCaveOrk2_3():
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("Combat2",))
	


def ActCaveOrk4():
	darfuncs.UnhideBadGuy("Ork4")
	
	
	
def BridgeCaveOrkDead(entity):
	global BridgeCaveOrks
	if entity in BridgeCaveOrks:
		BridgeCaveOrks.remove(entity)
		if len(BridgeCaveOrks)==0:
			Bladex.ExeMusicEvent(-1)
			Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("Atmos18",))
	if entity=="Ork4" and not Ork1Act:
		ork1.Position=-36028,4460,-18152
		ork1.Angle=4.5
		darfuncs.UnhideBadGuy("Ork1")
		global Ork1Act
		Ork1Act=1
	
	
	
######## Cliff Cave
	
def CliffCaveOrkDead(entity):
	global CliffCaveorks
	if entity in CliffCaveorks:
		CliffCaveorks.remove(entity)
	if len(CliffCaveorks)==0:
		Bladex.AddScheduledFunc(Bladex.GetTime()+5.0,OpenProDoor1,())
		Bladex.ExeMusicEvent(-1)
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("Atmos18",))
		
		
def OpenProDoor1():	
	prodoor1.OpenDoor()
	
	
def SulfurOrkDead(entity):
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.0,ChangeMusic("Atmos29",))

	
def UnhideOrk5_Gork1():
	Bladex.KillMusic()
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("Combat6",))
	darfuncs.UnhideBadGuy("Ork5")
	darfuncs.UnhideBadGuy("GreatOrk1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+7.0, Actions.TurnToFaceEntity,("Ork5","Player1",))
	SetWay0() 
	if len(BridgeCaveOrks)==0:
		return
	for id in BridgeCaveOrks:
		ork=Bladex.GetEntity(id)
		if ork.Life>0:
			ork.Life=0
			
			
########## Sulfur Pit
	
def UnhideSulfurOrk():
	darfuncs.UnhideBadGuy("GreatOrk2")
	
	
def SulphurOrkDead(entity):
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("Atmos1",))
	
	
def OpenPitGate():
        desplazamientos=(2200.0, 600.0)
        vectores=((0.0, 1.0, 0.0), (0.0, 1.0, 0.0))
        vel_iniciales=(500.0, 2000)
        vel_finales=(2000.0, 500)
        son_durante=(deslizrasanexo, deslizrasanexo)
        son_finales=("", golperasanexo)
        Objects.NDisplaceObject(gate1din, desplazamientos, vectores, vel_iniciales, vel_finales, (), son_durante, son_finales)
	global VapOn
	VapOn=1
	LanzaVaporesAcido()
	
	
def EnterTunnelMusic(sector, entity):
	if entity != "Player1":
		return
	if Currentmusic == "Tunnel":
		return
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.8,ChangeMusic,("Tunnel",))
	
	
def ExitTunnelMusic(sector, entity):
	if entity != "Player1":
		return
	if Currentmusic == "Atmos29":
		return
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.8, ChangeMusic,("Atmos29",))
	
	
def UpperForge():
	GameText.WriteTextAux(GetText("The Sulphur Pits..."), 5.0, 185,140,20, [],300)




def SulphurPit(sector, entity):
	if entity != "Player1":
		return
	SetWay1()
	sectpillar1.OnEnter=""
		
		
def StartRecedeSulphur(sector, entity):
	if entity != "Player1":
		return
	print "Sulphur Recede"
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.8,SulphurRecede,())
	sectpillar1.OnEnter=None



SulphurHi=25000
SulphurLevel=25000
SulphurLo=29400
SulphurUp=1

def matame(finado):
	finado.Life = 0
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.0,SulphurSectorsEnable,())
	
	
	
def SulphurSplash(x,y,z):
	ps=Bladex.CreateEntity("SplashSulphur", "Entity Particle System D1", x,y,z)
	ps.ParticleType="GasVenenoso5"
	ps.YGravity=-600.0
	ps.Friction=0.05
	ps.PPS=30
	ps.Velocity=0.0, -3000.0, 0.0
	ps.RandomVelocity=20.0
	ps.Time2Live=60
	ps.DeathTime=Bladex.GetTime()+3
	SndSplash.Position = x, y, z
	SndSplash.PlaySound(0)
	SndGlubGlub.Position = x, y, z
	SndGlubGlub.PlaySound(0)
	
	
	
def SulphurDeath(sector,entity):
	finado = Bladex.GetEntity(entity)
	if finado.Person:
		SulphurSplash(finado.Position[0],SulphurLevel-1,finado.Position[2])
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, matame,(finado,))
		
		if(entity=="Player1"):
			cam.SType = 0
			cam.TType = 0
			SulphurSectorsDisable()



def SulphurTimer(Entity,Timer):
	global SulphurLevel	
	if SulphurLevel<SulphurLo:
		SulphurLevel = SulphurLevel + 10
		sulphur.Position = -30000, SulphurLevel, -46000
	else:
		sulphur.TimerFunc = ""
		sulphur.RemoveFromList("Timer30")	

def SulphurRecede():
	sulphur.SubscribeToList("Timer30")
	sulphur.TimerFunc = SulphurTimer
	global SulphurUp
	SulphurUp=0
	SulphurSectorsEnable()


def SulphurSectorsEnable():
	if SulphurUp:
		sectsulphur1.OnEnter=SulphurDeath
		sectsulphur2.OnEnter=SulphurDeath
		sectsulphur3.OnEnter=SulphurDeath
		sectsulphur4.OnEnter=SulphurDeath
		sectsulphur5.OnEnter=SulphurDeath
		sectsulphur6.OnEnter=SulphurDeath
		sectsulphur7.OnEnter=SulphurDeath
		sectsulphur8.OnEnter=SulphurDeath
		sectsulphur9.OnEnter=SulphurDeath
		sectsulphur10.OnEnter=SulphurDeath
		sectsulphur11.OnEnter=SulphurDeath
		sectsulphur12.OnEnter=SulphurDeath
		sectsulphur13.OnEnter=SulphurDeath
		sectsulphur14.OnEnter=SulphurDeath
		sectsulphur15.OnEnter=SulphurDeath
		sectsulphur16.OnEnter=SulphurDeath
		sectsulphur17.OnEnter=SulphurDeath
		sectsulphur18.OnEnter=SulphurDeath
		sectsulphur19.OnEnter=SulphurDeath
		sectsulphur20.OnEnter=SulphurDeath
		sectsulphur21.OnEnter=SulphurDeath
		sectsulphur22.OnEnter=SulphurDeath
	else:
		sectsulphurLower1.OnEnter=SulphurDeath
		sectsulphur1.OnEnter=""
		sectsulphur2.OnEnter=""
		sectsulphur3.OnEnter=""
		sectsulphur4.OnEnter=""
		sectsulphur5.OnEnter=""
		sectsulphur6.OnEnter=""
		sectsulphur7.OnEnter=""
		sectsulphur8.OnEnter=""
		sectsulphur9.OnEnter=""
		sectsulphur10.OnEnter=""
		sectsulphur11.OnEnter=""
		sectsulphur12.OnEnter=""
		sectsulphur13.OnEnter=""
		sectsulphur14.OnEnter=""
		sectsulphur15.OnEnter=""
		sectsulphur16.OnEnter=""
		sectsulphur17.OnEnter=""
		sectsulphur18.OnEnter=""
		sectsulphur19.OnEnter=""
		sectsulphur20.OnEnter=""
		sectsulphur21.OnEnter=""
		sectsulphur22.OnEnter=""
		print "Lowering Sulphur Triggs"
		
		
def SulphurSectorsDisable():
	if SulphurUp:
		sectsulphur1.OnEnter=""
		sectsulphur2.OnEnter=""
		sectsulphur3.OnEnter=""
		sectsulphur4.OnEnter=""
		sectsulphur5.OnEnter=""
		sectsulphur6.OnEnter=""
		sectsulphur7.OnEnter=""
		sectsulphur8.OnEnter=""
		sectsulphur9.OnEnter=""
		sectsulphur10.OnEnter=""
		sectsulphur11.OnEnter=""
		sectsulphur12.OnEnter=""
		sectsulphur13.OnEnter=""
		sectsulphur14.OnEnter=""
		sectsulphur15.OnEnter=""
		sectsulphur16.OnEnter=""
		sectsulphur17.OnEnter=""
		sectsulphur18.OnEnter=""
		sectsulphur19.OnEnter=""
		sectsulphur20.OnEnter=""
		sectsulphur21.OnEnter=""
		sectsulphur22.OnEnter=""
	else:
		sectsulphurLower1.OnEnter=""
		
	
	
	
VapPos=[(-24000, 28000, -44000),
	(-21000, 28000, -42000),
	(-20000, 28000, -41000),
	(-17000, 28000, -40000),
	(-17000, 28000, -38000),
	(-16000, 28000, -35000),
	(-19000, 28000, -33000),
	(-22000, 28000, -36000),
	(-24000, 28000, -36500),
	(-13000, 28000, -42000),
	(-9500, 28000, -45500),
	(-26000, 28000, -44000),
	(-27250, 28000, -42000),
	(-24000, 28000, -33000),
	(-16000, 28000, -37000),
	(-31000, 28000, -36000)]	
	
	
	
VapOn=0
	
def VaporesAcido(ps):
	variation=whrandom.uniform(2.0, 5.0)
	new_pos=VapPos[whrandom.randint(0,len(VapPos)-1)]
	ps.Position=new_pos[0], SulphurLevel, new_pos[2]
	Bladex.AddScheduledFunc(Bladex.GetTime()+variation, VaporesAcido, (ps,))




def LanzaVaporesAcido():
	if not VapOn:
		return
	vel=whrandom.uniform(-500.0, -4000.0)
	ps=Bladex.CreateEntity("VaporesLagoAcido", "Entity Particle System D1", 0, 0, 0)
	ps.ParticleType="GasVenenoso5"
	ps.YGravity=-600.0
	ps.Friction=0.05
	ps.PPS=20
	ps.Velocity=0.0, vel, 0.0
	ps.RandomVelocity=30.0
	ps.Time2Live=60
	VaporesAcido(ps)

	
	
def ActVapors():
	global VapOn
	VapOn=1	
	VaporesAcido()

############## Find Knightshade 


def SwordMovie(sector, entity):
	if entity != "Player1":
		return
	sectpillar1.OnEnter=StartRecedeSulphur
	print "Sword Movie"
	Bladex.DeactivateInput() 
	Scorer.SetVisible(0)
	Bladex.KillMusic()
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, Bladex.ExeMusicEvent, (Bladex.GetMusicEvent("Gargolye"),))
	Bladex.AddScheduledFunc(Bladex.GetTime()+22.5, ChangeMusic,("Combat3",))
	GargolyeCam1()
	sectdk.OnEnter=""
	CheckVenom()
	
	
def LightGargolyeEyes():
	lx,ly,lz = garg1.GraspPos("Leye")
	rx,ry,rz = garg1.GraspPos("Reye")
	leyelite=Bladex.CreateEntity("LeftEyeLight","Entity Spot",lx,ly+200,lz)
	reyelite=Bladex.CreateEntity("RightEyeLight","Entity Spot",rx,ry+200,rz)
	leyelite.Color=reyelite.Color=50,250,50
	leyelite.Intensity=reyelite.Intensity=0.1
	leyelite.Precission=reyelite.Precission=0.7
	leyelite.CastShadows=reyelite.CastShadows=0
	leyelite.Visible=reyelite.Visible=1
	leyelite.Flick=reyelite.Flick=0
	AuxFuncs.SpotIntensityVariation("LeftEyeLight",0.1,2.0,5.0)
	AuxFuncs.SpotIntensityVariation("RightEyeLight",0.1,2.0,5.0)
	
	
	
def GargolyeCam1():
	Time=4.0
	cpos= cam.Position
	tpos= cam.TPos
	cpos2= -71402,25932,-51166
	tpos2=  Bladex.GetEntity("Garg1").Position
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], Time, StartGargolye)
	

def StartGargolye():
	LightGargolyeEyes()
	SetWayTemp(-120000,26000,-26000)
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,CreateSpirit1,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,GargolyeCam2,())
	
	
def GargolyeCam2():
	Actions.TurnToFaceEntity("Player1",garg1.Name)
	Time=5.0
	cpos= cam.Position
	tpos= cam.TPos
	cpos2= -91604,23000,-54625
	tpos2= -80227,23210,-41174
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], Time,GargCamEnd)
	RaiseKSGate()
	
	

def CreateSpirit1():
	lx,ly,lz = garg1.GraspPos("Lhand")
	rx,ry,rz = garg1.GraspPos("Rhand")
	sx,sy,sz = garg1.GraspPos("Launch")
	gboltL.Position=lx,ly,lz
	gboltR.Position=rx,ry,rz
	gboltL.Target=gboltR.Target=sx,sy,sz
	gboltL.Active=gboltR.Active=1
	impl=Bladex.CreateEntity("ImplosionFX", "Entity Particle System D1", sx,sy,sz)
	impl.ParticleType="EnergiaGreen"
	impl.YGravity=0.0
	impl.Friction=0.0
	impl.PPS=300
	impl.Velocity=0.0, 0.0, 0.0
	impl.RandomVelocity=-30.0
	impl.Time2Live=70
	impl.DeathTime=Bladex.GetTime()+2.5
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.5,CreateSpirit2,(sx,sy,sz,))
	
	
def GargCamEnd():
	Bladex.AddScheduledFunc(Bladex.GetTime()+7.8,Restore,())
	
	

def CreateSpirit2(sx,sy,sz):
	spirit1.Position=sx,sy,sz
	estela.Position=sx,sy,sz
	AuxFuncs.SpotIntensityVariation(spirit1.Name,0.1,3.0,3.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, MoveSpirit1,())
	
	
def MoveSpirit1():
	init_pos= spirit1.Position
	end_pos= -80227,23210,-41174  
	Objects.DisplaceObjectFromTo(spirit1din, init_pos, end_pos, 1200.0, 600.0, "", "", "", MoveSpiritTrack, (), Spirit1End)
	
	
	
def MoveSpiritTrack():
	estela.Position=spirit1.Position
	gboltL.Target=gboltR.Target=spirit1.Position
	
	
def Spirit1End():
	gboltL.Active=gboltR.Active=0
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,LanzaLenguaEspiritu,("KSSkel1",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.2,LanzaLenguaEspiritu,("KSSkel2",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.8,LanzaLenguaEspiritu,("KSSkel3",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.0,RemoveSpirit,())
	

	
def RemoveSpirit():
	estela.DeathTime=Bladex.GetTime()+0.5
	AuxFuncs.SpotIntensityVariation(spirit1.Name,3.0,0.1,2.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.1,RemoveSpirit2,())
	
	
	
def RemoveSpirit2():
	spirit1.RemoveFromWorld()

	
def LanzaLenguaEspiritu(EntityName):
	skelly=Bladex.GetEntity(EntityName)
	x,y,z= -80227,23210,-41174  
	lengua=Bladex.CreateEntity("Lengua_"+EntityName, "Entity Particle System D1", 0.0, 0.0, 0.0)
	lengua.ParticleType="Volutilla"
	lengua.YGravity=500.0
	lengua.Friction=0.2
	lengua.PPS=512
	lengua.Velocity=0.0, 0.0, 0.0
	lengua.RandomVelocity=30.0
	lengua.Time2Live=32
	lenguadin=Objects.CreateDinamicObject(lengua.Name)
	Objects.DisplaceObjectFromTo(lenguadin, spirit1.Position, skelly.Position, 6000.0, 6000.0, "", "", "", "", (), ImpactoLengua, (EntityName,))
	sndwhoosh1.Play(x,y,z,0)
	
	
def ImpactoLengua(EntityName):
	x, y, z = Bladex.GetEntity(EntityName).Position
	lengua=Bladex.GetEntity("Lengua_"+EntityName)
	lengua.DeathTime=Bladex.GetTime()+0.5
	hite=30700
	ps=Bladex.CreateEntity("Vapores"+EntityName, "Entity Particle System D1", x, hite,z)
	ps.ParticleType="GasVenenoso4"
	ps.YGravity=-600.0
	ps.Friction=0.05
	ps.PPS=30
	ps.Velocity=0.0, -1600.0, 0.0
	ps.RandomVelocity=20.0
	ps.Time2Live=60
	ps.DeathTime=Bladex.GetTime()+2.5
	SpawnSkel(EntityName)
	
	
def SlimeySkelAura(SKEL):
	aura = Auras.MakeAura(SKEL,-1,(5,1.0,1.0,1,0,0), (),(),(2,  0.4,0.8,0.4, 1.0, 0.6  , 0,250,150, 0.0, 1.0))
	
	
	
def SpawnSkel(entity):
	skl=Bladex.GetEntity(entity)
	SlimeySkelAura(entity)
	darfuncs.UnhideBadGuy(entity)
	skl.SetTmpAnmFlags(1,1,1,0,5,1,0)
	skl.LaunchAnimation("Skl_appears1")
	alfa=B3DLib.GetEntity2EntityAngle(skl.Name, "Player1")
	skl.Angle=alfa
	skl.ActionAreaMin=pow( 2,26 ) 
	skl.ActionAreaMax=pow( 2,27 ) 
	darfuncs.CreateFalseCube(skl.Position,-1.0,skl.Name)
	anmtime=Bladex.GetAnimationDuration("Skl_appears1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+anmtime,Despierta,(entity,))
	
	
def Despierta(SkelName):
	o = Bladex.GetEntity(SkelName + "quad")
	if o:
		o.SubscribeToList("Pin")
	skl=Bladex.GetEntity(SkelName)
	skl.SetOnFloor()
	skl.GoTo(char.Position[0],char.Position[1],char.Position[2])
	
	
	
# Skel attack
	
SkelNum=4
SkelsLeft=9


SkelWeps=["HookSword","Garrote","Hacha5","Maza2","Maza","Martillo"]

SkelSpawnPos = [(-78879,31068,-44899),
		(-77322,30968,-43991),
		(-75862,31109,-41728),
		(-74395,31112,-39418),
		(-74303,30718,-42161),
		(-75711,30478,-44491),
		(-77212,30286,-46876),
		(-80004,31110,-44461),
		(-79174,31108,-41835),
		(-78114,31110,-38913)]
	
	
def SlimeSkelDead(entity):
	global SkelNum
	global SkelsLeft
	SkelsLeft=SkelsLeft-1
	if SkelsLeft==0:
		DropKSGate()
		StartKnighshadeScene(entity)
		ResetWayPoint()
		Bladex.ExeMusicEvent(-1)
		print "Skels complete" 
	
	if SkelNum >9:
		return
	WEAPON="Maza2"
	WEAPON=SkelWeps[whrandom.randint(0, len(SkelWeps)-1)]
	
	LEVEL= SkelNum+4
	nuskel=Bladex.CreateEntity("KSSkel"+`SkelNum`,"Skeleton",0,0,0, "Person")
	nuskel.Level=LEVEL
	nuskel.Data=EnemyNPCTypes.SlimeySkeleton(nuskel)
	nuskel.Data.Resistances= copy.copy(CharStats.GetCharResistances("DarkSkel"))
	o=Bladex.CreateEntity(nuskel.Name+"WP",WEAPON,0,0,0,"Weapon") 
	ItemTypes.ItemDefaultFuncs (o)
	Reference.EntitiesObjectData[o.Name]= Reference.DefaultObjectData["Espadaelfica"]
	Reference.EntitiesSelectionData[o.Name]=()
	Actions.TakeObject(nuskel.Name,o.Name)
	o=Bladex.CreateEntity(nuskel.Name+"SH","Escudo1",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	Reference.EntitiesSelectionData[o.Name]=()
	Actions.TakeObject(nuskel.Name,o.Name)
	darfuncs.HideBadGuy(nuskel.Name)
	SkelNum=SkelNum+1
	nuskel.Data.DeathFunc=SlimeSkelDead
	
	Bladex.AddScheduledFunc(Bladex.GetTime()+10.0,CheckToSpawn,(nuskel.Name,))
	
	
	
def ValidAppear(pos):
	entid = Bladex.GetEntitiesAt(pos[0],pos[1],pos[2],800)
	for on in entid:
		o = Bladex.GetEntity(on)
		if o.Person:
			if o.Life > 0:
				if o.Alpha >0.01:
					return 0
	return 1			
	
	
def CheckToSpawn(entity):
	en=Bladex.GetEntity(entity)
	Offset = 1700
	pos=SkelSpawnPos[whrandom.randint(0, len(SkelSpawnPos)-1)]
	en.Position=pos[0], pos[1]+Offset, pos[2]
	en.Angle=B3DLib.GetEntity2EntityAngle(en.Name, "Player1")
	if ValidAppear(pos):
		SpawnSkel(entity)
		print entity+": clear"
	else:
		Bladex.AddScheduledFunc(Bladex.GetTime()+10.0,CheckToSpawn,(entity,))
		print entity+": Trying but some git in the way"
	
	
def StartKnighshadeScene(entity):
	x,y,z=Bladex.GetEntity(entity).Position
	lvl=char.Level
	nulvl=lvl+1
	char.Data.FastrackLevelup("Player1",nulvl)
	DeathAppears(entity,0)
	time=4.0
	Bladex.KillMusic()
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,ChangeMusic,("SwordAppear",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,SetKSsecne,(entity,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+time, ReleaseSpirit,(entity,))
	
	

def Restore():
	AuxFuncs.ResetScene()	
	Scorer.SetVisible(1)
	

def SetKSsecne(entity):
	Bladex.DeactivateInput()
	Scorer.SetVisible(0)
	Actions.TurnToFaceEntity("Player1",entity)
	
	
def PlayerTurnToWatch():
	Actions.TurnToFaceEntity("Player1","Garg1")
	
	
def ReleaseSpirit(entity):
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.4, Actions.TurnToFaceEntity,("Player1","SpiritGuide",))
	lskel=Bladex.GetEntity(entity)
	x,y,z=lskel.Position
	sg.Position=x,y-1000,z
	
	spirit2.Position=estela2.Position= x,y+1200,z
	AuxFuncs.SpotIntensityVariation("Spirit2",0.1,7.0,2.0)
	charpos= char.Position
	cpos=cam.Position
	tpos=cam.TPos
	cpos2= charpos[0],charpos[1]-1600,charpos[2]
	tpos2=x,y-1000,z
	Time=3.0
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], Time)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,SpiritRaise,())
	cpos2
	
	
	
def SpiritRaise():
	init_pos=spirit2.Position
	end_pos=sg.Position
	Objects.DisplaceObjectFromTo(spirit2din, init_pos, end_pos, 800.0, 200.0, "", "", "", MoveSpiritTrack2, (), ReturnSpirit1)
	
	
	
def ReturnSpirit1():
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.6,PlayerTurnToWatch,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,ReturnSpirit1a,())
	cpos=cam.Position
	tpos=cam.TPos
	cpos2= -72071,27725,-49838
	tpos2=garg1.Position
	Time=14.0
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], Time)
	Bladex.AddScheduledFunc(Bladex.GetTime()+Time+4.0,CamBackToPlayer,())
	
	
def CamBackToPlayer():
	cpos=cam.Position
	tpos=cam.TPos
	cpos2= -68071,28725,-49838
	tpos2= -72071,28725,-49838
	Time=9.0
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], Time)
	Bladex.AddScheduledFunc(Bladex.GetTime()+Time+4.0,Restore,())
	
	
def ReturnSpirit1a():
	init_pos=spirit2.Position
	end_pos=-78403,22231,-42941   
	Objects.DisplaceObjectFromTo(spirit2din, init_pos, end_pos, 2600.0, 300.0, "", "", "", MoveSpiritTrack3, (), ReturnSpirit2)
	


	
	
def ReturnSpirit2():
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,StrikeGargolye,())
	char.Position= -72364,29111,-52619
	char.Angle=0.4
	char.SetOnFloor()
	
	
def MoveSpiritTrack2():
	estela2.Position=spirit2.Position
	
	
def MoveSpiritTrack3():
	sg.Position=estela2.Position=spirit2.Position
	
	
def StrikeGargolye():
	gboltL.Position=gboltR.Position=sg.Position
	gboltL.Target=gboltR.Target=-83003,22431,-37341
	gboltL.Active=gboltR.Active=1
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,StrikeGargolye2,())
	sndblom1.Play(-83003,22431,-40341,0)

def StrikeGargolye2():
	lx,ly,lz = garg1.GraspPos("Lhand")
	rx,ry,rz = garg1.GraspPos("Rhand")
	gboltL2.Position=gboltR2.Position=-83003,22431,-37341
	gboltL2.Target=lx,ly,lz
	gboltR2.Target=rx,ry,rz
	gboltL2.Active=gboltR2.Active=1
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,Spirit2End,())
	sndlec1.Play(-83003,22431,-40341,0)
	
	
	
def DestroySpirit2():
	spirit2.RemoveFromWorld()
	estela2.DeathTime=Bladex.GetTime()+0.5
	gboltR2.Active=0
	gboltL2.Active=0
	gboltR.Active=0
	gboltL.Active=0
	
	
def Spirit2End():
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,StartKnightshadeApp,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,DestroySpirit2,())
	



##### Knightshade appear
	
	
def WeaponPS():
	ksps=Bladex.CreateEntity("KnightshadePS", "Entity Particle System Dobj", 0.0, 0.0, 0.0)
	ksps.ObjectName="Knightshade"
	ksps.FollowFactor=1.0
	ksps.ParticleType="KnightshadeParticle"
	ksps.PPS=140
	ksps.YGravity=0.0
	ksps.Friction=0.0
	ksps.Velocity=0.0, 0.0, 0.0
	ksps.RandomVelocity=1.0
	ksps.NormalVelocity=0.0
	ksps.Time2Live=60
	
	
def KillWeaponPS():
	ksps=Bladex.GetEntity("KnightshadePS")
	ksps.DeathTime=Bladex.GetTime()+3.0
	AuxFuncs.SpotIntensityVariation("LeftEyeLight",2.0,0.1,4.0,1)
	AuxFuncs.SpotIntensityVariation("RightEyeLight",2.0,0.1,4.0,1)
	Reference.EntitiesSelectionData["Knightshade"]=(8.0,4000.0, "Knightshade")
	
	
def StartKnightshadeApp():
	PlayerTypes.UpdateKnighshade()
	lx,ly,lz = Bladex.GetEntity("Garg1").GraspPos("Launch")
	dk=Bladex.GetEntity("Knightshade")
	Reference.EntitiesSelectionData["Knightshade"]=()
	AuxFuncs.FadeObject("Knightshade",0.1, 1.0, 3.0)
	
	ksball=Bladex.CreateEntity("KSBall","BolaRayos",lx,ly,lz)
	ksball.Alpha=0.2
	ksball.RasterMode  ="AdditiveAlpha"
	ksball.RasterMode  ="Read"
	ksball.CastShadows = 0
	ksball.SelfIlum    = 0.5
	
	ksballin=Bladex.CreateEntity("KSBallInner","BolaRayos",lx,ly,lz)
	ksballin.Alpha=0.0
	ksballin.CastShadows = 0
	ksballin.Scale=0.6
	
	dk.Alpha=0.0
	dk.Alpha=0.0
	dk.Position=ksball.Position
	
	fireball=Bladex.CreateEntity("InnerBall_Fire","Entity Particle System Dobj",0,0,0)
	fireball.ObjectName=ksballin.Name
	fireball.ParticleType="DeepGreenMagicMissile"
	fireball.PPS=400
	fireball.YGravity=0.0
	fireball.Friction=0.04
	fireball.RandomVelocity=-16.0
	fireball.FollowFactor=0.4
	fireball.Time2Live=30
		
	concsound=Bladex.CreateEntity(ksball.Name+"ConcSound", "Entity Sound", 0, 0, 0)
	concsound.SetSound("..\\..\\Sounds\\energy-ball-conc.wav")
	concsound.MinDistance=5000
	concsound.MaxDistance=30000
	ksball.Link(concsound)
	concsound.PlaySound(0)
	
	wepstpos=-82325,25198,-38616
	wepfinos=-72166,28382,-49811
	ksballdin=Objects.CreateDinamicObject("KSBall")
	Objects.DisplaceObjectFromTo(ksballdin, wepstpos, wepfinos, 2500.0, 200.0, "", "", "", WPTrack, (),DestroyBall )
	
	
	
def WPTrack():
	dk=Bladex.GetEntity("Knightshade")
	ksball=Bladex.GetEntity("KSBall")
	ksballin=Bladex.GetEntity("KSBallInner")
	dk.Position=ksball.Position
	ksballin.Position=ksball.Position
	
	
def DestroyBall():
	ksball=Bladex.GetEntity("KSBall")
	x, y, z= ksball.Position
	ksball.SelfIlum=1.0
	impactlight=Bladex.CreateEntity(ksball.Name+"ImpactLight", "Entity Spot", x, y-800.0, z)
	impactlight.Color=180, 255, 160
	impactlight.Intensity=10.0
	impactlight.Precission=0.1
	impactlight.CastShadows=0
	impactlight.Flick=0
	impactlight.Visible=0
	AuxFuncs.SpotIntensityVariation(impactlight.Name, 10.0, 0.0, 1.8, 1)
	impactps=Bladex.CreateEntity(ksball.Name+"ImpactPS", "Entity Particle System Dobj", 0, 0, 0)
	impactps.ObjectName=ksball.Name
	impactps.ParticleType="DeepGreenMagicMissile"
	impactps.PPS=1000
	impactps.YGravity=0.0
	impactps.Friction=0.0
	impactps.RandomVelocity=5.0
	impactps.Time2Live=30
	impactps.DeathTime=Bladex.GetTime()+1.2
	ksball.TimerFunc=BallExpansion
	ksball.SubscribeToList("Timer60")
	WeaponPS()
	AuxFuncs.FadeObject("KSBall", 0.3, 0.0, 1.0)
	fireball=Bladex.GetEntity("InnerBall_Fire")
	fireball.DeathTime=Bladex.GetTime()
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,KillWeaponPS,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,KSFin,())
	
	
def BallExpansion(ent,time):
	ksball=Bladex.GetEntity("KSBall")
	if ksball.Scale>2.0:
		ksball.TimerFunc=""
		ksball.RemoveFromList("Timer60")
		ksball.SubscribeToList("Pin")
	else:
		ksball.Scale=ksball.Scale+0.02
		ksball.Alpha=ksball.Alpha-0.005
	

def KSFin():
	Scorer.SetVisible(1)
	Bladex.ActivateInput()
	KillWeaponPS()
	char.Data.HasKnightshade = 1
	Scorer.SlideTBS(0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+10.0, ChangeMusic,("Atmos1",))


def RaiseKSGate():
	desplazamientos=(2200.0, 500.0)
	vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
	vel_iniciales=(0.0, 1200)
	vel_finales=(800.0, 800)
	Objects.NDisplaceObject(ksgatedin, desplazamientos, vectores, vel_iniciales, vel_finales)	


def DropKSGate():
	desplazamientos=(2200.0, 500.0)
	vectores=((0.0, 1.0, 0.0), (0.0, 1.0, 0.0))
	vel_iniciales=(0.0, 1200)
	vel_finales=(800.0, 800)
	Objects.NDisplaceObject(ksgatedin, desplazamientos, vectores, vel_iniciales, vel_finales)	
	darfuncs.UnhideBadGuy("Ork6b")
	darfuncs.UnhideBadGuy("Ork6a")
	darfuncs.UnhideBadGuy("Ork6c")
	darfuncs.UnhideBadGuy("Ork6d")

######### Spooks

def VanishIt(entity):
	per=Bladex.GetEntity(entity)
	per.Alpha=0
	Spectre2()
	
	
def VanishIt2(entity):
	per=Bladex.GetEntity(entity)
	per.Alpha=0


def GrowMe(entity):
	me=Bladex.GetEntity(entity)
	if me.Scale<7.0:
		me.Scale=me.Scale+0.02


def Spectre(sector, entity):
	if entity != "Player1":
		return
	o=Bladex.GetEntity("Spect1")
	p=Bladex.GetEntity("Player1")
	sound=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit3.wav", "SndSpec")
	sound.Volume=1
	sound.MinDistance=1000000.0
	sound.MaxDistance=1000000.0
	sound.Play(o.Position[0], o.Position[1], o.Position[2], 0)
	dinobj2 = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj2, (-68500, 34500, -70000), (p.Position[0], p.Position[1]+3000, p.Position[2]-1000), 2000, 8000, "", "", "", GrowMe, (o.Name,), VanishIt, (o.Name,)) 
	sectspooks.OnEnter=None
	
	
def Spectre2():
	o=Bladex.GetEntity("Spect2")
	q=Bladex.GetEntity("Player1")
	sound=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit5.wav", "SndSpec2")
	sound.Volume=1
	sound.MinDistance=1000000.0
	sound.MaxDistance=1000000.0
	sound.Play(o.Position[0], o.Position[1], o.Position[2], 0)
	dinobj2 = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj2, (-70000, 33000, -70000), (q.Position[0], q.Position[1]+3200, q.Position[2]-2000), 2000, 8000, "", "", "", GrowMe, (o.Name,), VanishIt2, (o.Name,)) 

	
	
#### First Mino Cave
	
def UnhideMin1():
	darfuncs.UnhideBadGuy("Min1")
	darfuncs.UnhideBadGuy("Ork6") # archer
	mindoor1.OpenDoor()
	min1.Blind=1
	
def FirstMinoDead(entity):
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ResumeMusic,()) 
	
	
def CloseMinDoor():
	mindoor1.CloseDoor()
	global VapOn
	VapOn=0
	SetWayTemp(1000,18500,-37500)
	if ork6a.Life>0:
		darfuncs.HideBadGuy("Ork6a")
	if ork6b.Life>0:
		darfuncs.HideBadGuy("Ork6b")
	if ork6c.Life>0:
		darfuncs.HideBadGuy("Ork6c")
	if ork6d.Life>0:
		darfuncs.HideBadGuy("Ork6d")
	min1.Blind=0

#### Indy Slope

def unhideindorks():
	darfuncs.UnhideBadGuy("Ork7")
	darfuncs.UnhideBadGuy("Ork8")
	sectorkslope.OnEnter=unhideorkslope
	sectorks2.OnEnter=UnhideFirstCaveOrks
	sectorks3.OnEnter=unhideoboss
	sectway2.OnEnter=SetWay2
	

def Indiana(sector, entity):
	if entity != "Player1":
		return
	o=Bladex.GetEntity("Boulder")
	o.Impulse(0,0,0)
	indy=Bladex.CreateSound("..\\..\\Sounds\\Stone-floor-collapse.wav", "Startindy")
	indy.Volume=1
	indy.MinDistance=12000
	indy.MaxDistance=60000
	indy.Play(o.Position[0], o.Position[1], o.Position[2], 0)
	unhideindorks()
	SetWayTemp(9024,20675,10715)
	sectindy1.OnEnter=None
	sectindy2.OnEnter=None
	if min1.Life>0:
		min1.Life=0
	if ork6.Life>0:
		ork6.Life=0


def StoneFinished(ent):
	ent = Bladex.GetEntity(ent)
	import SolidMask
	ent.ExclusionMask = ent.ExclusionMask & (~SolidMask.EX_PERSON)
	
	

############# Poison Colonies ##################################################
	
def TombDoor():
	global tomb
	global tomba
	global tombb
	global tombc
	global tombx
	if tomb+tomba+tombb+tombc==4:
		tombx=1
		door3.OpenDoor()
		unhidemazemonster()
		ClearText()
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, GameText.WriteTextAux,("Sequence is Complete, Tomb is open...", 4.0, 255,155,20, [],260,))
		Bladex.ExeMusicEvent(-1)
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("BeforeTomb",))
		
		
	elif tomb+tomba+tombb+tombc==3:		
		ClearText()
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.2, GameText.WriteTextAux,("Just one to go ...", 3.0, 255,155,20, [],260,)) 
	elif tomb+tomba+tombb+tombc==2:		
		ClearText()
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.2, GameText.WriteTextAux,("Still two to find ...", 3.0, 255,155,20, [],260,))
	else:
		ClearText()
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.2, GameText.WriteTextAux,("Three more to go ...", 3.0, 255,155,20, [],260,))
		
		
		
def Abredoor3():
	global tomb
	tomb=1
	TombDoor()
	
def Tomb3a():
	global tomba
	tomba=1
	TombDoor()
	
def Tomb3b():
	global tombb
	tombb=1
	TombDoor()
	
def Tomb3c():
	global tombc
	tombc=1
	TombDoor()
	


def DropStake(entity):
	desplazamientos=(2600.0, 500.0)
	vectores=((0.0, 1.0, 0.0), (0.0, 1.0, 0.0))
	vel_iniciales=(0.0, 1200)
	vel_finales=(800.0, 800)
	Objects.NDisplaceObject(entity, desplazamientos, vectores, vel_iniciales, vel_finales)	


def OpenColonyBarrier():
	DropStake(stake1din)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,DropStake,(stake4din,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.3,DropStake,(stake3din,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,DropStake,(stake2din,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.8,DropStake,(stake5din,))	
	
	
def unhideorkslope(sector, entity):
	if entity != "Player1":
		return
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("Colony",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,GameText.WriteTextAux,("The Poisoned Colonies...", 4.0, 0,150,0, [],300,))
	darfuncs.UnhideBadGuy("Ork9") # Orc with bow on troll bridge
	darfuncs.UnhideBadGuy("GreatOrk3")
	SetWayTemp(9024,20675,10715)
	sectorkslope.OnEnter=""
	
	

def UnhideFirstCaveOrks(sector, entity):
	if entity != "Player1":
		return
	ork10.UnFreeze()
	ork11.UnFreeze()
	gok4.UnFreeze()
	ork10.Blind=0
	ork11.Blind=0
	sectorks2.OnEnter=""
	
	
	
def ActGreatOrk4():
	gok4.Blind=0
	gok4.Deaf=0
	
	
	
def OpenBridgeGate():
	desplazamientos=(2600.0, 600.0)
        vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
        vel_iniciales=(500.0, 2000)
        vel_finales=(2000.0, 500)
        son_durante=(deslizrasanexo, deslizrasanexo)
        son_finales=("", golperasanexo)
        Objects.NDisplaceObject(brgate1din, desplazamientos, vectores, vel_iniciales, vel_finales, (), son_durante, son_finales)
	
	
def UnhideSecondCaveOrks():
	darfuncs.UnhideBadGuy("GreatOrk6")
	darfuncs.UnhideBadGuy("Ork13")
	
	
def unhideoboss(sector, entity):
	if entity != "Player1":
		return
	darfuncs.UnhideBadGuy("GreatOrk5")
	darfuncs.UnhideBadGuy("Ork12")
	darfuncs.UnhideBadGuy("Ork15")
	darfuncs.UnhideBadGuy("Ork16")
	sectorks3.OnEnter=""
	
	
def UnhideLastcaveOrks():
	darfuncs.UnhideBadGuy("GreatOrk7")
	darfuncs.UnhideBadGuy("Ork14")
	
	
def unhidetrls():
	darfuncs.UnhideBadGuy("Troll1")
	darfuncs.UnhideBadGuy("Troll2")
	darfuncs.UnhideBadGuy("Troll3")
	global ColonyEnemies
	ColonyEnemies.append("Troll1")
	ColonyEnemies.append("Troll2")
	ColonyEnemies.append("Troll3")
	
	
def unhidemazemonster():
	darfuncs.UnhideBadGuy("Min2")
	global ColonyEnemies
	ColonyEnemies.append("Min2")
	
	
	
Guardorks=2
	
def ColonyOrkDead(entity):
	global ColonyEnemies
	global Guardorks
	if entity in ColonyEnemies:
		ColonyEnemies.remove(entity)
	if entity in("Ork10","Ork11"):
		Guardorks=Guardorks-1
		if Guardorks==0:
			gok4.Blind=0


def KillOrk(sector, entity):
	per=Bladex.GetEntity(entity)
	if per.Kind in ("Ork","GreatOrk"):
		per.Life=0
	else:
		pass

	
############# Green Golem


def RaiseSpiderDoor():
	desplazamientos=(5600.0, 500.0)
	vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
	vel_iniciales=(0.0, 1200)
	vel_finales=(800.0, 800)
	Objects.NDisplaceObject(spdoordin, desplazamientos, vectores, vel_iniciales, vel_finales)	


def RaiseStake(entity):
	desplazamientos=(2600.0, 500.0)
	vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
	vel_iniciales=(0.0, 2200)
	vel_finales=(2000.0, 2000)
	Objects.NDisplaceObject(entity, desplazamientos, vectores, vel_iniciales, vel_finales)	
	
	
def DropGolemStake(entity):
	desplazamientos=(2600.0, 500.0)
	vectores=((0.0, 1.0, 0.0), (0.0, 1.0, 0.0))
	vel_iniciales=(0.0, 2200)
	vel_finales=(2000.0, 2000)
	Objects.NDisplaceObject(entity, desplazamientos, vectores, vel_iniciales, vel_finales)	


def CloseGolemBarrier():
	RaiseStake(stake6din)
	RaiseStake(stake7din)
	RaiseStake(stake8din)
	RaiseStake(stake9din)
	
def OpenGolemBarrier():
	DropGolemStake(stake6din)
	DropGolemStake(stake7din)
	DropGolemStake(stake8din)
	DropGolemStake(stake9din)
	


def GreenGolemDead(entity):
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.0, ChangeMusic,("Atmos1",)) 
	OpenGolemBarrier()
	ResetWayPoint()
	RaiseSpiderDoor()
	
	
def StartGolemCombat():
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.0,StopMatrixFXX,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,StartGolemCombat2,())
	Bladex.ActivateInput()
	Scorer.SetVisible(1)


def ActGolem():
	grgolem.Data.ActPos=-70000,38823,-11187
	Actions.TurnToFaceEntity("Player1","GreenGolem")
	grgolem.Data.Deploy()
	KillVapour()

def StartGolemCombat2():
	ChangeMusic("Combat4")
	
	
def StartBurnGol(sector,entity):
	if entity != "Player1":
		return
	Bladex.DeactivateInput()
	Scorer.SetVisible(0)
	Bladex.KillMusic()
	CheckVenom() # no droping dead during cutscene
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, GolemAppearMusic,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.8, GolVapourFX,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, ActGolem,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.3, GolemCam,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.6, char.GoTo,(-63209,38901,-18736,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.8, CloseGolemBarrier,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+6.8, StartGolemCombat,())
	SetWayTemp(-51500,36000,-11000)
	BrnGolSec.OnEnter = ""
	
	
	
def GolemAppearMusic():
	Bladex.ExeMusicEvent(Bladex.GetMusicEvent("GolemAppear"))
	
	
	
def GolemCam():
	StartMatrixFXX("GreenGolemTarget")
	
	
def GolVapourFX():
	ps=Bladex.CreateEntity("GolemVapour", "Entity Particle System D1", -70348,39823,-11187)
	ps.ParticleType="GasVenenoso2"
	ps.YGravity=-600.0
	ps.Friction=0.05
	ps.PPS=30
	ps.Velocity=0.0, -2000.0, 0.0
	ps.RandomVelocity=20.0
	ps.Time2Live=60


def KillVapour():
	ps=Bladex.GetEntity("GolemVapour")
	ps.DeathTime=Bladex.GetTime()+3


def CheckMusic1(sector,entity):
	if entity != "Player1":
		return
	if Currentmusic == "Atmos1":
		Bladex.ExeMusicEvent(-1)
		if tombx==1:
			Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("BeforeTomb",)) 
		else:
			Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("Colony",)) 
		sectgol3.OnEnter= CheckMusic2
		
		
def CheckMusic2(sector,entity):
	if entity != "Player1":
		return
	if Currentmusic != "Atmos1":
		Bladex.ExeMusicEvent(-1)
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, ChangeMusic,("Atmos1",)) 



############### Secret Room powup Venom

def unhidespiders():
	for arachnid in range (6):
		darfuncs.UnhideBadGuy("spider" +str(arachnid))
		Venomglow("spider"+str(arachnid),20000)
		
	
########################################## Red Maze


def EnterMaze():
	Bladex.KillMusic()
	Bladex.ExeMusicEvent(Bladex.GetMusicEvent("Creepy"))
	GameText.WriteTextAux(GetText("The Evil Place...\nTomb of the living dead"), 4.0, 160,10,10,[],300)
	door3.CloseDoor()
	


def OpenMazeGate(entity):
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.8,ResumeMusic,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.8, OpenMazeGate2,())


def OpenMazeGate2():
        desplazamientos=(2200.0, 600.0)
        vectores=((0.0, 1.0, 0.0), (0.0, 1.0, 0.0))
        vel_iniciales=(500.0, 2000)
        vel_finales=(2000.0, 500)
        son_durante=(deslizrasanexo, deslizrasanexo)
        son_finales=("", golperasanexo)
        Objects.NDisplaceObject(mzgate1din, desplazamientos, vectores, vel_iniciales, vel_finales, (), son_durante, son_finales)
	per=Bladex.GetEntity("Skeleton1")
	per.UnFreeze()
	#global MazeEnemies
	#MazeEnemies.append("Skeleton1")
	
	
def StartMazeMusic(sector, entity):
	if entity != "Player1":
		return
	per=Bladex.GetEntity("Skeleton1")
	Actions.TurnToFaceEntity("Skeleton1","Player1")
	per.Blind=0
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.8,ChangeMusic,("Combat6",))
	for id in ColonyEnemies:
		per=Bladex.GetEntity(id)
		if per.Life>0:
			per.Freeze()
			per.Life=0
	sectmaz1.OnEnter = None
	
	
	

def unhideskel3():
	darfuncs.UnhideBadGuy("Skeleton3")
	darfuncs.UnhideBadGuy("Skeleton33")
	global MazeEnemies
	MazeEnemies.append("Skeleton3")
	MazeEnemies.append("Skeleton33")
	
	
def unhideskel4():
	global MazeEnemies
	darfuncs.UnhideBadGuy("Skeleton4")
	MazeEnemies.append("Skeleton4")
	
def unhideskel5():
	global MazeEnemies
	darfuncs.UnhideBadGuy("Skeleton5")
	MazeEnemies.append("Skeleton5")
	
def unhideskel6():
	global MazeEnemies
	darfuncs.UnhideBadGuy("Skeleton6")
	darfuncs.UnhideBadGuy("maz1")
	MazeEnemies.append("Skeleton6")
	MazeEnemies.append("maz1")
	
def unhideskel7():
	global MazeEnemies
	darfuncs.UnhideBadGuy("Skeleton7")
	MazeEnemies.append("Skeleton7")
	
def unhideskel8():
	global MazeEnemies
	darfuncs.UnhideBadGuy("Skeleton8")
	MazeEnemies.append("Skeleton8")
	
def unhideskel9():
	global MazeEnemies
	darfuncs.UnhideBadGuy("Skeleton9")
	MazeEnemies.append("Skeleton9")
	
def unhideskel10():
	global MazeEnemies
	darfuncs.UnhideBadGuy("Skeleton10")
	MazeEnemies.append("Skeleton10")
	
	
def unhideskel11():
	global MazeEnemies
	darfuncs.UnhideBadGuy("Skeleton11")
	darfuncs.UnhideBadGuy("Skeleton12")
	darfuncs.UnhideBadGuy("Skeleton13")
	darfuncs.UnhideBadGuy("Skeleton14")
	darfuncs.UnhideBadGuy("Skeleton15")
	MazeEnemies.append("Skeleton11")
	MazeEnemies.append("Skeleton12")
	MazeEnemies.append("Skeleton13")
	MazeEnemies.append("Skeleton14")
	MazeEnemies.append("Skeleton15")
	
	

def unhidemaz23():
	global MazeEnemies
	darfuncs.UnHideBadGuy("maz2")
	darfuncs.UnHideBadGuy("maz3")
	MazeEnemies.append("maz2")
	MazeEnemies.append("maz3")
	
	
def unhidemaz4():
	global MazeEnemies
	darfuncs.UnHideBadGuy("maz4")
	MazeEnemies.append("maz4")
	
	
def StartBurnSkl2(sector,entity):
	if (entity == "Player1"):
		Bladex.ExeMusicEvent(-1)
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.0, Bladex.ExeMusicEvent, (Bladex.GetMusicEvent("Combat1"),))
		BrnSklSec2.OnEnter = ""
		generadorBrnSkl.GenerateEnemy()
	
	
def GenerateBurnSkl(o):
	o.CatchOnFire(0,0,0)
	luz             = Bladex.CreateEntity(o.Name+"Luz","Entity Spot",0,0,0)
	luz.Color       = 181,91,10
	luz.Intensity   = 6
	luz.Precission  = 0.077
	luz.CastShadows = 0
	luz.Visible     = 0
	luz.SizeFactor  = 0
	o.Link(luz)
	MazeEnemies.append(o.Name)
	o.Data.Resistances= copy.copy(CharStats.GetCharResistances("FireSkeleton"))

def ApagaLuz(luz,l):
	luze = Bladex.GetEntity(luz)
	Luz=AuxFuncs.GetSpot(luze)
	Luz.Intensity = 0.0
	Luz.CastShadows = 0
	Fire=AuxFuncs.GetFire(luze)
	Fire.Intensity = 20.0


def finGeneraFuego(a=0,b=0,c=0):
	OnOff.LightSetInens   = 60.0
	OnOff.LightSetRadius  = 0.077
	OnOff.LightSetColor   = (255,70,9)
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.8,ChangeMusic,("ExitMaze",))


def ExitMaze(sector, entity):
	if entity != "Player1":
		return
	Bladex.ExeMusicEvent(-1)
	if Currentmusic != "ExitMaze":
		Bladex.AddScheduledFunc(Bladex.GetTime()+2.8,ChangeMusic,("ExitMaze",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,SerpentsLair,())
	sectmaz2.OnEnter = None
	

def SerpentsLair():
	RewardText=""
	if char.Level < 17:
	    	char.Data.FastrackLevelup("Player1",17)
	    	RewardText="\nLEVEL 18\nThe Gods reward your Efforts"
	    	
	GameText.WriteTextAux(GetText("Secret Entrance to the Chaos Vaults..\n"+str(RewardText)), 7.0, 200,10,10, [],260)
	
	if len(MazeEnemies) == 0:
		return
	print "Maze Enemies are: ",MazeEnemies
	for id in MazeEnemies:
		per=Bladex.GetEntity(id)
		try:
			if per:
				if per.Person:
					if per.Life>0:
						per.Life=0
						print "Killing off ",per.Name
		except:
			print "Exception: "+id+" Does not exist"
		
			
def unhideldms():
	darfuncs.UnhideBadGuy("ldm1")
	darfuncs.UnhideBadGuy("ldm2")


######################## After Maze

Sallies=2


def ActSally():
	darfuncs.UnhideBadGuy("Sally1")
	darfuncs.UnhideBadGuy("Sally2")
	sal1.Data.RedGlow("Sally1")
	sal2.Data.RedGlow("Sally2")
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.8,ChangeMusic,("Combat_Light",))
	


def SallyDead(entity):
	global Sallies
	Sallies=Sallies-1
	if Sallies==0:
		sectsal1.OnEnter = AbreDoor1
		Bladex.ExeMusicEvent(-1)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.8,ChangeMusic,("LavaCave",))

def AbreDoor1(sector, entity):
	if entity != "Player1":
		return
	door1.OpenDoor()
	dk1.UnFreeze()
	dk2.UnFreeze()
	dk1.Blind=1
	dk2.Blind=1
	sectsal1.OnEnter = None
		
		
	
############### Lava Cave


def unhidedks(sector, entity):
	if entity != "Player1":
		return
	dk1.UnFreeze()
	dk2.UnFreeze()
	dk1.Blind=0
	dk2.Blind=0
	Bladex.KillMusic()
	Bladex.AddScheduledFunc(Bladex.GetTime(), Bladex.ExeMusicEvent, (Bladex.GetMusicEvent("Darks"),))
	sectlav1.OnEnter = None
	sectlav2.OnEnter = None
	sectlav3.OnEnter = None
	

def PlayerInPlace():
	dist=B3DLib.GetXZDistance("Player1","MarkerSkull") # in case he overshoots and goes in the lava
	if dist>1000:
		return 0
	return 1
	

def AppearBigGuy1(sector, entity):
	if entity != "Player1":
		return
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, CheckToActCK,())
	
	
def CheckToActCK():
	if PlayerInPlace():
		Bladex.SetTriggerSectorFunc("CKTrigger", "OnEnter", None)
		dk1.Freeze()
		dk2.Freeze()
		dk1.Blind=1
		dk2.Blind=1
		ck1.Blind=1
		ck1.Deaf=1
		char.Data.Invincibility=3
		CheckVenom()
		door8.OpenDoor()
		Bladex.DeactivateInput()
		AppearBigGuy2()
	else:
		pass
	
	

def AppearBigGuy2():
	CKCam()
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.9, ck1.UnFreeze,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, ck1.Data.Appear,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, Actions.TurnToFaceEntity,("Player1","BigGuy",))
	CKMagicallyAppearing()
	
	
def CKCam():
	CheckVenom()
	Bladex.SetListenerPosition(2)
	opos1,opos2,opos3=cam.Position
	tpos1,tpos2,tpos3=cam.TPos
	etpos1,etpos2,etpos3=ck1.Position
	AuxFuncs.MoveCamFromTo(opos1,opos2,opos3,  61250,36000,-57000, etpos1,etpos2,etpos3, etpos1,etpos2,etpos3, 4.0, CKCam2)
	
	
def CKCam2():
	Bladex.AddScheduledFunc(Bladex.GetTime()+10.0,EndCKCam,())
	
	
def EndCKCam():
	ck1.Blind=0
	ck1.Deaf=0
	char.Data.Invincibility=0
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.0, AuxFuncs.ResetScene,())
	dk1.UnFreeze()
	dk2.UnFreeze()
	dk1.Blind=0
	dk2.Blind=0
	
	
	
	
	
def BigGuyDead(entity):
	StartMatrixFXX(ck1.Name,0.7)
	Bladex.AddScheduledFunc(Bladex.GetTime()+9.0, StopMatrixFXX,())
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+8.0, ChangeMusic,("Atmos1",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+9.0,OpenDoor2,())
	for id in CKMinions:
		per=Bladex.GetEntity(id)
		if per.Life>0:
			per.Life=0
		
	
def DKDED(entity):
	global CKMinions
	if entity in CKMinions:
		CKMinions.remove(entity)
	if len(CKMinions)==0:
		print "No More minions"
		return
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.0, NextKnight,())
	
	
def NextKnight():
	if ck1.Life<=0:
		return
	DKNAME=CKMinions[whrandom.randint(0, len(CKMinions)-1)]
	if PlayerNotTooNear(DKNAME):
		DeathAppears(DKNAME)
		darfuncs.UnhideBadGuy(DKNAME)
		try:
			stat=Bladex.GetEntity(DKNAME+"Statue")
			stat.SubscribeToList("Pin")
		except:
			pass
		
	else:
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.0,NextKnight,())


def PlayerNotTooNear(entity):
	dist=B3DLib.GetXZDistance("Player1", entity)
	if dist>2000:
		return 1
	return 0

	
def StartCKMusic():
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, ChangeMusic,("Combat_Hard",))
	ck1.Data.RangeAttack=1
	
	
def ShutCKDoor():
	door8.CloseDoor()
	SetWayTemp(61000, 37200,-74000)
	global WayPointAngle
	WayPointAngle=0
	darfuncs.UnhideBadGuy("DarkKnight3")
	darfuncs.UnhideBadGuy("DarkKnight4")
	print "CK door shut"
	dk1.Freeze()
	dk2.Freeze()
	dk1.Blind=1
	dk2.Blind=1
	
	
	
	
def OpenDoor2():
	door2.OpenDoor()
	door2a.OpenDoor()

	
def Abredoor4():
	door4.OpenDoor()
	door4a.CloseDoor()
	
	
###################### Vamp

def VampDead(entity):
	print "VAMP DED"
	VampVanish(entity)
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.0,door5.OpenDoor,())
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+9.0, ChangeMusic,("Atmos5",))
	Bladex.SetSun(1,-20,6,8)
	Raster.SetDomeColor(150,100,80)
	global skystate
	skystate=2
	
	
def VampVanish(entity):
	vamp=Bladex.GetEntity(entity)
	x,y,z=vamp.Position
	sndvampdead.Play(x,y,z,0)
	rwp=Bladex.GetEntity(vamp.InvRight)
	lwp=Bladex.GetEntity(vamp.InvLeft)
	DeathAppears(entity,0,8.5)
	AuxFuncs.FadeObject(entity,0.5,0.0,6.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+7.1,RemoveMe,(vamp,))
	if rwp:
		AuxFuncs.FadeObject(vamp.InvRight,0.5,0.0,6.0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.1,RemoveMe,(rwp,))
	if lwp:
		AuxFuncs.FadeObject(vamp.InvLeft,0.5,0.0,6.0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.1,RemoveMe,(lwp,))
		
		
	
def RemoveMe(thing):
	thing.Position=0,0,50000

def unhidevamp():
	Bladex.DeactivateInput()
	Scorer.SetVisible(0)
	Bladex.KillMusic()
	CheckVenom()
	VampVapourFX()
	Bladex.AddScheduledFunc(Bladex.GetTime(), Bladex.ExeMusicEvent, (Bladex.GetMusicEvent("VampAppear"),))
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.4, ActVamp,())
	
	
def ActVamp():
	VampCam()
	vamp.UnFreeze()
	vamp.Position=99500, 39400, -60250
	vamp.SetTmpAnmFlags(1,1,1,0,5,1)
   	vamp.Wuea = Reference.WUEA_ENDED
   	vamp.LaunchAnmType("tumba_rey_aguila")
   	vamp.AnmEndedFunc= VampAttack
   	VampAurasOn()
   	Actions.TurnToFaceEntity("Player1","Vamp1")
   	Bladex.AddScheduledFunc(Bladex.GetTime()+14.0,PlayerGetSet,())
   	
   	
def PlayerGetSet():
	if not (char.InvRight):
		Actions.StdToggleWeapons("Player1")



def VampAttack(entity):
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,Bladex.ExeMusicEvent,(-1,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.0, ChangeMusic,("Combat4",))
	Actions.TurnToFaceEntity(vamp.Name, "Player1")
	vamp.Blind=0
	Bladex.ActivateInput()
	Scorer.SetVisible(1)
	KillVampVapour()
	
	
	
def VampAurasOn():
	vaura = Auras.MakeAura("Vamp1",-1,(5,1.0,1.0,1,0,0), (),(),(2,  0.4,0.8,0.4, 1.0, 0.6  , 0,250,150, 0.0, 1.0))
	vswaura = Auras.MakeAura("Vamp1WP",-1,(25,1.0,1.0,1,0,0), (),(),(2,  0.8,0.8,1.0, 1.0, 0.6  , 0,250,50, 0.0, 1.0))
	vshaura = Auras.MakeAura("Vamp1SH",-1,(25,1.0,1.0,1,0,0), (),(),(2,  0.8,0.8,1.0, 1.0, 0.6  , 0,150,50, 0.0, 1.0))


def VampCam():
	AbreCam.ResetNode()
	h=char.Position[1]
	char.Position=91500,h,-61000
	tx,ty,tz= vamp.Position	
	AbreCam.AddNode ((105000,38500,-63750),(tx,ty,tz), 0)
	AbreCam.AddNode ((105000,38500,-63750),(tx-500,ty,tz),3)
	AbreCam.AddNode ((106200,38000,-61250),(tx-1000,ty,tz),3)
	AbreCam.AddNode ((104000,38000,-55250),(tx-2000,ty,tz),6)
	AbreCam.AddNode ((100000,38000,-55250),(93000,ty,tz),6)
	AbreCam.LastTime=0
	AbreCam.AbreCam()



def VampVapourFX():
	ps=Bladex.CreateEntity("VampSmoke", "Entity Particle System D1", 99500, 39000, -60250)
	ps.ParticleType="GasVenenoso3"
	ps.YGravity=-600.0
	ps.Friction=0.05
	ps.PPS=30
	ps.Velocity=0.0, -2000.0, 0.0
	ps.RandomVelocity=20.0
	ps.Time2Live=60
	

def KillVampVapour():
	ps=Bladex.GetEntity("VampSmoke")
	ps.DeathTime=Bladex.GetTime()+3
	
	
def VampKill():
	vamp.Life = CharStats.GetCharMaxLife(vamp.Kind, vamp.Level)





################ Planets and Magic Path rooms


	
def Abredoor16():
	door16.OpenDoor()
	OpenPlanetsExit()


def Abredoor6():
	door6.OpenDoor()

	
###############################################################################################################################################################################################
##################### Magpath.py #######################


def OpenMagicPathExit():
        desplazamientos=(2200.0, 600.0)
        vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
        vel_iniciales=(500.0, 2000)
        vel_finales=(2000.0, 500)
        son_durante=(deslizrasanexo, deslizrasanexo)
        son_finales=("", golperasanexo)
        Objects.NDisplaceObject(mpgatedin, desplazamientos, vectores, vel_iniciales, vel_finales, (), son_durante, son_finales)


def FadeUp(B,A):
	Blok=Bladex.GetEntity("StepStone"+str(B-1))
	Blok.Alpha=Blok.Alpha+A
	
	

def FadeIn(B,A):
	tm=Bladex.GetTime()
	Bladex.AddScheduledFunc(tm+0.0, FadeUp, (B,A),"FadeUp"+str(B)+str(tm))
	Bladex.AddScheduledFunc(tm+0.1, FadeUp, (B,A),"FadeUp1"+str(B)+str(tm))
	Bladex.AddScheduledFunc(tm+0.2, FadeUp, (B,A),"FadeUp2"+str(B)+str(tm))
	Bladex.AddScheduledFunc(tm+0.3, FadeUp, (B,A),"FadeUp3"+str(B)+str(tm))
	Bladex.AddScheduledFunc(tm+0.4, FadeUp, (B,A),"FadeUp4"+str(B)+str(tm))



def FadeOut(B):
	for x in range(1,14,1):
 	  for y in range(0,9,1):
	     global MagPaths
	     pos=str(x)+str(y+1)	
 	     for i in range(63):
	        if str(MagPaths[i])==str(pos): 
			Bladex.GetEntity("StepStone"+str(x)+str(y)).Alpha=0 	



def MagicPath(BQ):
   global OnBlock
   if BQ!=OnBlock:
	OnBlock=BQ
	FadeOut(BQ)
	FadeIn(BQ,0.199)
	global MagPaths
	for i in range(63):
		if str(MagPaths[i])==str(BQ-10): 
			FadeIn(BQ-10,0.1)
		if str(MagPaths[i])==str(BQ+10): 
			FadeIn(BQ+10,0.1)
		if str(MagPaths[i])==str(BQ-1): 
			FadeIn(BQ-1,0.1)
		if str(MagPaths[i])==str(BQ+1): 
			FadeIn(BQ+1,0.1)


######## After many painful hours of reloading BOD, .... ###################
################### Funcs #########################

def MagPat1(sector,entity):
    if (entity == "Player1"):
	MagicPath(14)
def MagPat2(sector,entity):
    if (entity == "Player1"):
	MagicPath(15)
def MagPat3(sector,entity):
    if (entity == "Player1"):
	MagicPath(16)
def MagPat4(sector,entity):
    if (entity == "Player1"):
	MagicPath(18)
def MagPat5(sector,entity):
    if (entity == "Player1"):
	MagicPath(19)
def MagPat6(sector,entity):
    if (entity == "Player1"):
	MagicPath(21)
def MagPat7(sector,entity):
    if (entity == "Player1"):
	MagicPath(22)
def MagPat8(sector,entity):
    if (entity == "Player1"):
	MagicPath(23)
def MagPat9(sector,entity):
    if (entity == "Player1"):
	MagicPath(24)
def MagPat10(sector,entity):
    if (entity == "Player1"):
	MagicPath(26)
def MagPat11(sector,entity):
    if (entity == "Player1"):
	MagicPath(28)
def MagPat12(sector,entity):
    if (entity == "Player1"):
	MagicPath(32)
def MagPat13(sector,entity):
    if (entity == "Player1"):
	MagicPath(34)
def MagPat14(sector,entity):
    if (entity == "Player1"):
	MagicPath(36)
def MagPat15(sector,entity):
    if (entity == "Player1"):
	MagicPath(37)
def MagPat16(sector,entity):
    if (entity == "Player1"):
	MagicPath(38)
def MagPat17(sector,entity):
    if (entity == "Player1"):
	MagicPath(39)
def MagPat18(sector,entity):
    if (entity == "Player1"):
	MagicPath(42)
def MagPat19(sector,entity):
    if (entity == "Player1"):
	MagicPath(45)
def MagPat20(sector,entity):
    if (entity == "Player1"):
	MagicPath(47)
def MagPat21(sector,entity):
    if (entity == "Player1"):
	MagicPath(51)
def MagPat22(sector,entity):
    if (entity == "Player1"):
	MagicPath(52)
def MagPat23(sector,entity):
    if (entity == "Player1"):
	MagicPath(53)
def MagPat24(sector,entity):
    if (entity == "Player1"):
	MagicPath(54)
def MagPat25(sector,entity):
    if (entity == "Player1"):
	MagicPath(55)
def MagPat26(sector,entity):
    if (entity == "Player1"):
	MagicPath(57)
def MagPat27(sector,entity):
    if (entity == "Player1"):
	MagicPath(58)
def MagPat28(sector,entity):
    if (entity == "Player1"):
	MagicPath(59)
def MagPat29(sector,entity):
    if (entity == "Player1"):
	MagicPath(61)
def MagPat30(sector,entity):
    if (entity == "Player1"):
	MagicPath(62)
def MagPat31(sector,entity):
    if (entity == "Player1"):
	MagicPath(64)
def MagPat32(sector,entity):
    if (entity == "Player1"):
	MagicPath(66)
def MagPat33(sector,entity):
    if (entity == "Player1"):
	MagicPath(68)
def MagPat34(sector,entity):
    if (entity == "Player1"):
	MagicPath(74)
def MagPat35(sector,entity):
    if (entity == "Player1"):
	MagicPath(76)
def MagPat36(sector,entity):
    if (entity == "Player1"):
	MagicPath(78)
def MagPat37(sector,entity):
    if (entity == "Player1"):
	MagicPath(79)
def MagPat38(sector,entity):
    if (entity == "Player1"):
	MagicPath(83)
def MagPat39(sector,entity):
    if (entity == "Player1"):
	MagicPath(84)
def MagPat40(sector,entity):
    if (entity == "Player1"):
	MagicPath(86)
def MagPat41(sector,entity):
    if (entity == "Player1"):
	MagicPath(87)
def MagPat42(sector,entity):
    if (entity == "Player1"):
	MagicPath(89)
def MagPat43(sector,entity):
    if (entity == "Player1"):
	MagicPath(92)
def MagPat44(sector,entity):
    if (entity == "Player1"):
	MagicPath(93)
def MagPat45(sector,entity):
    if (entity == "Player1"):
	MagicPath(97)
def MagPat46(sector,entity):
    if (entity == "Player1"):
	MagicPath(99)
def MagPat47(sector,entity):
    if (entity == "Player1"):
	MagicPath(102)
def MagPat48(sector,entity):
    if (entity == "Player1"):
	MagicPath(106)
def MagPat49(sector,entity):
    if (entity == "Player1"):
	MagicPath(107)
def MagPat50(sector,entity):
    if (entity == "Player1"):
	MagicPath(109)
def MagPat51(sector,entity):
    if (entity == "Player1"):
	MagicPath(112)
def MagPat52(sector,entity):
    if (entity == "Player1"):
	MagicPath(113)
def MagPat53(sector,entity):
    if (entity == "Player1"):
	MagicPath(114)
def MagPat54(sector,entity):
    if (entity == "Player1"):
	MagicPath(116)
def MagPat55(sector,entity):
    if (entity == "Player1"):
	MagicPath(118)
def MagPat56(sector,entity):
    if (entity == "Player1"):
	MagicPath(119)
def MagPat57(sector,entity):
    if (entity == "Player1"):
	MagicPath(122)
def MagPat58(sector,entity):
    if (entity == "Player1"):
	MagicPath(124)
def MagPat59(sector,entity):
    if (entity == "Player1"):
	MagicPath(125)
def MagPat60(sector,entity):
    if (entity == "Player1"):
	MagicPath(126)
def MagPat61(sector,entity):
    if (entity == "Player1"):
	MagicPath(128)
def MagPat62(sector,entity):
    if (entity == "Player1"):
	MagicPath(138)
def MagPat63(sector,entity):
    if (entity == "Player1"):
	MagicPath(139)

################################################################ start planets


def OpenPlanetsExit():
        desplazamientos=(2200.0, 600.0)
        vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
        vel_iniciales=(500.0, 2000)
        vel_finales=(2000.0, 500)
        son_durante=(deslizrasanexo, deslizrasanexo)
        son_finales=("", golperasanexo)
        Objects.NDisplaceObject(plgatedin, desplazamientos, vectores, vel_iniciales, vel_finales, (), son_durante, son_finales)
	
	
	
	
def Orbit(sector, entity):
	if entity != "Player1":
		return
	o = Bladex.GetEntity("orbit")
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.RotateObject(dinobj,3.14159*50000,0.15,3,(134000,40000,-47000),(0,1,0),Objects.ABS,"","","","",(),"",())
	o = Bladex.GetEntity("orbit2")
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.RotateObject(dinobj,3.14159*50000,0.2,3,(122000,40000,-33000),(0,1,0),Objects.ABS,"","","","",(),"",())
	o = Bladex.GetEntity("orbit3")
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.RotateObject(dinobj,3.14159*-50000,0.25,1,(128000,40000,-40000),(0,1,0),Objects.ABS,"","","","",(),"",())
	sectorbit1.OnEnter=None
	sectorbit2.OnEnter=None
	
"""
def Orbit(sector, entity):
	if entity != "Player1":
		return
	o = Bladex.GetEntity("orbit")
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.RotateObject(dinobj,3.14159*50000,0.3,3,(134000,40000,-47000),(0,1,0),Objects.ABS,"","","","",(),"",())
	o = Bladex.GetEntity("orbit2")
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.RotateObject(dinobj,3.14159*50000,0.4,3,(122000,40000,-33000),(0,1,0),Objects.ABS,"","","","",(),"",())
	o = Bladex.GetEntity("orbit3")
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.RotateObject(dinobj,3.14159*-50000,0.5,1,(128000,40000,-40000),(0,1,0),Objects.ABS,"","","","",(),"",())
	sectorbit1.OnEnter=None
	sectorbit2.OnEnter=None
"""
###############################################################################################################################################################################################
#################################################### Final yard



def OpenCathedralDoors():
	Objects.DisplaceObjectFromTo(ldoordin,(186500,33000,-56800),(186500,33000,-53800),100,540, "", "", "", "",(),"",()) 
	Objects.DisplaceObjectFromTo(rdoordin,(186500,33000,-63800),(186500,33000,-66800),100,540, "", "", "", "",(),FinPEnd1,()) 
	CheckVenom()
	
	

def FinPEnd1():
	Bladex.ActivateInput()
	Scorer.SetVisible(1)


def EnterCathedralYard(sector, entity):
	if entity != "Player1":
		return
	SetWayTemp(117000,39000,-60000)
	
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.1,DalMovie,())
	Bladex.KillMusic()
	Bladex.ExeMusicEvent(Bladex.GetMusicEvent("DalMovie"))
	sectoryard1.OnEnter=None
	sectoryard2.OnEnter=None
	sectoryard3.OnEnter=None


def CathYardCap():
	GameText.WriteTextAux(GetText("The Black Cathedral"), 5.0, 150,10,150, [],260)


def DalMovie():
	ddal.UnFreeze()
	Bladex.DeactivateInput()
	Scorer.SetVisible(0)
	Bladex.SetListenerPosition(2)
	CheckVenom()
	cposx,cposy,cposz=139347,33776,-60121
	tposx,tposy,tposz =119347,38776,-60121
	cposendx,cposendy,cposendz = 201000, 3922, -59000
	tposendx,tposendy,tposendz =119347,35776,-60121
	AuxFuncs.MoveCamFromTo(cposx,cposy,cposz, cposendx,cposendy,cposendz, tposx,tposy,tposz, tposendx,tposendy,tposendz, 33.0, ActDramaDal)
	Bladex.AddScheduledFunc(Bladex.GetTime()+29.0,MoveDal,())
	


def ActDramaDal():
	sndbosslaff1.Play(197283,5760,-59342,0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,Crow1TakeOff,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+13.0, AuxFuncs.ResetScene,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+13.3, Scorer.SetVisible, (1,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+33.0, ResumeMusic,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+15.0, FreezeDal, ())
	
	
	
def FreezeDal():
	ddal.Freeze()
	ddal.Blind=1
	ddal.Deaf=1	
	
	
def MoveDal():
	ddal.LaunchAnmType("first_appears")


def Crow1TakeOff():
	cuervo3_sound.Play(197283,5760,-59342,0)
	crow1=Bladex.GetEntity("Crow1") 
	crow1.Orientation=0.61,0.61,0.35,-0.35
	crow1.Animation="Crw_jmp"
	crow1.FPS=30
	crow1.OnAnimationEndFunc=AnmEndC1

def AnmEndC1(name):
	Crow1Fly()
	
	
def Crow1Fly():
	cuervo5_sound.Play(197283,5760,-59342,0)
	crow1=Bladex.GetEntity("Crow1")
	crow1.Orientation=0.5,0.5,0.43,-0.43                                          
	crow1.Animation="Crw_fly"
	crow1.FPS=20.0
	Bladex.AddScheduledFunc(Bladex.GetTime() +12.0, crow1.SubscribeToList,("Pin",))



def UnhideTratsSouth(sector, entity):
	if entity != "Player1":
		return
	darfuncs.UnhideBadGuy("TraitorKnight2")
	darfuncs.UnhideBadGuy("TraitorKnight2A")
	OpenMagicPathExit()
	sectorcathyard1.OnEnter=None
	
	
	
	
	
	
def UnhideTratsNorth(sector, entity):
	if entity != "Player1":
		return
	darfuncs.UnhideBadGuy("TraitorKnight1")
	darfuncs.UnhideBadGuy("TraitorKnight1A")
	
	sectorcathyard2.OnEnter=None
	
	
	
	
	
	
	
	
	
def ActDoorGuards(sector, entity):
	if entity != "Player1":
		return
	darfuncs.UnhideBadGuy("TraitorKnight3")
	darfuncs.UnhideBadGuy("TraitorKnight4")
	darfuncs.UnhideBadGuy("TraitorKnight5")
	DeathAppears ("TraitorKnight3", 0)
	DeathAppears ("TraitorKnight4", 0)
	DeathAppears ("TraitorKnight5", 0)
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.3, ChangeMusic,("Combat_Hard",)) 
	sectdoorguards.OnEnter = None
	
	
def StoneGolemDead(entity):
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.3, ChangeMusic,("Atmos5",)) 
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.3, EnableGuardsTigger,())
	
def EnableGuardsTigger():
	sectdoorguards.OnEnter = ActDoorGuards
	
def UnhideGuardGolem():
	darfuncs.UnhideBadGuy("EndG1")
	DeathAppears ("EndG1", 0)
	door5.CloseDoor() #vamp exit
	Bladex.KillMusic()
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.3, ChangeMusic,("Combat4",)) 
	
	
	

DoorGuards=3


def DoorGuardDead(entity):
	global DoorGuards
	DoorGuards=DoorGuards-1
	if DoorGuards==0:
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.8, DoorsOpenCam1,())
	global YardEnemies
	if entity in YardEnemies:
		YardEnemies.remove(entity)
		
		
def DoorsOpenCam1():
	Bladex.DeactivateInput()
	Actions.TurnToFaceEntity("Player1","TapizEscorpion_204")
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.8, DoorsOpenCam2,())
	CheckVenom()
	
	
def DoorsOpenCam2():
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.3, ChangeMusic,("CathEnter",)) 
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,OpenCathedralDoors,())
	
	


def RunSkelDead(entity):
	global RunSkels
	if entity in RunSkels:
		RunSkels.remove(entity)
		if len(RunSkels) == 0:
			Bladex.AddScheduledFunc(Bladex.GetTime()+5.0, LightsDown,())
			Bladex.AddScheduledFunc(Bladex.GetTime()+15.0,EnableDemonTrigger,())
			Bladex.ExeMusicEvent(-1)
			Bladex.AddScheduledFunc(Bladex.GetTime()+2.5, ChangeMusic,("ExitMaze",))


def EnableDemonTrigger():
	Bladex.SetTriggerSectorFunc("GDTrigger", "OnEnter", DemonTrigger)
		
		
def AppearGreatDemon():
	Bladex.DeactivateInput()
	gd.Position = 191726,37609,-59809
	gd.UnFreeze()
	gd.Data.LifeUp (gd.Name)
	gd.Data.LifeUpCalled = 1
	gd.Data.ResetCombat (gd.Name)
	gd.Data.ShieldOn (gd.Name)
	Actions.TurnToFaceEntity("Player1",gd.Name)
	Bladex.AddScheduledFunc(Bladex.GetTime()+5, DemonActivate,())
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+5, ChangeMusic,("Finale",))
	Bladex.SetTriggerSectorFunc("GDTrigger", "OnEnter", None)
		
		
		
def DemonActivate():
	gd.Blind=0
	gd.Deaf=0
	Bladex.ActivateInput()
		


Lightintens=10
Lightlowintens=0
Fireintens=0
SpotIntens=25

def SpotDownTimer(ent_name, time):
	global SpotIntens
	spot=Bladex.GetEntity(ent_name)
	SpotIntens=SpotIntens-0.15
	spot.Intensity=SpotIntens
	if SpotIntens<=0.6:
		spot.RemoveFromList("Timer15")
		spot.TimerFunc=""
		


def SpotsDown():
	Luzrr1.SubscribeToList("Timer15")	
	Luzrr1.TimerFunc= SpotDownTimer
	Luzrr2.SubscribeToList("Timer15")	
	Luzrr2.TimerFunc= SpotDownTimer
	Luzrr6.SubscribeToList("Timer15")	
	Luzrr6.TimerFunc= SpotDownTimer
	Luzrr7.SubscribeToList("Timer15")	
	Luzrr7.TimerFunc= SpotDownTimer




def LiteDownTimer(ent_name, time):
	global Lightintens
	global Lightlowintens
	global Fireintens
	lite1=Bladex.GetEntity(ent_name)
	Lightintens=Lightintens-0.05
	Fireintens=Fireintens+0.07
	lite1.FiresIntensity=[ Fireintens ]
	lite1.Lights = [(Lightintens, 0.03125, (255, 196, 128))]
	if Lightintens<=Lightlowintens:
		lite1.RemoveFromList("Timer30")
		lite1.TimerFunc=""
		


def LightsDown():
	SpotsDown()
	dl1.SubscribeToList("Timer15")	
	dl1.TimerFunc= LiteDownTimer
	dl2.SubscribeToList("Timer15")	
	dl2.TimerFunc= LiteDownTimer
	dl3.SubscribeToList("Timer15")	
	dl3.TimerFunc= LiteDownTimer
	dl4.SubscribeToList("Timer15")	
	dl4.TimerFunc= LiteDownTimer
		
		
		
		
		
def CathedralEnter():
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.3,CathedralEnter2,())
	
	
def CathedralEnter2():
	Bladex.ExeMusicEvent(-1)
	Bladex.DeactivateInput()
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,ActRunSkels,())
	if len(YardEnemies)>0:
		for id in YardEnemies:
			per=Bladex.GetEntity(id)
			if per.Life>0:
				per.Life=0
	
	
def ActRunSkels(sector, entity):
	if entity != "Player1":
		return
	Bladex.DeactivateInput()
	Bladex.AddScheduledFunc(Bladex.GetTime(), ChangeMusic,("Combat6",))
	darfuncs.UnhideBadGuy("Runskl1")
	rnskl1.GoToJogging = 1
	rnskl1.GoTo(216000,34500,-60000)
	darfuncs.UnhideBadGuy("Runskl1a")
	rnskl1a.GoToJogging = 1
	rnskl1a.GoTo(216000,34500,-60000)
	global caminitpos
	global caminitTpos
	caminitpos=cam.Position
	caminitTpos=cam.TPos
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, LookSkl2,())
	AuxFuncs.MoveCamFromTo(caminitpos[0],caminitpos[1],caminitpos[2], caminitpos[0],caminitpos[1],caminitpos[2], caminitTpos[0],caminitTpos[1],caminitTpos[2], 196000,35000,-47000, 2, RunSklCam2)
	sectskels.OnEnter=None
	CheckVenom()
	
	
	
def RunSklCam2():
	Actions.TurnToFaceEntity("Player1","TapizEscorpion_204")
	global caminitTpos
	caminitTpos=cam.TPos
	AuxFuncs.MoveCamFromTo(caminitpos[0], caminitpos[1], caminitpos[2], caminitpos[0], caminitpos[1], caminitpos[2], caminitTpos[0],caminitTpos[1],caminitTpos[2], 196000,35000,-72000, 4.5, SklCamFin1)
	
	

def SklCamFin1():
	Bladex.ActivateInput()
	AuxFuncs.ResetScene()
	
	
def LookSkl2():
	darfuncs.UnhideBadGuy("Runskl2")
	rnskl2.GoToJogging = 1
	rnskl2.GoTo(216000,34500,-60000)
	darfuncs.UnhideBadGuy("Runskl2a")
	rnskl2a.GoToJogging = 1
	rnskl2a.GoTo(216000,34500,-60000)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.6, LookSkl3,())
	
	
def LookSkl3():
	global WayPoint
	global WayPointAngle
	WayPoint=192500, 31000, -47500 
	WayPointAngle=3.0
	prodoor2.CloseDoor()
	
	
	

def DemonTrigger(sector, entity):
	if entity != "Player1":
		return
	AppearGreatDemon()


def DemonDead(entity):
	Bladex.ExeMusicEvent(-1)
	Bladex.AddScheduledFunc(Bladex.GetTime()+9, ChangeMusic,("ExitMaze",))
	Bladex.AddScheduledFunc(Bladex.GetTime()+17, EnableStairOpenFunc, ())
	lvl=char.Level
	if lvl<18:
		nulvl=18
		char.Data.FastrackLevelup("Player1",nulvl)
		
		
def EnableStairOpenFunc():
	Bladex.SetTriggerSectorFunc("GDTrigger", "OnEnter", OpenStairs)
	
	
def OpenStairs(sector, entity):
	if entity != "Player1":
		return
	Bladex.SetTriggerSectorFunc("GDTrigger", "OnEnter", None)
	Flipstair3()
	Actions.TurnToFaceEntity("Player1","TapizEscorpion_204")
	Bladex.KillMusic()
	Bladex.AddScheduledFunc(Bladex.GetTime(), Bladex.ExeMusicEvent, (Bladex.GetMusicEvent("Creepy"),))
	Bladex.AddScheduledFunc(Bladex.GetTime()+10, ResumeMusic,())


def Flipstair1():
	stair1.OpenDoor()

def Flipstair2():
	stair2.OpenDoor()
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.8,Flipstair1,())


def Flipstair3():
	stair3.OpenDoor()
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.8,Flipstair2,())
	

############################################################################
############################### Dal Gurak & friends... #################

def KillBolts():
	ents = Bladex.nEntities()
	for id in range(ents):
		obj = Bladex.GetEntity(id)
		if obj.Kind == "Entity ElectricBolt":
			obj.Active=0
		if obj.Kind == "Orbe":
			obj.Position = 0,0,0

def unhidedal1():
	darfuncs.UnhideBadGuy("GenDalGurak3")
	Actions.TurnToFaceEntity("Player1", "GenDalGurak3")
	EnemyMagicallyAppearing("GenDalGurak3",4)
	
	

def KillPlayer():
	char.Life=0
	
	
def FreezeAndReplaceDal():
	per=Bladex.GetEntity("GenDalGurak3")
	per.Freeze()
	per.Data.Invincibility=1
	Bladex.AddScheduledFunc(Bladex.GetTime()+6.0, ReplaceDal,(per,))
	char.SetActiveEnemy(None)
	
	
def ReplaceDal(per):
	if per.Life<=0:
		return
	per.UnFreeze()
	x,y,z=per.Position
	if x>231500:
		per.Position=224000, 45000, -61000
	else:
		per.Position=239000, 45000, -61000
	per.Angle=B3DLib.GetEntity2EntityAngle(per.Name, "Player1")
	per.Data.Invincibility=0
	
	
	
def MoveBack(sector, entity):
	if entity not in ("GenDalGurak3","Player1"):
		return
	x,y,z=Bladex.GetEntity("GenDalGurak3").Position
	if entity == "Player1":
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, KillPlayer,())
		cam.SType = 0
		cam.TType = 0
		global WayPointAngle
		if x>231500:
			SetWayTemp(224000, 45000, -61000)
			WayPointAngle=4.5
		else:
			SetWayTemp(239000, 45000, -61000)
			WayPointAngle=1.5
	elif  entity == "GenDalGurak3":
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, FreezeAndReplaceDal,())




def  MuereDalGurak(entity):
	Bladex.DeactivateInput()
	Scorer.SetVisible(0)
	lvl=char.Level
	nulvl=lvl+1
	char.Data.FastrackLevelup("Player1",nulvl)
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,PlayerLookAtDal,())
	Bladex.KillMusic()
	StartMatrixFXX("GenDalGurak3",0.7)
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, Bladex.ExeMusicEvent, (Bladex.GetMusicEvent("DalDead1"),))
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.0, DalVanishFX,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+13.0,AuxFuncs.FadeTo,(4.0,2.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+16.0, GoingUp,())
	x,y,z=Bladex.GetEntity("GenDalGurak3").Position
	snddalagony.Play(x,y,z,0)
	
	

def DalVanishFX():
	per=Bladex.GetEntity("GenDalGurak3")
	x,y,z=per.Position
	dluz=Bladex.CreateEntity("DalLuz1","Entity Spot",x,y,z)
	dluz.Color=100,100,100
	dluz.Intensity=0.0
	dluz.Precission=0.1
	dluz.CastShadows=0
	dluz.Visible=0
	dluz.Flick=0
	AuxFuncs.SpotIntensityVariation("DalLuz1",0.0,10,2.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.1,AuxFuncs.SpotIntensityVariation,("DalLuz1",10,0.0,4,1,))
	rwp=Bladex.GetEntity(per.InvRight)
	lwp=Bladex.GetEntity(per.InvLeft)
	DeathAppears(per.Name,1,10.0)
	AuxFuncs.FadeObject(per.Name,1.0,0.0,6.0)
	if rwp:
		AuxFuncs.FadeObject(per.InvRight,0.5,0.0,6.0)
	if lwp:
		AuxFuncs.FadeObject(per.InvLeft,0.5,0.0,6.0)
		


def PlayerLookAtDal():
	Actions.TurnToFaceEntity("Player1","GenDalGurak3")
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.8,StepAway,())
	
	
def StepAway():
	position=char.Rel2AbsPoint(0,1500,0)
	max_fall=2000
	if char.TestPos(position[0],position[1],position[2], char.ActionAreaMax, max_fall):	
		char.LaunchAnmType("wbk_1h")
		
	
	
def GoingUp():
	char.Position=230500,44500,-59000
	char.Angle=3.5
	CheckVenom()
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,UpCam,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,FinalCap,())
	desplazamientos=(500.0, 5000.0, 500.0)
	vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
	vel_iniciales=(0.0, 1000.0, 1000.0)
	vel_finales=(1000.0, 1000.0, 0.0)
	son_iniciales=("", "", "")
	son_durante=("", "", "")
	Objects.NDisplaceObject(centcoldin, desplazamientos, vectores, vel_iniciales, vel_finales, son_iniciales, son_durante)
	Objects.NDisplaceObject(sphbowldin, desplazamientos, vectores, vel_iniciales, vel_finales, son_iniciales, son_durante)
	doorX.CloseDoor()
	
	
	
def DoorXFin():
	global ShowCStats
	ShowCStats = 0
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,Quake1,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+30.0,AuxFuncs.FadeTo,(6.0,30.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+36.0,ConquestStats,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+50.0,TheEnd,())
	
	

def UpCam():
	AuxFuncs.FadeFrom(1.0,0.6)
	StopMatrixFXX()
	Bladex.SetListenerPosition(2)
	cpos=226000,38000,-51000
	cpos2=226000,38000,-62000
	tpos=251000, 39000, -66000
	tpos2=251000, 39000, -59000
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], 12, "")
	ChangeMusic("Atmos19")
	inv=char.GetInventory()
	inv.LinkRightBack("")
	inv.LinkRightHand("")
	inv.LinkRightBack("Doom2")
	if char.InvLeft:
		shd=Bladex.GetEntity(char.InvLeft)
		inv.LinkLeftBack("")
		inv.LinkLeftBack(shd.Name)
	char.LaunchAnmType("Rlx_no")
	
	

	
	
	
def TheEnd():
	Bladex.LoadLevel("Casa")

		
		
		
def FinalCap():
	ClearText()
	GameText.WriteTextAux(GetText("You have found the Sword of Ianna and released\nits powers from the evil force of Chaos.\nThe youngest of the Chaos magicians lies slain in his own Cathedral\n but your journey is only beginning....\n\n Are you prepared for your next Conquest??"),20.0,255,150,20,[],260)
	
		
def BreakWall():	
	derr1.DoBreak((-2.8, 0.0, 0.0), (246000, 38000, -58000), (0.0, 0.0, 0.0))
	derr2.DoBreak((-2.0, 0.0, 0.0), (246000, 38000, -60000), (0.0, 0.0, 0.0))
	HugeDustBlast()
		

def Quake1():
	darfuncs.Temblores(8.0,30)
	DropMiniRocks()
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,BreakWall,())
	Bladex.SetTimeSpeed(0.8)
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,RunAway,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+9.0,Quake2,())
	
def Quake2():
	darfuncs.Temblores(30.0,80)
	DropBricks()
	sndquake2.Play(cam.Position[0],35000,cam.Position[2],0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.0,DropColumn,())
	

def RunAway():
	char.RouteEndedFunc= JumpInHole
	char.GoToJogging=1
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,char.GoTo,(243433,38719,-59646,))
	
def JumpInHole(entity):
	char.RouteEndedFunc=None
	char.LaunchAnmType("jmph0_no")
	char.AnmEndedFunc=MassiveLeap
	
	
def MassiveLeap(entity):
	char.LaunchAnmType("jmp_no")
	char.AnmEndedFunc=DropMe
	

def DropMe(entity):
	char.AnmEndedFunc=None
	x,y,z=char.Position
	if x > 247000:
		char.SetOnFloor()
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,FreezeMe,())
	else:
		char.GoTo(243433,38719,-59646)
		
		
		
def FreezeMe():
	char.Freeze()
	char.AnmEndedFunc=None
	





Xcoords=[233000, 234000, 235000, 236000, 237000, 238000, 239000, 240000]
Ycoords=[-57000, -58000, -59000, -60000, -61000, -62000, -63000, -64000, -65000, -66000]
Zrockhight=28000
Zbrickhight=29000
RockNum=0
BrickNum=0
RockTypes=["Piedra_01","Piedra_03","Piedra_08","Piedra_04"]


def DropMiniRocks():
	if RockNum>20:
		print "Rocks End"
		return
	global RockNum
	x_pos=Xcoords[whrandom.randint(0,len(Xcoords)-1)]
	y_pos=Ycoords[whrandom.randint(0,len(Ycoords)-1)]
	SIZE=1.0
	SIZE=whrandom.uniform(1.0, 3.0)
	ROCKTYPE="Piedra_01"
	ROCKTYPE=RockTypes[whrandom.randint(0,len(RockTypes)-1)]
	RockNum=RockNum+1
	rock=Bladex.CreateEntity("MiniRock_"+`RockNum`,ROCKTYPE,x_pos,Zrockhight,y_pos)
	rock.Static=0
	rock.Scale=SIZE
	rock.Impulse(0,0,0)
	Tvar=whrandom.uniform(0.3, 3.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+Tvar, DropMiniRocks,())
	if SIZE>=2.0:
		DOWNPULL=whrandom.uniform(3000.0, 8000.0)
		DUR=whrandom.uniform(3.0, 8.0)
		DropSand(x_pos,Zrockhight-1000,y_pos, 0,DOWNPULL,0,DUR,RockNum)
		sndquake1.Play(x_pos,38000-1000,y_pos,0)


def DropBricks():
	if BrickNum>10:
		print "Bricks End"
		return
	global BrickNum
	x_pos=Xcoords[whrandom.randint(0,len(Xcoords)-1)]
	y_pos=Ycoords[whrandom.randint(0,len(Ycoords)-1)]
	SIZE=1.0
	SIZE=whrandom.uniform(1.0, 2.0)
	
	BrickNum=BrickNum+1
	br=Bladex.CreateEntity("Brick_"+`BrickNum`,"Adoquinpulsador",x_pos,Zbrickhight,y_pos)
	br.Static=0
	br.Scale=SIZE
	br.Impulse(0,0,0)
	Tvar=whrandom.uniform(2.0, 5.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+Tvar, DropBricks,())
	

def DropColumn():
	o=Bladex.CreateEntity("Columnaestrecha_271","Columnaestrecha",229000,35000,-61111)
	o.Scale=2.2
	o.Static=0
	o.Orientation=(0.965925812721,-0.258819043636,0.0,0.0)
	o.Impulse(0,0,0)
	



def DropSand(x,y,z,vx,vy,vz,Death=3.0,NUM=1):
	tierra1=Bladex.CreateEntity("Cristales"+`NUM`, "Entity Particle System D1", x, y, z)
	tierra1.ParticleType="SandyDust"
	tierra1.PPS=128
	tierra1.YGravity=9800.0
	tierra1.Friction=0.1
	tierra1.Velocity=vx,vy,vz
	tierra1.RandomVelocity=50.0
	tierra1.Time2Live=64
	tierra1.DeathTime=Bladex.GetTime()+Death	
	


def HugeDustBlast():
	smoke3=Bladex.CreateEntity("WallDust", "Entity Particle System D1", 245000, 39000, -60000)
	smoke3.ParticleType="SandyDust"
	smoke3.YGravity=-4000.0
	smoke3.Friction=0.1
	smoke3.PPS=128
	smoke3.Velocity= -3000.0, -500.0, 0.0
	smoke3.Time2Live=50
	smoke3.RandomVelocity=60
	smoke3.DeathTime = Bladex.GetTime() + 3.0


def CoolFX(entity,effect,tm):
	o = Bladex.GetEntity(entity)
	sound=Bladex.CreateSound("..\\..\\Sounds\\fuego-boo.wav", "SndFireDoom")
	sound.Volume=1
	sound.Play(o.Position[0], o.Position[1], o.Position[2], 0)
	FX = Bladex.CreateEntity("FXO"+str(entity), "Entity Particle System D1",o.Position[0], o.Position[1], o.Position[2])
	FX.ParticleType   = effect
	FX.YGravity       = -500 # -1000
	FX.Friction       = 0.01
	FX.PPS            = 1024
	FX.Velocity       = 0, 0, 0 # 0,800,0
	FX.Time2Live      = 30 #60
	FX.NormalVelocity=0.1 #-2.0
	FX.RandomVelocity = 20 #65
	FX.DeathTime=Bladex.GetTime()+tm


def CoolFXObj(entity,effect,tm,T2,RV):
	o = Bladex.GetEntity(entity)
	sound=Bladex.CreateSound("..\\..\\Sounds\\fuego-boo.wav", "SndObjDoom")
	sound.Volume=1
	sound.Play(o.Position[0], o.Position[1], o.Position[2], 0)
	FX = Bladex.CreateEntity("FXO"+str(entity), "Entity Particle System Dobj",o.Position[0], o.Position[1], o.Position[2])
	FX.ObjectName=entity
	FX.ParticleType   = effect
	FX.YGravity       = -600 # -1000
	FX.Friction       = 0.01
	FX.PPS            = 256 # 1024
	FX.Velocity       = 0, 0, 0 # 0,800,0
	FX.Time2Live      = T2 #30 #60
	FX.NormalVelocity=0.1 #-2.0
	FX.RandomVelocity = RV #20 #65
	FX.DeathTime=Bladex.GetTime()+tm
	

def ShowDalFunc():
	unhidedal1()
	Actions.TurnToFaceEntity("Player1", "GenDalGurak3")
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.5,ChangeMusic,("FightDal",))
	SetWay7()
	KillBolts()
	AuxFuncs.ResetScene()
	Scorer.SetVisible(1)



LZ=[235000,-61500,235000,-58500,233000,-56500,230000,-56500,228000,-58500,228000,-61500,230000,-63500,233000,-63500]
Z=39900

def DalFunc():
	Bladex.ActivateInput() 
	doorX.OpenDoor()
	stm=Bladex.GetTime()
	Bladex.AddScheduledFunc(stm+8, ShowDalFunc,())
	orbbolt2.Active=0
	orbbolt.Active=0
	o=Bladex.GetEntity("DoomX").Position=0,0,0
	desplazamientos=(500.0, 5000.0, 500.0)
	vectores=((0.0, 1.0, 0.0), (0.0, 1.0, 0.0), (0.0, 1.0, 0.0))
	vel_iniciales=(0.0, 1000.0, 1000.0)
	vel_finales=(1000.0, 1000.0, 0.0)
	son_iniciales=("", "", "")
	son_durante=("", "", "")
	Objects.NDisplaceObject(centcoldin, desplazamientos, vectores, vel_iniciales, vel_finales, son_iniciales, son_durante)
	Objects.NDisplaceObject(sphbowldin, desplazamientos, vectores, vel_iniciales, vel_finales, son_iniciales, son_durante)


def Bang8(o):
	Actions.TurnToFaceEntity("Player1","DoomX")
	CoolFXObj("DoomX","LargeFire",1,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj,(LZ[14],Z,LZ[15]),(LZ[0],Z,LZ[1]),4000,4000,"","","", TrackOrb,(o,),DalFunc,()) 

def Bang7(o):
	CoolFXObj("DoomX","LargeFire",1,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (LZ[12], Z, LZ[13]), (LZ[14], Z, LZ[15]), 4000, 4000, "", "", "",   TrackOrb, (o,), Bang8, (o,)) 

def Bang6(o):
	Actions.TurnToFaceEntity("Player1","DoomX")
	CoolFXObj("DoomX","LargeFire",1,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (LZ[10], Z, LZ[11]), (LZ[12], Z, LZ[13]), 4000, 4000, "", "", "",   TrackOrb, (o,), Bang7, (o,)) 


def Bang5(o):
	Actions.TurnToFaceEntity("Player1","DoomX")
	CoolFXObj("DoomX","LargeFire",1,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (LZ[8], Z, LZ[9]), (LZ[10], Z, LZ[11]), 4000, 4000, "", "", "",   TrackOrb, (o,), Bang6, (o,)) 

def Bang4(o):
	Actions.TurnToFaceEntity("Player1","DoomX")
	CoolFXObj("DoomX","LargeFire",1,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (LZ[6], Z, LZ[7]), (LZ[8], Z, LZ[9]), 4000, 4000, "", "", "",   TrackOrb, (o,), Bang5, (o,)) 


def Bang3(o):
	Actions.TurnToFaceEntity("Player1","DoomX")
	CoolFXObj("DoomX","LargeFire",1,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (LZ[4], Z, LZ[5]), (LZ[6], Z, LZ[7]), 4000, 4000, "", "", "",   TrackOrb, (o,), Bang4, (o,)) 


def Bang2(o):
	Actions.TurnToFaceEntity("Player1","DoomX")
	CoolFXObj("DoomX","LargeFire",1,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (LZ[2], Z, LZ[3]), (LZ[4], Z, LZ[5]), 4000, 4000, "", "", "",   TrackOrb, (o,), Bang3, (o,)) 



def Bang1(o):
	CoolFXObj("DoomX","LargeFire",1,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	orbbolt2.Position=Bladex.GetEntity("Doom").Position
	orbbolt2.Target=o.Position
	orbbolt2.Active=1
	Actions.TurnToFaceEntity("Player1","DoomX")
	Objects.DisplaceObjectFromTo(dinobj, (LZ[0], Z, LZ[1]), (LZ[2], Z, LZ[3]), 4000, 4000, "", "", "",   TrackOrb, (o,), Bang2, (o,)) 
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.5,SwordCam4,())
	


	
	
def LevitateOrb():
	orbbolt.Active=0
	o = Bladex.GetEntity("Doom")
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (o.Position[0], o.Position[1], o.Position[2]), (o.Position[0], o.Position[1]-500, o.Position[2]), 600, 200, "", "", "",  "", (), "", ()) 
	
	
	
	
def End2Func():
	o=Bladex.GetEntity("DoomX")
	Bang1(o)
	


def TakeFunc():
	char.AddAnmEventFunc("PickupEvent",PickupSwordHandler)
	char.LaunchAnmType("tke_r_key04")
	stm=Bladex.GetTime()
	Bladex.AddScheduledFunc(stm+2.2, End2Func,())



def PickupSwordHandler(EntityName, EventName):
	inv=char.GetInventory()
	inv.maxWeapons = 5
	o=Bladex.GetEntity("Doom2")
	flag=Reference.GiveWeaponFlag("Doom2")
	inv.AddWeapon("Doom2",flag)
	inv.LinkRightHand("Doom2")
	

def MatPause():
	if (char.InvRight):
		Actions.StdToggleWeapons("Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.8, TakeFunc,())
	

def ObjToPlayerFunc(o,stm):
	pers = Bladex.GetEntity("Player1")
	pos=pers.Position
	o=Bladex.GetEntity("Doom2")
	CoolFXObj("Doom2","EnergyDissip",4,60,30)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (o.Position[0], o.Position[1], o.Position[2]), (pos[0]+800, pos[1], pos[2]), 4000, 500, "", "", "",  ObjIsRotateFunc, (o.Name,), MatPause, ()) 
	SwordCam3()
	

def ObjDropFunc(entity):
	o = Bladex.GetEntity("Doom2")
	stm=Bladex.GetTime()
	Bladex.AddScheduledFunc(stm+0.1, ObjToPlayerFunc,(o.Name,stm,))


def RotateSwordFunc():
	o=Bladex.GetEntity("Doom2")
	dinobj = Objects.CreateDinamicObject(o.Name)
	SwordAppearsFX("Doom2","FastEnergyConc",5)
	Actions.TurnToFaceEntity("Player1", "Doom2")
	Objects.RotateObject(dinobj, 3.14159*5.5, 20, 1, (0, 1, 0), (0, 0, 1), Objects.REL, "", "", "", ObjIsRotateFunc, (o.Name,), ObjDropFunc, (o.Name,))
	
	

def BladeFunc():
	if SkPer==3:
		IannaS="BladeSword2Barbarian"
	else:
		IannaS="BladeSword2"
	o=Bladex.CreateEntity("Doom2",IannaS,244000, 34800, -60000,"Weapon")
	o.Static=1
	o.Scale=1
	o.Orientation=-0.5,-0.5,0,0
	ItemTypes.ItemDefaultFuncs (o)
	Actions.TurnToFaceEntity("Player1", "Doom2")
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (o.Position[0], o.Position[1], o.Position[2]), (o.Position[0], o.Position[1]-2800, o.Position[2]), 600, 200, "", "", "",  ObjIsRotateFunc, (o.Name,), RotateSwordFunc, ()) 
	
	
	
	

def ObjElectricFunc():
	o = Bladex.GetEntity("Doom")
	ShockBolt1(o.Position[0], o.Position[1], o.Position[2], 243800,33200,-60000, 200)###
	o=Bladex.GetEntity("Book1")
	o.SelfIlum=0.8
	stm=Bladex.GetTime()
	Bladex.AddScheduledFunc(stm+1, BladeFunc,())


def OrbPause():
	stm=Bladex.GetTime()
	Bladex.AddScheduledFunc(stm+1, ObjElectricFunc,())
	char.Position= 232500,39000,-60000
	char.Angle=4.5
	char.SetOnFloor()
	ChangeMusic("SwordAppear2")

def ObjGoAltarFunc():
	Bladex.ExeMusicEvent(-1)
	Actions.TurnToFaceEntity("Player1","Altar1")
	SwordCam2()
	o = Bladex.GetEntity("Doom")
	sound=Bladex.CreateSound("..\\..\\Sounds\\trueno5.wav", "SndDoomFly1")
	sound.Volume=1
	sound.Play(o.Position[0], o.Position[1], o.Position[2], 0)
	CoolFXObj("Doom","LargeFire",3,30,10)
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (o.Position[0], o.Position[1], o.Position[2]), (240000, 33000, -60000), 4000, 2000, "", "", "",  ObjIsRotateFunc, (o.Name,), OrbPause, ()) 
	

def ObjIsRotateFunc(obj): 
	try:
		dinobj = obj.Data.dinobjdata
		dinobj.OnMovement = 0
		dinobj.OnRotation = 0
	except:
		pass

def TrackOrb(o):
	orbbolt2.Target=o.Position


def ObjRotateAbsFunc(o):
	o = Bladex.GetEntity("Doom")
	pos=231000,38500,-59000
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.RotateObject(dinobj, 3.14159*1.5, 1, 3, (pos[0],38000,pos[2]), (0, 1, 0), Objects.ABS, "", "", "", ObjIsRotateFunc, (o.Name,), ObjGoAltarFunc, ())
	
		
		
		
def ObjSpinFunc(o,tm):
	pos=char.Position
	o = Bladex.GetEntity("Doom")
	o.Position=231500,37950,-60000
	Actions.TurnToFaceEntity("Player1", o.Name)
	CoolFXObj("Doom","LargeFire",2.0,30,35)
	sphbowl.FiresIntensity=[ 46.0 ]
	sphbowl.Lights = [(0.0, 0.1, (255, 196, 128))]
	dinobj = Objects.CreateDinamicObject(o.Name)
	Objects.DisplaceObjectFromTo(dinobj, (o.Position[0], o.Position[1], o.Position[2]), (231500,36000,-60000), 200, 1000, "", "", "",  ObjIsRotateFunc, (o.Name,), ObjRotateAbsFunc, (o.Name,)) 
	GameText.WriteTextAux(GetText("***** The Sphere of Truth *****\n"), 5.0, 250,150,10,[],30)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, char.LaunchAnmType,("wbk_no",))



def SwordCam():
	cpos=cam.Position
	tpos=cam.TPos
	tpos2=231400,38500,-59000
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos[0]+7000, cpos[1]-1000, cpos[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], 6, "")

	
def SwordCam2():
	cpos=cam.Position
	tpos=cam.TPos
	cpos2=236400,31500,-59000  
	tpos2=244000, 34100, -60000
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], 5, "")
	
	
	
def SwordCam3():
	cpos=cam.Position
	tpos=cam.TPos
	cpos2=229400,31500,-66000  
	tpos2=237400,37500,-61000
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], 4, "")


def SwordCam4():
	cpos=cam.Position
	tpos=cam.TPos
	cpos2=239655,28336,-68746 
	tpos2=237160,34595,-61774 
	AuxFuncs.MoveCamFromTo(cpos[0], cpos[1], cpos[2], cpos2[0], cpos2[1], cpos2[2], tpos[0],tpos[1], tpos[2],tpos2[0], tpos2[1], tpos2[2], 1.5, "")






def ObjRaiseFunc(entity):
	time=2
	Bladex.AddScheduledFunc(Bladex.GetTime()+time, ObjSpinFunc,("Player1",time,))
	stair3.CloseDoor()


PlayerWalk=0


def AlainnFunc():
	Bladex.DeactivateInput() 
	Scorer.SetVisible(0)
	CheckVenom()
	SwordCam()
	charhight=39000
	if char.Kind=="Dwarf_N":
		charhight=39110
	char.GoToJogging = 0
	if char.GoTo(231000,charhight,-58000):
		char.RouteEndedFunc=ObjRaiseFunc
		print "Player moving in end scene"
		global PlayerWalk
		PlayerWalk=1
	else:
		Bladex.AddScheduledFunc(Bladex.GetTime()+3,ObjRaiseFunc,("Player1",))
	










############### Test Stuff ################################################################################

def IrPosicion1():
	char=Bladex.GetEntity("Player1")
	char.Position=11000,-1500,-7000

def IrPosicion2():
	char=Bladex.GetEntity("Player1") # ks tunnel
	char.Position=-1000,5123,-11000
	

def IrPosicion3():
	char=Bladex.GetEntity("Player1")
	char.Position=4278,11490,-35353 # poison colony start


def IrPosicion4():
	char=Bladex.GetEntity("Player1") # maze exit
	char.Position=62000, 35000, -5000


def IrPosicion5():
	char=Bladex.GetEntity("Player1")
	char.Position=-56000,36400,-27000  # golem tunnel
	char.Angle= 0

def IrPosicion6():
	char=Bladex.GetEntity("Player1")
	char.Position= 201773,38891,-13289 # end window

def IrPosicion7():
	char=Bladex.GetEntity("Player1")
	char.Position=200000,6000,-57000 #end tower
	
def IrPosicion8():
	char=Bladex.GetEntity("Player1") # test area
	char.Position=0,-1000,50000
	char.Angle=0
	char.Data.FastrackLevelup("Player1",19)
	
def IrPosicion9():
	char=Bladex.GetEntity("Player1") # final
	char.Position=218000,39000,-61000
	char.Angle=4.5



def InitEB():
	import EBrowser
	print "EBStart"

def WritePos():
	char=Bladex.GetEntity("Player1")
	x=int(char.Position[0])
	y=int(char.Position[1])
	z=int(char.Position[2])
	file = open("../../BODLoader/Mods/NewConquest/pos.txt","a")
        file.write("("+str(x)+","+str(y)+","+str(z)+")"+"\n")
        file.close()
        
     
MatRun=0
        
def TestCam():
        global MatRun
        if not MatRun:
        	cam.SType=0
		cam.TType=0
		cam.Position= 226000,36000,-57000
		cam.TPos=231000, 40000, -60000
		MatRun=1
        else:
        	AuxFuncs.ResetScene()
         	MatRun=0
         	
         	

    
         	
         	
         	
def TestCam2():
	Damage.BreakMyShield("TSkel1")
        print "Skelly shield test"
        
        
        
        
def DemTest():
	#DropMiniRocks()
	pass
Scoreron=1

def HideScorer():
	global Scoreron
	if Scoreron==1:
		Scorer.SetVisible(0)
		Scoreron=0
	else:
		Scorer.SetVisible(1)
		Scoreron=1




if Reference.PYTHON_DEBUG >= 1:
	

	Bladex.AddInputAction("InitEB", 0)
	Bladex.AddBoundFunc("InitEB", InitEB)
	Bladex.AssocKey("InitEB", "Keyboard", "X", 1)

	Bladex.AddInputAction("WritePos", 0)
	Bladex.AddBoundFunc("WritePos", WritePos)
	Bladex.AssocKey("WritePos", "Keyboard", "I", 1)

	Bladex.AddInputAction("HideScorer", 0)
	Bladex.AddBoundFunc("HideScorer", HideScorer)
	Bladex.AssocKey("HideScorer", "Keyboard", "B", 1)
	
	Bladex.AddInputAction("TestCam", 0)
	Bladex.AddBoundFunc("TestCam", TestCam)
	Bladex.AssocKey("TestCam", "Keyboard", "Z", 1)
	
	Bladex.AddInputAction("DemTest", 0)
	Bladex.AddBoundFunc("DemTest", DemTest)
	Bladex.AssocKey("DemTest", "Keyboard", "U", 1)
	
	Bladex.AddInputAction("TestCam2", 0)
	Bladex.AddBoundFunc("TestCam2", TestCam2)
	Bladex.AssocKey("TestCam2", "Keyboard", "Y", 1)