import Bladex
import Reference
import EnemyTypes
import Sparks
import Actions
import pocimac
import Breakings
import ItemTypes
import darfuncs
import Auras
import EnmGenRnd
import AuxFuncs
import GenFX
from math import pow
import CharStats
import copy
import EnemyNPCTypes
import QuiverTypes









# area 1 = 2nd cave inner
# area 2 = 2nd cave outer
# area 3 = cave bridge
# area 4 = indy window pri
# area 5 = indywindow sec
# area 6 = troll bridge pri
# area 7 = troll bridge sec
# area 8 = troll tunnel pri
# area 9 = sniper nook pri
# area 10 = sniper nook sec
# area 11 = indy slope bottom
# area 12 = sallypit pri
# area 13 = sallypit sec
# area 14 = darkarc pri
# area 15 = darkarc sec
# area 16 = ck pri
# area 17 = ck sec
# area 18 = vamp pri
# area 19 = vamp sec
# area 20 = cathedral door inner
# area 21 = cathedral door outer
# area 22 = cathedral door outer sec
# area 23 = FinYard North pri
# area 24 = FinYard North sec
# area 25 = FinYard South pri
# area 26 = FinYard South sec
# area 27 = KS cave pri
# area 28 = KS cave sec



BridgeCaveOrks=[]  # up to sulphur pits.
CliffCaveorks=[]   # two orks in the cave 
ColonyEnemies=[]
MazeEnemies=[]
CKMinions=[]
YardEnemies=[]
RunSkels=[]







########## actors


ork3D=Bladex.CreateEntity("Ork3D","Ork",-35509,4578,-18821,"Person")
ork3D.Angle=4.6
ork3D.Data=EnemyNPCTypes.ConquestOrk(ork3D)
ork3D.Blind=1
ork3D.Deaf=1



pers=Bladex.CreateEntity("DramaSkel1","Spidersmall",24000,-18500,2000,"Person")
pers.Angle=5
pers.Level=1
pers.Scale=4
pers.Blind       = 1
pers.Deaf        = 1
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)



o=Bladex.CreateEntity("Drama1","Skull",25000,-17500,1500,"Physic")
o.Scale=1
o.Orientation=0.7,0.7,0,0
o.Static=1
o.SelfIlum=1



ddal=Bladex.CreateEntity("DramaDal1","DalGurak",198500,6000,-60000,"Person")
ddal.Angle=0
ddal.Blind       = 1
ddal.Deaf        = 1
ddal.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(ddal)
ddal.Freeze()




############################# 1st Cave with single orc #sup3ork

Ork1Act=0

ork1=Bladex.CreateEntity("Ork1","Ork",-55000, 800,-23000,"Person")
ork1.Angle=4.2
ork1.Level=8
ork1.SetOnFloor()
o=Bladex.CreateEntity("Ork1WP","Garrote",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork1.Name,o.Name)
ork1.Data=EnemyNPCTypes.ConquestOrk(ork1)
darfuncs.HideBadGuy("Ork1")
BridgeCaveOrks.append(ork1.Name)
ork1.Data.DeathFunc=BridgeCaveOrkDead


ork2=Bladex.CreateEntity("Ork2","Ork",-22245,7655,-15661,"Person")
ork2.Angle=1.7
ork2.Level=6
o=Bladex.CreateEntity("Ork2BW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork2.Name,o.Name)
o=Bladex.CreateEntity("Ork2QV","CarcajEnvenenado",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(ork2.Name,o.Name)
o=Bladex.CreateEntity("Ork2WP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork2.Name,o.Name)
o=Bladex.CreateEntity("Orc2POT","Pocima100",0,0,0,"Physic")
o.Scale=1
pocimac.CreatePotion(o.Name)
Actions.TakeObject(ork2.Name,o.Name)
ork2.Data=EnemyNPCTypes.ConquestOrk(ork2)
ork2.ActionAreaMin=pow( 2,1 ) 
ork2.ActionAreaMax=pow( 2,2 ) 
ork2.SetOnFloor()
darfuncs.HideBadGuy("Ork2")
BridgeCaveOrks.append(ork2.Name)
ork2.Data.DeathFunc=BridgeCaveOrkDead



ork3=Bladex.CreateEntity("Ork3","Ork",-18401,7931,-15845,"Person")
ork3.Angle=0
ork3.Level=8
o=Bladex.CreateEntity("Ork3WP","Garrote",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork3.Name,o.Name)
o=Bladex.CreateEntity("Ork3SH","Escudo1",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork3.Name,o.Name)
ork3.Data=EnemyNPCTypes.ConquestOrk(ork3)
ork3.ActionAreaMin=pow( 2,1 ) 
ork3.ActionAreaMax=pow( 2,2 ) 
ork3.SetOnFloor()
darfuncs.HideBadGuy("Ork3")
BridgeCaveOrks.append(ork3.Name)
ork3.Data.DeathFunc=BridgeCaveOrkDead



ork4=Bladex.CreateEntity("Ork4","Ork",-19000, 11800,-26000,"Person")
ork4.Angle=5
ork4.Level=9
ork4.SetOnFloor()
o=Bladex.CreateEntity("Ork4WP","Espadaelfica",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork4.Name,o.Name)
o=Bladex.CreateEntity("Ork4SH","Escudo5",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork4.Name,o.Name)
ork4.Data=EnemyNPCTypes.ConquestOrk(ork4)
ork4.ActionAreaMin=pow( 2,0 ) 
ork4.ActionAreaMax=pow( 2,1 ) 
darfuncs.HideBadGuy("Ork4")
BridgeCaveOrks.append(ork4.Name)
ork4.Data.DeathFunc=BridgeCaveOrkDead






################### Cave across jump 

ork5=Bladex.CreateEntity("Ork5","Ork",-7000, 6000,-1000,"Person")
ork5.Angle=3
ork5.Level=8
ork5.SetOnFloor()
bowtop1=Bladex.CreateEntity("Ork5BW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bowtop1)
Actions.TakeObject(ork5.Name,bowtop1.Name)
quivertop1=Bladex.CreateEntity("Ork5QV","CarcajEnvenenado",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(quivertop1) 
Actions.TakeObject(ork5.Name,quivertop1.Name)
swordtop1=Bladex.CreateEntity("Ork5WP","Espadaelfica",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(swordtop1)
Actions.TakeObject(ork5.Name,swordtop1.Name)
ork5.Data=EnemyNPCTypes.ConquestOrk(ork5)
darfuncs.HideBadGuy("Ork5")
CliffCaveorks.append(ork5.Name)
ork5.Data.DeathFunc=CliffCaveOrkDead



gok1=Bladex.CreateEntity("GreatOrk1","Great_Ork",1000, 6000, -3000,"Person")
gok1.Angle=0
gok1.Level=8
o=Bladex.CreateEntity("GreatOrk1WP","Hacha5",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("GreatOrk1SH","Escudo2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(gok1.Name,"GreatOrk1WP")
Actions.TakeObject(gok1.Name,"GreatOrk1SH")
gok1.Data=EnemyNPCTypes.ConquestOrk(gok1)
gok1.SetOnFloor()
darfuncs.HideBadGuy("GreatOrk1")
CliffCaveorks.append(gok1.Name)
gok1.Data.DeathFunc=CliffCaveOrkDead


### sulfur pit ork 

gok2=Bladex.CreateEntity("GreatOrk2","Great_Ork",-5000, 11000, -24000,"Person")
gok2.Level=11
gok2.Angle=5

o=Bladex.CreateEntity("GreatOrk2WP","Martillo2",0,0,0,"Weapon")
o.Scale=1
Actions.TakeObject(gok2.Name,o.Name)
o=Bladex.CreateEntity("GreatOrk2SH","Escudo2",0,0,0,"Weapon")
Actions.TakeObject(gok2.Name,o.Name)
gate4key=Bladex.CreateEntity("PitKey","Llavecutre",0,0,0,"Physic")    
gate4key.Scale=1.0
darfuncs.SetHint(gate4key,"Pit Key")
Actions.TakeObject(gok2.Name,"PitKey")
gok2.Data=EnemyNPCTypes.ConquestOrk(gok2)
gok2.Data.DeathFunc=SulphurOrkDead
gok2.SetOnFloor()
darfuncs.HideBadGuy(gok2.Name)


o=Bladex.CreateEntity("Spect1","Espectro",-66500, 45500, -48500,"Physic")
o.Scale=3.5
o.Orientation=0.495618,0.504344,-0.495618,0.504344
darfuncs.ObjAlpha(o,0.2,0.8)

o=Bladex.CreateEntity("Spect2","Espectro",-66500, 45500, -46500,"Physic")
o.Scale=3.5
o.Orientation=0.495618,0.504344,-0.495618,0.504344
darfuncs.ObjAlpha(o,0.2,0.8)

min1=Bladex.CreateEntity("Min1","Minotaur",5500, 26800, -48000,"Person")
min1.Angle=6
min1.Level=7
o=Bladex.CreateEntity("Min1WP","Mazapiedra",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(min1.Name,"Min1WP")
min1.Data=EnemyNPCTypes.ConquestMinotaur(min1)
min1.SetOnFloor()
darfuncs.HideBadGuy(min1.Name)
min1.Data.DeathFunc=FirstMinoDead

############## Knightshade Skels

ksskel1=Bladex.CreateEntity("KSSkel1","Skeleton",-76933,30182+1700,-46141, "Person")
ksskel1.Angle=4.46
ksskel1.Level=5
ksskel1.Data=EnemyNPCTypes.SlimeySkeleton(ksskel1)
o=Bladex.CreateEntity("KSSkel1WP","Maza2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Reference.EntitiesObjectData[o.Name]=copy.copy( Reference.DefaultObjectData["Espadaelfica"])
Reference.EntitiesSelectionData[o.Name]=()
o=Bladex.CreateEntity("KSSkel1SH","Escudo1",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Reference.EntitiesSelectionData[o.Name]=()
Actions.TakeObject("KSSkel1","KSSkel1WP")
Actions.TakeObject("KSSkel1","KSSkel1SH")
darfuncs.HideBadGuy("KSSkel1")
ksskel1.Data.DeathFunc=SlimeSkelDead
ksskel1.ActionAreaMin=pow( 2,26 ) 
ksskel1.ActionAreaMax=pow( 2,27 ) 
ksskel1.Data.Resistances= copy.copy(CharStats.GetCharResistances("DarkSkel"))

ksskel2=Bladex.CreateEntity("KSSkel2","Skeleton",-74787,30486+1700,-42627, "Person")
ksskel2.Angle=4.46
ksskel2.Level=6
ksskel2.Data=EnemyNPCTypes.SlimeySkeleton(ksskel2)
o=Bladex.CreateEntity("KSSkel2WP","Dagesse",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Reference.EntitiesObjectData[o.Name]= copy.copy(Reference.DefaultObjectData["Espadaelfica"])
Reference.EntitiesSelectionData[o.Name]=()
o=Bladex.CreateEntity("KSSkel2SH","Escudo1",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Reference.EntitiesSelectionData[o.Name]=()
Actions.TakeObject("KSSkel2","KSSkel2WP")
Actions.TakeObject("KSSkel2","KSSkel2SH")
darfuncs.HideBadGuy("KSSkel2")
ksskel2.Data.DeathFunc=SlimeSkelDead
ksskel2.ActionAreaMin=pow( 2,26 ) 
ksskel2.ActionAreaMax=pow( 2,27 ) 
ksskel2.Data.Resistances= copy.copy(CharStats.GetCharResistances("DarkSkel"))

ksskel3=Bladex.CreateEntity("KSSkel3","Skeleton",-73100,30671+1700,-39995, "Person")
ksskel3.Angle=4.46
ksskel3.Level=7
ksskel3.Data=EnemyNPCTypes.SlimeySkeleton(ksskel3)
o=Bladex.CreateEntity("KSSkel3WP","Hacha5",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Reference.EntitiesObjectData[o.Name]= Reference.DefaultObjectData["Espadaelfica"]
Reference.EntitiesSelectionData[o.Name]=()
o=Bladex.CreateEntity("KSSkel3SH","Escudo1",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Reference.EntitiesSelectionData[o.Name]=()
Actions.TakeObject("KSSkel3","KSSkel3WP")
Actions.TakeObject("KSSkel3","KSSkel3SH")
darfuncs.HideBadGuy("KSSkel3")
ksskel3.Data.DeathFunc=SlimeSkelDead
ksskel3.ActionAreaMin=pow( 2,26 ) 
ksskel3.ActionAreaMax=pow( 2,27 ) 
ksskel3.Data.Resistances= copy.copy(CharStats.GetCharResistances("DarkSkel"))


############# Ork at Indy-window winork

ork6=Bladex.CreateEntity("Ork6","Ork",13200, 12000,-34500,"Person")
ork6.Angle=0   
ork6.Level=11
ork6.SetOnFloor()
o=Bladex.CreateEntity("Ork6BW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6.Name,o.Name)
o=Bladex.CreateEntity("Ork6QV","CarcajEnvenenado",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(o) 
Actions.TakeObject(ork6.Name,o.Name)
o=Bladex.CreateEntity("Ork6WP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6.Name,o.Name)
ork6.Data=EnemyNPCTypes.ConquestOrk(ork6)
ork6.ActionAreaMin=pow( 2,3 ) 
ork6.ActionAreaMax=pow( 2,4 ) 
darfuncs.HideBadGuy("Ork6")

# archers in alcoves

ork6a=Bladex.CreateEntity("Ork6a","Ork",-29647,19015,-37509,"Person")
ork6a.Angle=4.5   
ork6a.Level=6
ork6a.SetOnFloor()
o=Bladex.CreateEntity("Ork6aBW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6a.Name,o.Name)
o=Bladex.CreateEntity("Ork6aQV","Carcaj",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(o) 
Actions.TakeObject(ork6a.Name,o.Name)
o=Bladex.CreateEntity("Ork6aWP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6a.Name,o.Name)
ork6a.Data=EnemyNPCTypes.ConquestOrk(ork6a)
darfuncs.HideBadGuy("Ork6a")


ork6b=Bladex.CreateEntity("Ork6b","Ork",-25847,19015,-28509,"Person")
ork6b.Angle=4
ork6b.Level=5
ork6b.SetOnFloor()
o=Bladex.CreateEntity("Ork6bBW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6b.Name,o.Name)
o=Bladex.CreateEntity("Ork6bQV","Carcaj",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(o) 
Actions.TakeObject(ork6b.Name,o.Name)
o=Bladex.CreateEntity("Ork6bWP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6b.Name,o.Name)
ork6b.Data=EnemyNPCTypes.ConquestOrk(ork6b)
darfuncs.HideBadGuy("Ork6b")


ork6c=Bladex.CreateEntity("Ork6c","Ork",-1500,17015,-50000,"Person")
ork6c.Angle=1
ork6c.Level=6
ork6c.SetOnFloor()
o=Bladex.CreateEntity("Ork6cBW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6c.Name,o.Name)
o=Bladex.CreateEntity("Ork6cQV","Carcaj",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(o) 
Actions.TakeObject(ork6c.Name,o.Name)
o=Bladex.CreateEntity("Ork6cWP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6c.Name,o.Name)
ork6c.Data=EnemyNPCTypes.ConquestOrk(ork6c)
darfuncs.HideBadGuy("Ork6c")


ork6d=Bladex.CreateEntity("Ork6d","Ork",-1000,19015,-57500,"Person")
ork6d.Angle=1
ork6d.Level=5
ork6d.SetOnFloor()
o=Bladex.CreateEntity("Ork6dBW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6d.Name,o.Name)
o=Bladex.CreateEntity("Ork6dQV","Carcaj",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(o) 
Actions.TakeObject(ork6d.Name,o.Name)
o=Bladex.CreateEntity("Ork6dWP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork6d.Name,o.Name)
ork6d.Data=EnemyNPCTypes.ConquestOrk(ork6d)
darfuncs.HideBadGuy("Ork6d")






############ two orks on indy slope


ork7=Bladex.CreateEntity("Ork7","Ork",31000, 21000,-7000,"Person")
ork7.Angle=4
ork7.Level=11
ork7.SetOnFloor()
o=Bladex.CreateEntity("Ork7WP","Maza2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork7.Name,o.Name)
o=Bladex.CreateEntity("Ork7SH","Escudo4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork7.Name,o.Name)
ork7.Data=EnemyNPCTypes.ConquestOrk(ork7)
darfuncs.HideBadGuy("Ork7")


ork8=Bladex.CreateEntity("Ork8","Ork",31000, 21500,-4000,"Person")
ork8.Angle=4
ork8.Level=11
ork8.SetOnFloor()
o=Bladex.CreateEntity("Ork8WP","EgyptSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork8.Name,o.Name)
o=Bladex.CreateEntity("Ork8SH","Escudo4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork8.Name,o.Name)
ork8.Data=EnemyNPCTypes.ConquestOrk(ork8)
darfuncs.HideBadGuy("Ork8")


########### Poison Colony

## First on slope

gok3=Bladex.CreateEntity("GreatOrk3", "Great_Ork",28500, 27800, -22000,"Person")
gok3.Angle=0
gok3.Level=15
gok3.SetOnFloor()
o=Bladex.CreateEntity("GreatOrk3WP","Cimitarra",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("GreatOrk3SH","Escudo9",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o.Scale=1.25
Actions.TakeObject(gok3.Name,"GreatOrk3WP")
Actions.TakeObject(gok3.Name,"GreatOrk3SH")
gok3.Data=EnemyNPCTypes.ConquestOrk(gok3)
darfuncs.HideBadGuy("GreatOrk3")
ColonyEnemies.append("GreatOrk3")
gok3.Data.DeathFunc=ColonyOrkDead


### archer on bridge

ork9=Bladex.CreateEntity("Ork9","Ork", 7000, 32800, 2000,"Person")
ork9.Angle=4.2
ork9.Level=10
ork9.SetOnFloor()
o=Bladex.CreateEntity("Ork9BW","Arco3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork9.Name,o.Name)
o=Bladex.CreateEntity("Ork9QV","CarcajEnvenenado",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(ork9.Name,o.Name)
o=Bladex.CreateEntity("Ork9WP","EgyptSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork9.Name,o.Name)
o=Bladex.CreateEntity("Ork9SH","Escudo4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork9.Name,o.Name)
o=Bladex.CreateEntity("Ork9POT","Pocima100",0,0,0,"Physic")
o.Scale=1.0
pocimac.CreatePotion(o.Name)
Actions.TakeObject(ork9.Name,o.Name)
ork9.Data=EnemyNPCTypes.ConquestOrk(ork9)
ork9.ActionAreaMin=pow( 2,5 ) 
ork9.ActionAreaMax=pow( 2,6 ) 
darfuncs.HideBadGuy("Ork9")
ColonyEnemies.append("Ork9")
ork9.Data.DeathFunc=ColonyOrkDead

###### first cave

ork10=Bladex.CreateEntity("Ork10","Ork",3500, 38800,-12000,"Person")
ork10.Angle=4
ork10.Level=10

o=Bladex.CreateEntity("Ork10WP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork10.Name,o.Name)
o=Bladex.CreateEntity("Ork10SH","Escudo4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork10.Name,o.Name)
ork10.Data=EnemyNPCTypes.ConquestOrk(ork10)
ork10.SetOnFloor()
ork10.Freeze()
ork10.Blind=1
ork10.Deaf=1
ColonyEnemies.append("Ork10")
ork10.Data.DeathFunc=ColonyOrkDead

gok4=Bladex.CreateEntity("GreatOrk4","Great_Ork",7000, 38800,-12500,"Person")
gok4.Angle=4.5
gok4.Level=11
o=Bladex.CreateEntity("GreatOrk4WP","EgyptSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(gok4.Name,o.Name)
o=Bladex.CreateEntity("GreatOrk4SH","Escudo4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(gok4.Name,o.Name)
brgate1key=Bladex.CreateEntity("BridgeKey","Llavecutre",0,0,0,"Physic")    
brgate1key.Scale=1.0
darfuncs.SetHint(brgate1key,"Bridge Key")
Actions.TakeObject(gok4.Name,"BridgeKey")
gok4.Data=EnemyNPCTypes.ConquestOrk(gok4)
gok4.SetOnFloor()
gok4.Freeze()
gok4.Blind=1
gok4.Deaf=1
ColonyEnemies.append("GreatOrk4")
gok4.Data.DeathFunc=ColonyOrkDead

ork11=Bladex.CreateEntity("Ork11","Ork",5500, 38000,-16000,"Person")
ork11.Angle=4.6
ork11.Level=10
o=Bladex.CreateEntity("Ork11WP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork11.Name,o.Name)
o=Bladex.CreateEntity("Ork11SH","Escudo5",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork11.Name,o.Name)
ork11.Data=EnemyNPCTypes.ConquestOrk(ork11)
ork11.SetOnFloor()
ork11.Freeze()
ork11.Blind=1
ork11.Deaf=1
ColonyEnemies.append("Ork11")
ork11.Data.DeathFunc=ColonyOrkDead

### Boss Ork

gok5=Bladex.CreateEntity("GreatOrk5","Great_Ork",-21000, 39000, -4000,"Person")
gok5.Angle=5.0
gok5.Level=15
o=Bladex.CreateEntity("GreatOrk5WP","Maza3",0,0,0,"Weapon")
o.Scale=1.1
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("GreatOrk5SH","Escudo9",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(gok5.Name,"GreatOrk5WP")
Actions.TakeObject(gok5.Name,"GreatOrk5SH")
gok5.Data=EnemyNPCTypes.ConquestOrk(gok5)
gok5.SetOnFloor()
darfuncs.HideBadGuy(gok5.Name)
ColonyEnemies.append("GreatOrk5")
gok5.Data.DeathFunc=ColonyOrkDead

###### sniper ork


ork12=Bladex.CreateEntity("Ork12","Ork",-35500, 30800, -19000,"Person")
ork12.Angle=5
ork12.Level=14
ork12.SetOnFloor()
o=Bladex.CreateEntity("Ork12BW","Arco2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork12.Name,o.Name)
o=Bladex.CreateEntity("Ork12QV","CarcajEnvenenado",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(ork12.Name,o.Name)
o=Bladex.CreateEntity("Ork12WP","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork12.Name,o.Name)
ork12.Data=EnemyNPCTypes.ConquestOrk(ork12)
ork12.ActionAreaMin=pow( 2,8 ) 
ork12.ActionAreaMax=pow( 2,9 ) 
darfuncs.HideBadGuy("Ork12")
ColonyEnemies.append("Ork12")
ork12.Data.DeathFunc=ColonyOrkDead

######################### Cave on right


gok6=Bladex.CreateEntity("GreatOrk6","Great_Ork",-35000, 39800, 8500,"Person")
gok6.Level=12
gok6.Angle=4.5
o=Bladex.CreateEntity("GreatOrk6WP","Espadacurva",0,0,0,"Weapon")
Actions.TakeObject(gok6.Name,o.Name)
o=Bladex.CreateEntity("GreatOrk6SH","Escudo4",0,0,0,"Weapon")
Actions.TakeObject("GreatOrk6",o.Name)
gok6.Data=EnemyNPCTypes.ConquestOrk(gok6)
gok6.SetOnFloor()
darfuncs.HideBadGuy(gok6.Name)
ColonyEnemies.append("GreatOrk6")
gok6.Data.DeathFunc=ColonyOrkDead


ork13=Bladex.CreateEntity("Ork13","Ork",-34500, 39800, 16000,"Person")
ork13.Level=12
ork13.Angle=4.0
o=Bladex.CreateEntity("Ork13WP","EgyptSword",0,0,0,"Weapon")
Actions.TakeObject(ork13.Name,o.Name)
o=Bladex.CreateEntity("Ork13SH","Escudo4",0,0,0,"Weapon")
Actions.TakeObject(ork13.Name,o.Name)
ork13.Data=EnemyNPCTypes.ConquestOrk(ork13)
ork13.SetOnFloor()
darfuncs.HideBadGuy(ork13.Name)
ColonyEnemies.append("Ork13")
ork13.Data.DeathFunc=ColonyOrkDead


################## last cave

ork14=Bladex.CreateEntity("Ork14","Ork",-44000, 35000,-48000,"Person")
ork14.Angle=3.2
ork14.Level=14
ork14.SetOnFloor()
o=Bladex.CreateEntity("Ork14WP","Hacha3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork14.Name,o.Name)
o=Bladex.CreateEntity("Ork14SH","Escudo4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork14.Name,o.Name)
ork14.Data=EnemyNPCTypes.ConquestOrk(ork14)
darfuncs.HideBadGuy("Ork14")
ColonyEnemies.append("Ork14")
ork14.Data.DeathFunc=ColonyOrkDead

gok7=Bladex.CreateEntity("GreatOrk7","Great_Ork",-44000, 39800, -41000,"Person")
gok7.Level=13
gok7.Angle=4
o=Bladex.CreateEntity("GreatOrk7WP","Espadacurva",0,0,0,"Weapon")
Actions.TakeObject(gok7.Name,o.Name)
o=Bladex.CreateEntity("GreatOrk7SH","Escudo9",0,0,0,"Weapon")
Actions.TakeObject(gok7.Name,o.Name)
gok7.Data=EnemyNPCTypes.ConquestOrk(gok7)
gok7.SetOnFloor()
darfuncs.HideBadGuy(gok7.Name)
ColonyEnemies.append("GreatOrk7")
gok7.Data.DeathFunc=ColonyOrkDead


#### outside

ork15=Bladex.CreateEntity("Ork15","Ork",-31235,39015,-8428,"Person")
ork15.Angle=1.2
ork15.Level=12
ork15.SetOnFloor()
o=Bladex.CreateEntity("Ork15WP","Hacha3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork15.Name,o.Name)
ork15.Data=EnemyNPCTypes.ConquestOrk(ork15)
darfuncs.HideBadGuy("Ork15")
ColonyEnemies.append("Ork15")
ork15.Data.DeathFunc=ColonyOrkDead

ork16=Bladex.CreateEntity("Ork16","Ork",-38294,38929,-31264,"Person")
ork16.Angle=5.2
ork16.Level=12
ork16.SetOnFloor()
o=Bladex.CreateEntity("Ork16WP","EgyptSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(ork16.Name,o.Name)
ork16.Data=EnemyNPCTypes.ConquestOrk(ork16)
darfuncs.HideBadGuy("Ork16")
ColonyEnemies.append("Ork16")
ork16.Data.DeathFunc=ColonyOrkDead


############################ Trolls 

troll1=Bladex.CreateEntity("Troll1","Troll_Dark",27000, 32800,8500,"Person")
troll1.Angle=3
troll1.Level=9
troll1.Scale=1
o=Bladex.CreateEntity("Troll1WP","Hachacarnicero",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(troll1.Name,o.Name)
troll1.Data=EnemyNPCTypes.ConquestTroll(troll1)
troll1.SetOnFloor()
troll1.ActionAreaMin=pow( 2,7 ) 
troll1.ActionAreaMax=pow( 2,6 ) 
darfuncs.HideBadGuy("Troll1")



troll2=Bladex.CreateEntity("Troll2","Troll_Dark",38000, 32800,21000,"Person")
troll2.Angle=3
troll2.Level=10
troll2.Scale=1
troll2.SetOnFloor()
o=Bladex.CreateEntity("Troll2WP","Hachacarnicero",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(troll2.Name,o.Name)
troll2.Data=EnemyNPCTypes.ConquestTroll(troll2)
troll2.ActionAreaMin=pow( 2,7 ) 
troll2.ActionAreaMax=pow( 2,6 ) 
darfuncs.HideBadGuy("Troll2")


troll3=Bladex.CreateEntity("Troll3","Troll_Dark",52000, 32800,26000,"Person")
troll3.Angle=3
troll3.Level=12
troll3.Scale=1
troll3.SetOnFloor()
o=Bladex.CreateEntity("Troll3WP","Mazapiedra",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(troll3.Name,o.Name)
troll3.Data=EnemyNPCTypes.ConquestTroll(troll3)
troll3.ActionAreaMin=pow( 2,7 ) 
troll3.ActionAreaMax=pow( 2,6 ) 
darfuncs.HideBadGuy("Troll3")

########## Door Mino Mazapiedra

min2=Bladex.CreateEntity("Min2","Minotaur",28000, 39800, -3000,"Person")
min2.Angle=2
min2.Level=13
o=Bladex.CreateEntity("Min2WP","HookSword",0,0,0,"Weapon")
o.Scale=2.0
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(min2.Name,o.Name)
min2.Data=EnemyNPCTypes.ConquestMinotaur(min2)
min2.SetOnFloor()
darfuncs.HideBadGuy("Min2")
min2.Data.DeathFunc=OpenMazeGate


######## Golem 


Bladex.AddCombustionDataFor("Golem_lava", "GreenFire", 250, 400, 4, 1, 3, 144000) 

grgolem=Bladex.CreateEntity("GreenGolem", "Golem_stone", -100000,439823,24000, "Person")
grgolem.Angle=4.5
grgolem.Level=18
grgolem.Data=EnemyNPCTypes.AcidGolem(grgolem)
grgolem.Data.DeathFunc=GreenGolemDead
grgolem.Data.Hide()

grgolemtarget=Bladex.CreateEntity("GreenGolemTarget", "Canica", -70348,39000,-11187)
grgolemtarget.Alpha=0.0
grgolemtarget.CastShadows=0



############ Spiders

sidestep = 500
sgap = 2000
for arachnid in range (6):
	pers=Bladex.CreateEntity("spider" +str(arachnid),"Spidersmall", -110500+sgap, 39800, 20000+arachnid*500,"Person")
	pers.Angle=3
	pers.Level=17
	pers.Blind       = 1
	pers.Deaf        = 1
	EnemyTypes.EnemyDefaultFuncs(pers)
	pers.SetOnFloor()
	darfuncs.HideBadGuy(pers.Name)
	sgap = sgap * -1



###################### Maze ###############################
########################################################################################


pers=Bladex.CreateEntity("Skeleton1","Skeleton",67500,38600,-2500,"Person")
pers.Angle=4.5
pers.Level=15
o=Bladex.CreateEntity("Islandesp2","FireSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("IslandEscudo2","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Islandesp2")
Actions.TakeObject(pers.Name,"IslandEscudo2")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
pers.Freeze()
pers.Blind=1
pers.Deaf=1
MazeEnemies.append("Skeleton1")


pers=Bladex.CreateEntity("Skeleton3","Skeleton",81500,39000,10000,"Person")
pers.Angle=3
pers.Level=13
o=Bladex.CreateEntity("Islandesp3","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("IslandEscudo3","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Islandesp3")
Actions.TakeObject(pers.Name,"IslandEscudo3")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton3")



pers=Bladex.CreateEntity("Skeleton33","Skeleton",91500,39000,-6000,"Person")
pers.Angle=1
pers.Level=14
o=Bladex.CreateEntity("landesp3","Hacha6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("landEscudo3","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"landesp3")
Actions.TakeObject(pers.Name,"landEscudo3")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton33")




pers=Bladex.CreateEntity("Skeleton4","Skeleton",56500,39000,18000,"Person")
pers.Angle=3
pers.Level=14
o=Bladex.CreateEntity("Islandesp4","Hacha4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("IslandEscudo4","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Islandesp4")
Actions.TakeObject(pers.Name,"IslandEscudo4")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton4")



pers=Bladex.CreateEntity("Skeleton5","Skeleton",111500,39000,10000,"Person")
pers.Angle=3
pers.Level=15
o=Bladex.CreateEntity("Islandesp5","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("IslandEscudo5","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Islandesp5")
Actions.TakeObject(pers.Name,"IslandEscudo5")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton5")



pers=Bladex.CreateEntity("Skeleton6","Skeleton",106500,39000,22000,"Person")
pers.Angle=1
pers.Level=15
o=Bladex.CreateEntity("Islandesp6","Dagesse",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("IslandEscudo6","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Islandesp6")
Actions.TakeObject(pers.Name,"IslandEscudo6")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton6")




pers=Bladex.CreateEntity("Skeleton7","Skeleton",96500,39000,41500,"Person")
pers.Angle=3
pers.Level=15
o=Bladex.CreateEntity("ndesp","Dagesse",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("ndEscudo","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"ndesp")
Actions.TakeObject(pers.Name,"ndEscudo")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton7")



pers=Bladex.CreateEntity("Skeleton8","Skeleton",81500,39000,42000,"Person")
pers.Angle=1
pers.Level=15
o=Bladex.CreateEntity("Isp","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("Isdo","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Isp")
Actions.TakeObject(pers.Name,"Isdo")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton8")


pers=Bladex.CreateEntity("Skeleton9","Skeleton",86500,39000,54000,"Person")
pers.Angle=1
pers.Level=13
o=Bladex.CreateEntity("I3","Hacha6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
o=Bladex.CreateEntity("IE3","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"I3")
Actions.TakeObject(pers.Name,"IE3")
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton9")


pers=Bladex.CreateEntity("Skeleton10","Skeleton",56000,39000,62000,"Person")
pers.Angle=4.5
pers.Level=14
o=Bladex.CreateEntity("I4","HookSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("IE4","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton10")


pers=Bladex.CreateEntity("Skeleton11","Skeleton",106000,39000,58000,"Person")
pers.Angle=7
pers.Level=17
o=Bladex.CreateEntity("newskw1","HookSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh1","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton11")


pers=Bladex.CreateEntity("Skeleton12","Skeleton",85000,39000,61000,"Person")
pers.Angle=3.8
pers.Level=17
o=Bladex.CreateEntity("newskw2","HookSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh2","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton12")


pers=Bladex.CreateEntity("Skeleton13","Skeleton",116000,38000,65000,"Person")
pers.Angle=0
pers.Level=17
o=Bladex.CreateEntity("newskw3","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh3","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton13")


pers=Bladex.CreateEntity("Skeleton14","Skeleton",111000,38000,54000,"Person")
pers.Angle=5
pers.Level=17
o=Bladex.CreateEntity("newskw4","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh4","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton14")


pers=Bladex.CreateEntity("Skeleton15","Skeleton",80500,39000,65000,"Person")
pers.Angle=3.8
pers.Level=17
o=Bladex.CreateEntity("newskw2","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh2","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton15")


######################### Burning Skeletons


Bladex.AddCombustionDataFor("Skeleton", "Fire", 250, 400, 4, 1, 3, 144000) # se extingira en 40 horas!

generadorBrnSkl = EnmGenRnd.CreateEnemiesGenerator(3, 1)
generadorBrnSkl.Level = 17

generadorBrnSkl.AddPoint((111500, 35900, 38000),("BrnSkl1", "Skeleton", "DoubleSword", 0, "KingShield", 1), "Skl_appears1")

generadorBrnSkl.InitGenFunc=GenerateBurnSkl
generadorBrnSkl.DifTime = 0.6
generadorBrnSkl.FinishGenFunc = finGeneraFuego
generadorBrnSkl.Activate()



############################## Zombies


pers=Bladex.CreateEntity("maz1","Knight_Zombie",76500, 38800, 23000,"Person")
pers.Angle=0
pers.Level=15
o=Bladex.CreateEntity("mtool","Hacha5",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("maz1")


pers=Bladex.CreateEntity("maz2","Knight_Zombie",91500, 38800, 22000,"Person")
pers.Angle=2
pers.Level=15
o=Bladex.CreateEntity("mtool2","Hacha4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("maz2")


pers=Bladex.CreateEntity("maz3","Knight_Zombie",91000, 38800, 6000,"Person")
pers.Angle=3
pers.Level=15
o=Bladex.CreateEntity("mtool3","Hacha4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("maz3")


pers=Bladex.CreateEntity("maz4","Knight_Zombie",67000, 38800, 34000,"Person")
pers.Angle=4.5
pers.Level=15
o=Bladex.CreateEntity("mtool4","Maza2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,o.Name)
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("maz4")


########## little demons


pers=Bladex.CreateEntity("ldm1","Little_Demon",137000, 34000, 66000,"Person")
pers.Angle=3
pers.Level=15
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("ldm1")

pers=Bladex.CreateEntity("ldm2","Little_Demon",145000, 34000, 66000,"Person")
pers.Angle=3
pers.Level=15
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("ldm2")




########## Salamanders

sal1=Bladex.CreateEntity("Sally1","Salamander",53225,39236,-23934,"Person")
sal1.Angle=4
sal1.Level=15
sal1.SetOnFloor()
sal1.Data=EnemyNPCTypes.ConquestSalamander(sal1)
darfuncs.HideBadGuy("Sally1")
sal1.Data.DeathFunc=SallyDead
#sal1.ActionAreaMin=pow( 2,11 ) 
#sal1.ActionAreaMax=pow( 2,12 ) 

sal2=Bladex.CreateEntity("Sally2","Salamander",69025,39236,-23934,"Person")
sal2.Angle=1.2
sal2.Level=15
sal2.SetOnFloor()
sal2.Data=EnemyNPCTypes.ConquestSalamander(sal2)
darfuncs.HideBadGuy("Sally2")
sal2.Data.DeathFunc=SallyDead
#sal2.ActionAreaMin=pow( 2,11 ) 
#sal2.ActionAreaMax=pow( 2,12 ) 


######## Lava Pit and Beyond


#### snipers

dk1=Bladex.CreateEntity("DarkKnight1","Dark_Knight",71500, 35800, -53000,"Person")
dk1.Angle=1
dk1.Level=5
dk1.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk1)
o=Bladex.CreateEntity("DarkKnight1BW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(dk1.Name,o.Name)
o=Bladex.CreateEntity("DarkKnight1QV","CarcajFuego",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs (o)
o.Data.SetNumberOfArrows(4, pers.Name)
Actions.TakeObject(dk1.Name,o.Name)
o=Bladex.CreateEntity("DarkKnight1WP","Dagesse",0,0,0,"Weapon")
o.Scale=1.2
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk1.Name,"DarkKnight1WP")
dk1.Blind       = 1
dk1.Deaf        = 1
dk1.SetOnFloor()
dk1.Freeze()



dk2=Bladex.CreateEntity("DarkKnight2","Dark_Knight",51000, 35800, -53000,"Person")
dk2.Angle=5
dk2.Level=5
dk2.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk2)
o=Bladex.CreateEntity("DarkKnight2BW","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(dk2.Name,o.Name)
o=Bladex.CreateEntity("DarkKnight2QV","CarcajFuego",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs (o)
o.Data.SetNumberOfArrows(4, pers.Name)
Actions.TakeObject(dk2.Name,o.Name)
o=Bladex.CreateEntity("DarkKnight2WP","Dagesse",0,0,0,"Weapon")
o.Scale=1.2
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk2.Name,"DarkKnight2WP")
dk2.Blind       = 1
dk2.Deaf        = 1
dk2.SetOnFloor()
dk2.Freeze()



##### big guy


ck1=Bladex.CreateEntity("BigGuy","ChaosKnight",61000,38600,-62000, "Person")
ck1.Scale=1.0
ck1.Angle=0.0
ck1.Level=19
ck1.Data=EnemyNPCTypes.ConquestChaosKnight(ck1)
ck1.Data.DamageFactorNone=0.15
ck1.Data.DamageFactorLight=0.35
ck1.Data.DamageFactorHeavy=0.35
ck1.Data.PrepareWeapons("Espadon", "Escudon")
ck1.Data.RWeapon="Espadon"+ck1.Name
ck1.Data.LWeapon="Escudon"+ck1.Name
ck1.Data.Deathfunc=BigGuyDead
ck1.SetOnFloor()
ck1.Freeze()
ck1.ActionAreaMin=pow(2,15)
ck1.ActionAreaMax=pow(2,16)


##### minions

dk3=Bladex.CreateEntity("DarkKnight3","Dark_Knight",73000, 39000, -65000,"Person")
dk3.Angle=1
dk3.Level=6
dk3.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk3)
o=Bladex.CreateEntity("DarkKnight3WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk3.Name,"DarkKnight3WP")
Reference.EntitiesObjectData["DarkKnight3WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight3SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk3.Name,"DarkKnight3SH")
dk3.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight3")
CKMinions.append("DarkKnight3")
dk3.Data.DeathFunc=DKDED
dk3.ActionAreaMin=pow(2,16)
dk3.ActionAreaMax=pow(2,15)

dk4=Bladex.CreateEntity("DarkKnight4","Dark_Knight",48000, 39000, -65000,"Person")
dk4.Angle=4
dk4.Level=6
dk4.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk4)
o=Bladex.CreateEntity("DarkKnight4WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk4.Name,"DarkKnight4WP")
Reference.EntitiesObjectData["DarkKnight4WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight4SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk4.Name,"DarkKnight4SH")
dk4.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight4")
CKMinions.append("DarkKnight4")
dk4.Data.DeathFunc=DKDED
dk4.ActionAreaMin=pow(2,16)
dk4.ActionAreaMax=pow(2,15)

##### frozen

dk5=Bladex.CreateEntity("DarkKnight5","Dark_Knight",73000,38640,-58860,"Person")
dk5.Angle=3
dk5.Level=6
dk5.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk5)
o=Bladex.CreateEntity("DarkKnight5WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk5.Name,"DarkKnight5WP")
Reference.EntitiesObjectData["DarkKnight5WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight5SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk5.Name,"DarkKnight5SH")
dk4.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight5")
CKMinions.append("DarkKnight5")
dk5.Data.DeathFunc=DKDED
dk5.ActionAreaMin=pow(2,16)
dk5.ActionAreaMax=pow(2,15)
o=Bladex.CreateEntity("DarkKnight5Statue","DknStatue",73000,38640,-58860)
o.Static=1
o.Scale=1.0
o.Orientation=(0.709,0.704,-0.0211,0.0039)





dk6=Bladex.CreateEntity("DarkKnight6","Dark_Knight",71500,38640,-58860,"Person")
dk6.Angle=3
dk6.Level=6
dk6.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk6)
o=Bladex.CreateEntity("DarkKnight6WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk6.Name,"DarkKnight6WP")
Reference.EntitiesObjectData["DarkKnight6WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight6SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk6.Name,"DarkKnight6SH")
dk6.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight6")
CKMinions.append("DarkKnight6")
dk6.Data.DeathFunc=DKDED
dk6.ActionAreaMin=pow(2,16)
dk6.ActionAreaMax=pow(2,15)
o=Bladex.CreateEntity("DarkKnight6Statue","DknStatue",71500,38640,-58860)
o.Static=1
o.Scale=1.0
o.Orientation=(0.709,0.704,-0.0211,0.0039)


dk7=Bladex.CreateEntity("DarkKnight7","Dark_Knight",69500,38640,-58860,"Person")
dk7.Angle=3
dk7.Level=6
dk7.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk7)
o=Bladex.CreateEntity("DarkKnight7WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk7.Name,"DarkKnight7WP")
Reference.EntitiesObjectData["DarkKnight7WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight7SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk7.Name,"DarkKnight7SH")
dk7.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight7")
CKMinions.append("DarkKnight7")
dk7.Data.DeathFunc=DKDED
dk7.ActionAreaMin=pow(2,16)
dk7.ActionAreaMax=pow(2,15)
o=Bladex.CreateEntity("DarkKnight7Statue","DknStatue",69500,38640,-58860)
o.Static=1
o.Scale=1.0
o.Orientation=(0.709,0.704,-0.0211,0.0039)


dk8=Bladex.CreateEntity("DarkKnight8","Dark_Knight",68000,38640,-58860,"Person")
dk8.Angle=3
dk8.Level=6
dk8.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk8)
o=Bladex.CreateEntity("DarkKnight8WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk8.Name,"DarkKnight8WP")
Reference.EntitiesObjectData["DarkKnight8WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight8SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk8.Name,"DarkKnight8SH")
dk8.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight8")
CKMinions.append("DarkKnight8")
dk8.Data.DeathFunc=DKDED
dk8.ActionAreaMin=pow(2,16)
dk8.ActionAreaMax=pow(2,15)
o=Bladex.CreateEntity("DarkKnight8Statue","DknStatue",68000,38640,-58860)
o.Static=1
o.Scale=1.0
o.Orientation=(0.709,0.704,-0.0211,0.0039)


##### west side


dk9=Bladex.CreateEntity("DarkKnight9","Dark_Knight",49000,38640,-58860,"Person")
dk9.Angle=3
dk9.Level=6
dk9.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk9)
o=Bladex.CreateEntity("DarkKnight9WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk9.Name,"DarkKnight9WP")
Reference.EntitiesObjectData["DarkKnight9WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight9SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk9.Name,"DarkKnight9SH")
dk9.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight9")
CKMinions.append("DarkKnight9")
dk9.Data.DeathFunc=DKDED
dk9.ActionAreaMin=pow(2,16)
dk9.ActionAreaMax=pow(2,15)
o=Bladex.CreateEntity("DarkKnight9Statue","DknStatue",49000,38640,-58860)
o.Static=1
o.Scale=1.0
o.Orientation=(0.709,0.704,-0.0211,0.0039)


dk10=Bladex.CreateEntity("DarkKnight10","Dark_Knight",50500,38640,-58860,"Person")
dk10.Angle=3
dk10.Level=6
dk10.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk10)
o=Bladex.CreateEntity("DarkKnight10WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk10.Name,"DarkKnight10WP")
Reference.EntitiesObjectData["DarkKnight10WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight10SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk10.Name,"DarkKnight10SH")
dk10.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight10")
CKMinions.append("DarkKnight10")
dk10.Data.DeathFunc=DKDED
dk10.ActionAreaMin=pow(2,16)
dk10.ActionAreaMax=pow(2,15)
o=Bladex.CreateEntity("DarkKnight10Statue","DknStatue",50500,38640,-58860)
o.Static=1
o.Scale=1.0
o.Orientation=(0.709,0.704,-0.0211,0.0039)


dk11=Bladex.CreateEntity("DarkKnight11","Dark_Knight",52000,38640,-58860,"Person")
dk11.Angle=3
dk11.Level=6
dk11.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk11)
o=Bladex.CreateEntity("DarkKnight11WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk11.Name,"DarkKnight11WP")
Reference.EntitiesObjectData["DarkKnight11WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight11SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk11.Name,"DarkKnight11SH")
dk11.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight11")
CKMinions.append("DarkKnight11")
dk11.Data.DeathFunc=DKDED
dk11.ActionAreaMin=pow(2,16)
dk11.ActionAreaMax=pow(2,15)
o=Bladex.CreateEntity("DarkKnight11Statue","DknStatue",52000,38640,-58860)
o.Static=1
o.Scale=1.0
o.Orientation=(0.709,0.704,-0.0211,0.0039)


dk12=Bladex.CreateEntity("DarkKnight12","Dark_Knight",54000,38640,-58860,"Person")
dk12.Angle=3
dk12.Level=6
dk12.Data=EnemyNPCTypes.ConquestKnight_Traitor(dk12)
o=Bladex.CreateEntity("DarkKnight12WP","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk12.Name,"DarkKnight12WP")
Reference.EntitiesObjectData["DarkKnight12WP"]=[Reference.OBJ_WEAPON,80, -80, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
o=Bladex.CreateEntity("DarkKnight12SH","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(dk12.Name,"DarkKnight12SH")
dk12.SetOnFloor()
darfuncs.HideBadGuy("DarkKnight12")
CKMinions.append("DarkKnight12")
dk12.Data.DeathFunc=DKDED
dk12.ActionAreaMin=pow(2,16)
dk12.ActionAreaMax=pow(2,15)
o=Bladex.CreateEntity("DarkKnight12Statue","DknStatue",54000,38640,-58860)
o.Static=1
o.Scale=1.0
o.Orientation=(0.709,0.704,-0.0211,0.0039)


################## vamp 


vamp=Bladex.CreateEntity("Vamp1","Vamp",100000, 40000, -60250,"Person")
vamp.Angle=3.0
vamp.Level=19
vamp.Data=EnemyNPCTypes.ConquestVamp(vamp)
vamp.Blind=1
vamp.Deaf=1
vamp.Freeze()
vamp.Data.DeathFunc=VampDead
vamp.ActionAreaMin=pow(2,17)
vamp.ActionAreaMax=pow(2,18)
vamp.Data.KilledEnemyFunc=VampKill



################ catedral yard

### top 

tkn1=Bladex.CreateEntity("TraitorKnight1","Dark_Knight",148000, 39000, -20000,"Person")
tkn1.Level=19
tkn1.Angle=4
o=Bladex.CreateEntity("TraitorKnight1WP","Espadafilo",0,0,0,"Weapon")
o.Scale=1
Actions.TakeObject(tkn1.Name,o.Name)
o=Bladex.CreateEntity("TraitorKnight1SH","Escudo6",0,0,0,"Weapon")
Actions.TakeObject(tkn1.Name,o.Name)
o=Bladex.CreateEntity("TraitorKnight1POT","Pocima200",0,0,0,"Physic")
pocimac.CreatePotion(o.Name)
Actions.TakeObject(tkn1.Name,o.Name)
tkn1.Data=EnemyNPCTypes.ConquestKnight_Traitor(tkn1)
tkn1.SetOnFloor()
darfuncs.HideBadGuy(tkn1.Name)
YardEnemies.append("TraitorKnight1")
tkn1.ActionAreaMin=pow(2,22)
tkn1.ActionAreaMax=pow(2,23)


tkn1a=Bladex.CreateEntity("TraitorKnight1A","Dark_Knight",148000, 39000, -44000,"Person")
tkn1a.Level=19
tkn1a.Angle=4
o=Bladex.CreateEntity("TraitorKnight1AWP","Espadafilo",0,0,0,"Weapon")
o.Scale=1
Actions.TakeObject(tkn1a.Name,o.Name)
o=Bladex.CreateEntity("TraitorKnight1ASH","Escudo6",0,0,0,"Weapon")
Actions.TakeObject(tkn1a.Name,o.Name)
o=Bladex.CreateEntity("TraitorKnight1APOT","Pocima200",0,0,0,"Physic")
pocimac.CreatePotion(o.Name)
Actions.TakeObject(tkn1a.Name,o.Name)
tkn1a.Data=EnemyNPCTypes.ConquestKnight_Traitor(tkn1a)
tkn1a.SetOnFloor()
darfuncs.HideBadGuy(tkn1a.Name)
YardEnemies.append("TraitorKnight1A")
tkn1a.ActionAreaMin=pow(2,23)
tkn1a.ActionAreaMax=pow(2,22)




tkn2=Bladex.CreateEntity("TraitorKnight2","Dark_Knight",148000, 38500, -100000,"Person")
tkn2.Level=19
tkn2.Angle=0
o=Bladex.CreateEntity("TraitorKnight2WP","Cimitarra",0,0,0,"Weapon")
o.Scale=1
Actions.TakeObject(tkn2.Name,o.Name)
o=Bladex.CreateEntity("TraitorKnight2SH","Escudo8",0,0,0,"Weapon")
Actions.TakeObject(tkn2.Name,o.Name)
o=Bladex.CreateEntity("TraitorKnight2POT","Pocima200",0,0,0,"Physic")
pocimac.CreatePotion(o.Name)
Actions.TakeObject(tkn2.Name,o.Name)
tkn2.Data=EnemyNPCTypes.ConquestKnight_Traitor(tkn2)
tkn2.SetOnFloor()
darfuncs.HideBadGuy(tkn2.Name)
YardEnemies.append("TraitorKnight2")
tkn2.ActionAreaMin=pow(2,24)
tkn2.ActionAreaMax=pow(2,25)


tkn2a=Bladex.CreateEntity("TraitorKnight2A","Dark_Knight",148000, 38500, -75000,"Person")
tkn2a.Level=19
tkn2a.Angle=0
o=Bladex.CreateEntity("TraitorKnight2AWP","Cimitarra",0,0,0,"Weapon")
o.Scale=1
Actions.TakeObject(tkn2a.Name,o.Name)
o=Bladex.CreateEntity("TraitorKnight2ASH","Escudo8",0,0,0,"Weapon")
Actions.TakeObject(tkn2a.Name,o.Name)
o=Bladex.CreateEntity("TraitorKnight2APOT","Pocima200",0,0,0,"Physic")
pocimac.CreatePotion(o.Name)
Actions.TakeObject(tkn2a.Name,o.Name)
tkn2a.Data=EnemyNPCTypes.ConquestKnight_Traitor(tkn2a)
tkn2a.SetOnFloor()
darfuncs.HideBadGuy(tkn2a.Name)
YardEnemies.append("TraitorKnight2A")
tkn2a.ActionAreaMin=pow(2,25)
tkn2a.ActionAreaMax=pow(2,24)

############### door guards

tkn3=Bladex.CreateEntity("TraitorKnight3","Dark_Knight",184000, 39000, -58000,"Person")
tkn3.Angle=2
tkn3.Level=18
o=Bladex.CreateEntity("TraitorKnight3WP","Espada",0,0,0,"Weapon")
o.Scale=1.2
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("TraitorKnight3SH","Escudo6",0,0,0,"Weapon")
o.Scale=1
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(tkn3.Name,"TraitorKnight3WP")
Actions.TakeObject(tkn3.Name,"TraitorKnight3SH")
tkn3.Data=EnemyNPCTypes.ConquestKnight_Traitor(tkn3)
tkn3.SetOnFloor()
darfuncs.HideBadGuy("TraitorKnight3")
tkn3.Data.DeathFunc= DoorGuardDead
tkn3.ActionAreaMin=pow(2,19)
tkn3.ActionAreaMax=pow(2,20)
YardEnemies.append("TraitorKnight3")

tkn4=Bladex.CreateEntity("TraitorKnight4","Dark_Knight",184000, 39000, -62500,"Person")
tkn4.Angle=1
tkn4.Level=18
o=Bladex.CreateEntity("TraitorKnight4WP","Espada",0,0,0,"Weapon")
o.Scale=1.2
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("TraitorKnight4SH","Escudo6",0,0,0,"Weapon")
o.Scale=1
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(tkn4.Name,"TraitorKnight4WP")
Actions.TakeObject(tkn4.Name,"TraitorKnight4SH")
tkn4.Data=EnemyNPCTypes.ConquestKnight_Traitor(tkn4)
tkn4.SetOnFloor()
darfuncs.HideBadGuy("TraitorKnight4")
tkn4.Data.DeathFunc= DoorGuardDead
tkn4.ActionAreaMin=pow(2,19)
tkn4.ActionAreaMax=pow(2,20)
YardEnemies.append("TraitorKnight4")


tkn5=Bladex.CreateEntity("TraitorKnight5","Dark_Knight",185200, 39000, -60500,"Person")
tkn5.Angle=1.5
tkn5.Level=19
o=Bladex.CreateEntity("TraitorKnight5WP","Espada",0,0,0,"Weapon")
o.Scale=1.2
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("TraitorKnight5SH","Escudo6",0,0,0,"Weapon")
o.Scale=1
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(tkn5.Name,"TraitorKnight5WP")
Actions.TakeObject(tkn5.Name,"TraitorKnight5SH")
tkn5.Data=EnemyNPCTypes.ConquestKnight_Traitor(tkn5)
tkn5.SetOnFloor()
darfuncs.HideBadGuy("TraitorKnight5")
tkn5.Data.DeathFunc= DoorGuardDead
tkn5.ActionAreaMin=pow(2,19)
tkn5.ActionAreaMax=pow(2,20)
YardEnemies.append("TraitorKnight5")





#########################

endgol=Bladex.CreateEntity("EndG1","Golem_stone",156000, 38500, -60000,"Person")
endgol.Angle=1.5
endgol.Level=14
endgol.SetOnFloor()
endgol.Data=EnemyNPCTypes.ConquestGolem(endgol)
darfuncs.HideBadGuy("EndG1")
YardEnemies.append("EndG1")
endgol.Data.DeathFunc= StoneGolemDead


################################################################################################
######################### Enter Cathedral ######################################################




rnskl1=Bladex.CreateEntity("Runskl1","Skeleton",190000, 30500, -47000,"Person")
rnskl1.Angle=4
rnskl1.Level=19
o=Bladex.CreateEntity("Runskl1WP","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(rnskl1.Name,o.Name)
o=Bladex.CreateEntity("Runskl1SH","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(rnskl1.Name,o.Name)
rnskl1.SetOnFloor()
rnskl1.Data=EnemyNPCTypes.ConquestSkeleton(rnskl1)
darfuncs.HideBadGuy("Runskl1")
RunSkels.append("Runskl1")
rnskl1.Data.DeathFunc= RunSkelDead
rnskl1.Data.Resistances= copy.copy(CharStats.GetCharResistances("ChaosSkeleton"))

rnskl1a=Bladex.CreateEntity("Runskl1a","Skeleton",194000, 30500, -47000,"Person")
rnskl1a.Angle=4
rnskl1a.Level=19
o=Bladex.CreateEntity("Runskl1aWP","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(rnskl1a.Name,o.Name)
o=Bladex.CreateEntity("Runskl1aSH","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(rnskl1a.Name,o.Name)
pers.SetOnFloor()
rnskl1a.Data=EnemyNPCTypes.ConquestSkeleton(rnskl1a)
darfuncs.HideBadGuy("Runskl1a")
RunSkels.append("Runskl1a")
rnskl1a.Data.DeathFunc= RunSkelDead
rnskl1a.Data.Resistances= copy.copy(CharStats.GetCharResistances("ChaosSkeleton"))

rnskl2=Bladex.CreateEntity("Runskl2","Skeleton",190000, 30500, -73000,"Person")
rnskl2.Angle=4
rnskl2.Level=19
o=Bladex.CreateEntity("Runskl2WP","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(rnskl2.Name,o.Name)
o=Bladex.CreateEntity("Runskl2SH","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(rnskl2.Name,o.Name)
rnskl2.SetOnFloor()
rnskl2.Data=EnemyNPCTypes.ConquestSkeleton(rnskl2)
darfuncs.HideBadGuy("Runskl2")
RunSkels.append("Runskl2")
rnskl2.Data.DeathFunc= RunSkelDead
rnskl2.Data.Resistances= copy.copy(CharStats.GetCharResistances("ChaosSkeleton"))

rnskl2a=Bladex.CreateEntity("Runskl2a","Skeleton",194000, 30500, -73000,"Person")
rnskl2a.Angle=4
rnskl2a.Level=19
rnskl2a.SelfIlum=0
rnskl2a.SendTriggerSectorMsgs=0
o=Bladex.CreateEntity("Runskl2aWP","DoubleSword",0,0,0,"Weapon")
o.SelfIlum=0
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(rnskl2a.Name,o.Name)
o=Bladex.CreateEntity("Runskl2aSH","Escudo7",0,0,0,"Weapon")
o.SelfIlum=0
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(rnskl2a.Name,o.Name)
rnskl2a.SetOnFloor()
rnskl2a.Data=EnemyNPCTypes.ConquestSkeleton(rnskl2a)
darfuncs.HideBadGuy("Runskl2a")
RunSkels.append("Runskl2a")
rnskl2a.Data.DeathFunc= RunSkelDead
rnskl2a.Data.Resistances= copy.copy(CharStats.GetCharResistances("ChaosSkeleton"))

########################################################


gd=Bladex.CreateEntity("GDmon1","Great_Demon",193000, 58500, -60500,"Person")
gd.Angle=4.5
gd.Scale=1
gd.Data=EnemyNPCTypes.ConquestGreat_Demon(gd)
gd.Data.DeathFunc=DemonDead 
gd.Blind=1
gd.Deaf=1
gd.Freeze()
gd.SelfIlum=0.3





gen_DalGurak3=Bladex.CreateEntity("GenDalGurak3","DalGurak",224000, 44500, -60000,"Person")
gen_DalGurak3.Level=9
gen_DalGurak3.Data=EnemyNPCTypes.ConquestDal(gen_DalGurak3)
gen_DalGurak3.Data.VeryOldImDeadFunc = gen_DalGurak3.ImDeadFunc
gen_DalGurak3.ImDeadFunc = MuereDalGurak
gen_DalGurak3.Data.positionlist.append([237000, 44500, -54500, 0])
gen_DalGurak3.Data.positionlist.append([237000, 44500, -65500, 0])
gen_DalGurak3.Data.positionlist.append([226000, 44500, -54500, 0])
gen_DalGurak3.Data.positionlist.append([226000, 44500, -65500, 0])
gen_DalGurak3.Data.positionlist.append([224000, 44500, -60000, 0])
gen_DalGurak3.Data.positionlist.append([239000, 44500, -60000, 0])











dalinv=gen_DalGurak3.GetInventory()
gen_DalGurak3.Data.Dalweapon=Bladex.CreateEntity("DalWeapon1", "DalWeapon", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(gen_DalGurak3.Data.Dalweapon)
gen_DalGurak3.Data.Dalweapon.SelfIlum=0.3

dalinv.AddWeapon(gen_DalGurak3.Data.Dalweapon.Name)
gen_DalGurak3.Data.Dalshield=Bladex.CreateEntity("DalShield","DalShield",0,0,0, "Weapon")
Sparks.MakeShield(gen_DalGurak3.Data.Dalshield.Name)
dalinv.AddShield(gen_DalGurak3.Data.Dalshield.Name)
dalmagicshield= ItemTypes.MakeMagicShield("DalMagicShield", gen_DalGurak3)
darfuncs.HideBadGuy("GenDalGurak3")






