import darfuncs
import math

radius=1200
x = 61250
y = 38500
z = -50000
dx=radius/2.0
dz=radius*((math.sqrt(3.0))/2.0)
floor_displ=1000.0 
roof_displ=2000.0
trsector_name="CKTrigger"
Bladex.AddTriggerSector(trsector_name, "SectoresTriggers", y+floor_displ, y-roof_displ, [(x+dx, z+dz), (x-dx, z+dz), (x-radius, z), (x-dx, z-dz), (x+dx, z-dz), (x+radius, z)])
Bladex.SetTriggerSectorFunc(trsector_name, "OnEnter", AppearBigGuy1)
		
		
x2 = 204000
y2 = 38500
z2 = -60000
dx=radius/2.0
dz=radius*((math.sqrt(3.0))/2.0)
floor_displ=1000.0 
roof_displ=2000.0
trsector_name="GDTrigger"
Bladex.AddTriggerSector(trsector_name, "SectoresTriggers", y2+floor_displ, y2-roof_displ, [(x2+dx, z2+dz), (x2-dx, z2+dz), (x2-radius, z2), (x2-dx, z2-dz), (x2+dx, z2-dz), (x2+radius, z2)])

		

darfuncs.EnterSecEvent(-44000, -800, -25500, ActCaveOrk1)

darfuncs.EnterSecEvent(-30000, -800, -18000, ActCaveOrk2_3)

darfuncs.EnterSecEvent(-35000, -800, -34000, UnhideCaveOrks2_3)

darfuncs.EnterSecEvent(-15000, 9500, -17000, ActCaveOrk4)


darfuncs.EnterSecEvent(-11000, -5000, 5000, UnhideOrk5_Gork1)

darfuncs.EnterSecEvent(4500, 4000, -20000, UnhideSulfurOrk)

darfuncs.EnterSecEvent(1500, 10500, -24000, UpperForge)




sectpillar1=Bladex.GetSector(-16000, 20000, -48000)
sectpillar1.OnEnter=SulphurPit

darfuncs.EnterSecEvent(3000, 26000, -41000,   CloseMinDoor)




sectdk=Bladex.GetSector(-67000,29500,-50000)
sectdk.OnEnter=SwordMovie


sectgol2=Bladex.GetSector(-52000, 35000, -27000)
sectgol2.OnEnter=CheckMusic1

sectgol3=Bladex.GetSector(-58000, 35000, -25000)
sectgol3.OnEnter=""



sectsulphur1=Bladex.GetSector(-22000, 28000, -50000)
sectsulphur2=Bladex.GetSector(-25000, 28000, -50000)
sectsulphur3=Bladex.GetSector(-25000, 28000, -45000)
sectsulphur4=Bladex.GetSector(-25000, 28000, -42000)
sectsulphur5=Bladex.GetSector(-26000, 28000, -40000)
sectsulphur6=Bladex.GetSector(-22000, 28000, -50000)
sectsulphur7=Bladex.GetSector(-25000, 28000, -36000)
sectsulphur8=Bladex.GetSector(-22000, 28000, -32000)
sectsulphur9=Bladex.GetSector(-20000, 28000, -32000)
sectsulphur10=Bladex.GetSector(-16000, 28000, -37000)
sectsulphur11=Bladex.GetSector(-17000, 28000, -40500)
sectsulphur12=Bladex.GetSector(-17000, 28000, -43000)
sectsulphur13=Bladex.GetSector(-19250, 28000, -42000)
sectsulphur14=Bladex.GetSector(-21000, 28000, -43000)
sectsulphur15=Bladex.GetSector(-14000, 28000, -43000)
sectsulphur16=Bladex.GetSector(-8000, 28000, -46000)
sectsulphur17=Bladex.GetSector(-10500, 28000, -47500)
sectsulphur18=Bladex.GetSector(-7000, 28000, -51000)
sectsulphur19=Bladex.GetSector(-11000, 28000, -50000)
sectsulphur20=Bladex.GetSector(-9000, 28000, -55000)
sectsulphur21=Bladex.GetSector(-15000, 28000, -54500)
sectsulphur22=Bladex.GetSector(-16000, 28000, -54000)

sectsulphur1.OnEnter=SulphurDeath
sectsulphur2.OnEnter=SulphurDeath
sectsulphur3.OnEnter=SulphurDeath
sectsulphur4.OnEnter=SulphurDeath
sectsulphur5.OnEnter=SulphurDeath
sectsulphur6.OnEnter=SulphurDeath
sectsulphur7.OnEnter=SulphurDeath
sectsulphur8.OnEnter=SulphurDeath
sectsulphur9.OnEnter=SulphurDeath
sectsulphur10.OnEnter=SulphurDeath
sectsulphur11.OnEnter=SulphurDeath
sectsulphur12.OnEnter=SulphurDeath
sectsulphur13.OnEnter=SulphurDeath
sectsulphur14.OnEnter=SulphurDeath
sectsulphur15.OnEnter=SulphurDeath
sectsulphur16.OnEnter=SulphurDeath
sectsulphur17.OnEnter=SulphurDeath
sectsulphur18.OnEnter=SulphurDeath
sectsulphur19.OnEnter=SulphurDeath
sectsulphur20.OnEnter=SulphurDeath
sectsulphur21.OnEnter=SulphurDeath
sectsulphur22.OnEnter=SulphurDeath

sectsulphurLower1=Bladex.GetSector(-20000, 33000, -45000)
sectsulphurLower1.OnEnter=""




sectspooks=Bladex.GetSector(-56000, 29800, -74000)
sectspooks.OnEnter=Spectre


sectindy1=Bladex.GetSector(32000, 17800, -29500)
sectindy1.OnEnter=Indiana

sectindy2=Bladex.GetSector(8000, 6500, -22000)
sectindy2.OnEnter=Indiana




sectorkslope=Bladex.GetSector(19000, -24000, 3000)
sectorkslope.OnEnter=""




sectorks2=Bladex.GetSector(21974,38930,-15891)
sectorks2.OnEnter=""





darfuncs.EnterSecEvent(9371,38931,-13414, ActGreatOrk4)



sectorks3=Bladex.GetSector(0, 39800, 4000)
sectorks3.OnEnter=""



sectway2=Bladex.GetSector(7500, 38500, 2500)
sectway2.OnEnter=""

darfuncs.EnterSecEvent(-30000, 39800, 500, UnhideSecondCaveOrks)

darfuncs.EnterSecEvent(-35000, 37800, -39500, UnhideLastcaveOrks)


darfuncs.EnterSecEvent(9000, 32800, 6000, unhidetrls)


BrnGolSec = Bladex.GetSector(-62000, 35800, -20000)
BrnGolSec.OnEnter = StartBurnGol


sectKillOrk = Bladex.GetSector(33000, 38000, -2500)
sectKillOrk.OnEnter = KillOrk


darfuncs.EnterSecEvent(-102000, 38800, 8000, unhidespiders)

darfuncs.EnterSecEvent(52000,38000,-2000,   SetWay3)

darfuncs.EnterSecEvent(44000, 36000, -1500, EnterMaze)


sectsal1= Bladex.GetSector(61000, 38000, -29000)
sectsal1.OnEnter = ""


sectmaz1= Bladex.GetSector(60000, 38000, -2500)
sectmaz1.OnEnter = StartMazeMusic


darfuncs.EnterSecEvent(66000, 39400, -2000, unhideskel3)

darfuncs.EnterSecEvent(61000, 39800, 6000, unhideskel4)

darfuncs.EnterSecEvent(96500, 39800, 2000, unhideskel5)

darfuncs.EnterSecEvent(96500, 39800, 14000, unhideskel6)

darfuncs.EnterSecEvent(91500, 39800, 29500, unhideskel7)

darfuncs.EnterSecEvent(66500, 39800, 38000, unhideskel8)

darfuncs.EnterSecEvent(66000, 39800, 50000, unhideskel9)

darfuncs.EnterSecEvent(67000, 39000, 58000, unhideskel10)

darfuncs.EnterSecEvent(92000, 39000, 54000, unhideskel11)

BrnSklSec2 = Bladex.GetSector(116000, 38400, 54000)
BrnSklSec2.OnEnter = StartBurnSkl2



darfuncs.EnterSecEvent(76500, 38000, -2500, unhidemaz23)

darfuncs.EnterSecEvent(86500, 38000, 10000, unhidemaz4)

darfuncs.EnterSecEvent(125000, 35500, 46000, unhideldms)

darfuncs.EnterSecEvent(61000, 38500, -21000,SetWay4)


sectmaz2= Bladex.GetSector(61000, 35000, -6000)
sectmaz2.OnEnter = ExitMaze


sectlav1= Bladex.GetSector(61000, 39800, -41000)
sectlav1.OnEnter = unhidedks

sectlav2= Bladex.GetSector(70000, 39800, -39000)
sectlav2.OnEnter = unhidedks


sectlav3= Bladex.GetSector(52000, 39800, -41000)
sectlav3.OnEnter = unhidedks




darfuncs.EnterSecEvent(61000, 38800, -67000, ShutCKDoor)

darfuncs.EnterSecEvent(61000, 38800, -57000, StartCKMusic)


darfuncs.EnterSecEvent(88000, 38500, -60000,SetWay5)


darfuncs.EnterSecEvent(94500, 39800, -60000, unhidevamp)


sectpowup1=Bladex.GetSector(61500, 35600, -84000)
sectpowup1.OnEnter = AddElectricToShade

sectpowup2=Bladex.GetSector(44500,39700,-16000)
sectpowup2.OnEnter = AddLightToShade

sectpowup3=Bladex.GetSector(-110500, 38600, 38000)
sectpowup3.OnEnter = AddVenomToShade

sectpowup4=Bladex.GetSector(141000,35200,81000)
sectpowup4.OnEnter = AddDrainToShade

sectpowup5=Bladex.GetSector(134500,38200,-81500)
sectpowup5.OnEnter = AddIceToShade

sectpowup6=Bladex.GetSector(128000, 38600, -35000)
sectpowup6.OnEnter = AddFireToShade

sectpowup7=Bladex.GetSector(49500, 32000, 37000)
sectpowup7.OnEnter = AddDestructorToShade


"""
darfuncs.EnterSecEvent(61500, 35600, -84000,  AddElectricToShade) # ck room
darfuncs.EnterSecEvent(44500,39700,-16000,    AddLightToShade)    # red maze entrance
darfuncs.EnterSecEvent(-110500, 38600, 38000, AddVenomToShade)    # golem cave
darfuncs.EnterSecEvent(141000,35200,81000,    AddDrainToShade)    # red maze - little demon room
darfuncs.EnterSecEvent(134500,38200,-81500,   AddIceToShade)      # magic path
darfuncs.EnterSecEvent(128000, 38600, -35000, AddFireToShade)     # planets room
darfuncs.EnterSecEvent(49500, 32000, 37000,   AddDestructorToShade)     # Troll tunnel return tunnel
"""


darfuncs.EnterSecEvent(148000, 38000,-60000,SetWay6)



sectdoorguards=Bladex.GetSector(178000, 38000, -60000)
sectdoorguards.OnEnter = ""




sectskels=Bladex.GetSector(196000, 38000,-60000)
sectskels.OnEnter=ActRunSkels



sectoryard1=Bladex.GetSector(120000, 39000, -60000)
sectoryard2=Bladex.GetSector(116000, 39000, -57500)
sectoryard3=Bladex.GetSector(116000, 39000, -63000)
sectoryard1.OnEnter=EnterCathedralYard
sectoryard2.OnEnter=EnterCathedralYard
sectoryard3.OnEnter=EnterCathedralYard

darfuncs.EnterSecEvent(115000, 39000, -60000, CathYardCap)

sectorwet1=Bladex.GetSector(128000, 44000, -22500)
sectorwet2=Bladex.GetSector(128000, 44000, -60000)
sectorwet3=Bladex.GetSector(128000, 44000, -100000)
sectorwet4=Bladex.GetSector(160000, 44000, -60000)
sectorwet1.OnEnter = Drowned
sectorwet2.OnEnter = Drowned
sectorwet3.OnEnter = Drowned
sectorwet4.OnEnter = Drowned





sectorbit1=Bladex.GetSector(116500, 38500, -56000)
sectorbit2=Bladex.GetSector(144000, 38500, -28000)
sectorbit1.OnEnter=Orbit
sectorbit2.OnEnter=Orbit



sectorcathyard1=Bladex.GetSector(142500, 38500, -87000)
sectorcathyard2=Bladex.GetSector(141500, 38500, -28000)
sectorcathyard1.OnEnter=UnhideTratsSouth
sectorcathyard2.OnEnter=UnhideTratsNorth








darfuncs.EnterSecEvent(222000,39800,-60500, AlainnFunc)


sectblood1=Bladex.GetSector(220000, 48000, -61000)
sectblood1.OnEnter=MoveBack






sect1 = Bladex.GetSector(115500,40000,-77500)
sect1.OnEnter = MagPat1
sect2 = Bladex.GetSector(115500,40000,-79500)
sect2.OnEnter = MagPat2
sect3 = Bladex.GetSector(115500,40000,-81500)
sect3.OnEnter = MagPat3
sect4 = Bladex.GetSector(115500,40000,-85500)
sect4.OnEnter = MagPat4
sect5 = Bladex.GetSector(115500,40000,-87500)
sect5.OnEnter = MagPat5
sect6 = Bladex.GetSector(117500,40000,-71500)
sect6.OnEnter = MagPat6
sect7 = Bladex.GetSector(117500,40000,-73500)
sect7.OnEnter = MagPat7
sect8 = Bladex.GetSector(117500,40000,-75500)
sect8.OnEnter = MagPat8
sect9 = Bladex.GetSector(117500,40000,-77500)
sect9.OnEnter = MagPat9
sect10 = Bladex.GetSector(117500,40000,-81500)
sect10.OnEnter = MagPat10
sect11 = Bladex.GetSector(117500,40000,-85500)
sect11.OnEnter = MagPat11
sect12 = Bladex.GetSector(119500,40000,-73500)
sect12.OnEnter = MagPat12
sect13 = Bladex.GetSector(119500,40000,-77500)
sect13.OnEnter = MagPat13
sect14 = Bladex.GetSector(119500,40000,-81500)
sect14.OnEnter = MagPat14
sect15 = Bladex.GetSector(119500,40000,-83500)
sect15.OnEnter = MagPat15
sect16 = Bladex.GetSector(119500,40000,-85500)
sect16.OnEnter = MagPat16
sect17 = Bladex.GetSector(119500,40000,-87500)
sect17.OnEnter = MagPat17
sect18 = Bladex.GetSector(121500,40000,-73500)
sect18.OnEnter = MagPat18
sect19 = Bladex.GetSector(121500,40000,-79500)
sect19.OnEnter = MagPat19
sect20 = Bladex.GetSector(121500,40000,-83500)
sect20.OnEnter = MagPat20
sect21 = Bladex.GetSector(123500,40000,-71500)
sect21.OnEnter = MagPat21
sect22 = Bladex.GetSector(123500,40000,-73500)
sect22.OnEnter = MagPat22
sect23 = Bladex.GetSector(123500,40000,-75500)
sect23.OnEnter = MagPat23
sect24 = Bladex.GetSector(123500,40000,-77500)
sect24.OnEnter = MagPat24
sect25 = Bladex.GetSector(123500,40000,-79500)
sect25.OnEnter = MagPat25
sect26 = Bladex.GetSector(123500,40000,-83500)
sect26.OnEnter = MagPat26
sect27 = Bladex.GetSector(123500,40000,-85500)
sect27.OnEnter = MagPat27
sect28 = Bladex.GetSector(123500,40000,-87500)
sect28.OnEnter = MagPat28
sect29 = Bladex.GetSector(125500,40000,-71500)
sect29.OnEnter = MagPat29
sect30 = Bladex.GetSector(125500,40000,-73500)
sect30.OnEnter = MagPat30
sect31 = Bladex.GetSector(125500,40000,-77500)
sect31.OnEnter = MagPat31
sect32 = Bladex.GetSector(125500,40000,-81500)
sect32.OnEnter = MagPat32
sect33 = Bladex.GetSector(125500,40000,-85500)
sect33.OnEnter = MagPat33
sect34 = Bladex.GetSector(127500,40000,-77500)
sect34.OnEnter = MagPat34
sect35 = Bladex.GetSector(127500,40000,-81500)
sect35.OnEnter = MagPat35
sect36 = Bladex.GetSector(127500,40000,-85500)
sect36.OnEnter = MagPat36
sect37 = Bladex.GetSector(127500,40000,-87500)
sect37.OnEnter = MagPat37
sect38 = Bladex.GetSector(129500,40000,-75500)
sect38.OnEnter = MagPat38
sect39 = Bladex.GetSector(129500,40000,-77500)
sect39.OnEnter = MagPat39
sect40 = Bladex.GetSector(129500,40000,-81500)
sect40.OnEnter = MagPat40
sect41 = Bladex.GetSector(129500,40000,-83500)
sect41.OnEnter = MagPat41
sect42 = Bladex.GetSector(129500,40000,-87500)
sect42.OnEnter = MagPat42
sect43 = Bladex.GetSector(131500,40000,-73500)
sect43.OnEnter = MagPat43
sect44 = Bladex.GetSector(131500,40000,-75500)
sect44.OnEnter = MagPat44
sect45 = Bladex.GetSector(131500,40000,-83500)
sect45.OnEnter = MagPat45
sect46 = Bladex.GetSector(131500,40000,-87500)
sect46.OnEnter = MagPat46
sect47 = Bladex.GetSector(133500,40000,-73500)
sect47.OnEnter = MagPat47
sect48 = Bladex.GetSector(133500,40000,-81500)
sect48.OnEnter = MagPat48
sect49 = Bladex.GetSector(133500,40000,-83500)
sect49.OnEnter = MagPat49
sect50 = Bladex.GetSector(133500,40000,-87500)
sect50.OnEnter = MagPat50
sect51 = Bladex.GetSector(135500,40000,-73500)
sect51.OnEnter = MagPat51
sect52 = Bladex.GetSector(135500,40000,-75500)
sect52.OnEnter = MagPat52
sect53 = Bladex.GetSector(135500,40000,-77500)
sect53.OnEnter = MagPat53
sect54 = Bladex.GetSector(135500,40000,-81500)
sect54.OnEnter = MagPat54
sect55 = Bladex.GetSector(135500,40000,-85500)
sect55.OnEnter = MagPat55
sect56 = Bladex.GetSector(135500,40000,-87500)
sect56.OnEnter = MagPat56
sect57 = Bladex.GetSector(137500,40000,-73500)
sect57.OnEnter = MagPat57
sect58 = Bladex.GetSector(137500,40000,-77500)
sect58.OnEnter = MagPat58
sect59 = Bladex.GetSector(137500,40000,-79500)
sect59.OnEnter = MagPat59
sect60 = Bladex.GetSector(137500,40000,-81500)
sect60.OnEnter = MagPat60
sect61 = Bladex.GetSector(137500,40000,-85500)
sect61.OnEnter = MagPat61
sect62 = Bladex.GetSector(139500,40000,-85500)
sect62.OnEnter = MagPat62
sect63 = Bladex.GetSector(139500,40000,-87500)
sect63.OnEnter = MagPat63
