####################################################################################
## BODLoader
####################################################################################

####################################################################################
# Global variables
####################################################################################

global ModName
global ModDesc
global ModVersion
global ModAuthor
global ModAuthorInfo
global NewFiles
global RepFiles
global MakeDirs

####################################################################################
# Mod Info
####################################################################################

# Mod Name
ModName          = "NewConquest"
# Mod Description
import Language
if Language.Current == 'Spanish':
	ModDesc = (
		"""NewConquest"""
		)
else:
	ModDesc = (
		"""Conquest Aniversary Edition\n\n"""
		"""A single-player level for Blade of Darkness"""
		)

# Mod Version
ModVersion       = "2.0"
# Author name
ModAuthor        = "Sir Random"
# Author info: email, url,...
ModAuthorInfo    = ""

####################################################################################
# Mod Data
####################################################################################

# Make new directories

MakeDirs = ['../NewConquest']

# New Files added by Mod and destination directory

NewFiles[0]      = {'File': 'agua.py',			'Dest': '../NewConquest'}
NewFiles[1]      = {'File': 'blade.swf',		'Dest': '../NewConquest'}
NewFiles[2]      = {'File': 'cfg.py',			'Dest': '../NewConquest'}
NewFiles[3]      = {'File': 'NewConquest.bw',		'Dest': '../NewConquest'}
NewFiles[4]      = {'File': 'NewConquest.lvl',		'Dest': '../NewConquest'}
NewFiles[5]      = {'File': 'NewConquest.mmp',		'Dest': '../NewConquest'}
NewFiles[6]      = {'File': 'cuervos.py',               'Dest': '../NewConquest'}
NewFiles[7]      = {'File': 'DefFuncs.py',		'Dest': '../NewConquest'}
NewFiles[8]      = {'File': 'Triggsect.py',		'Dest': '../NewConquest'}
NewFiles[9]      = {'File': 'Enemy.py',			'Dest': '../NewConquest'}
NewFiles[10]     = {'File': 'Blade_progress.jpg',       'Dest': '../NewConquest'}
NewFiles[11]     = {'File': 'Blade_progress2.jpg',      'Dest': '../NewConquest'}
NewFiles[12]     = {'File': 'Glmlava.mmp',		'Dest': '../NewConquest'}
NewFiles[13]     = {'File': 'INTRODUCTION.htm',         'Dest': '../NewConquest'}
NewFiles[14]     = {'File': 'INTRODUCTION.txt',         'Dest': '../NewConquest'}
NewFiles[15]     = {'File': 'Lava.py',			'Dest': '../NewConquest'}
NewFiles[16]     = {'File': 'Luces.py',			'Dest': '../NewConquest'}
NewFiles[17]     = {'File': 'Magpath.py',		'Dest': '../NewConquest'}
NewFiles[18]     = {'File': 'knightshade.mmp',	        'Dest': '../NewConquest'}
NewFiles[19]     = {'File': 'Myvamp.mmp',		'Dest': '../NewConquest'}
NewFiles[20]     = {'File': 'objs.py',			'Dest': '../NewConquest'}
NewFiles[21]     = {'File': 'objs2.py',			'Dest': '../NewConquest'}
NewFiles[22]     = {'File': 'Objs4.py',			'Dest': '../NewConquest'}
NewFiles[23]     = {'File': 'ObjsFinale.py',	        'Dest': '../NewConquest'}
NewFiles[24]     = {'File': 'pj.py',			'Dest': '../NewConquest'}
NewFiles[25]     = {'File': 'pocimas.py',		'Dest': '../NewConquest'}
NewFiles[26]     = {'File': 'Powerups.py',		'Dest': '../NewConquest'}
NewFiles[27]     = {'File': 'puertas.py',		'Dest': '../NewConquest'}
NewFiles[28]     = {'File': 'Readme.txt',		'Dest': '../NewConquest'}
NewFiles[29]     = {'File': 'sonidos.py',		'Dest': '../NewConquest'}
NewFiles[30]     = {'File': 'Weapons.py',		'Dest': '../NewConquest'}
NewFiles[31]     = {'File': 'NewConquestMenu.py',	'Dest': '../../Scripts'}
NewFiles[32]     = {'File': 'MusicEvents.py',		'Dest': '../NewConquest'}
NewFiles[33]     = {'File': 'QuiverTypes.py',		'Dest': '../NewConquest'}
NewFiles[34]     = {'File': 'ActorsInit.py',		'Dest': '../NewConquest'}
NewFiles[35]     = {'File': 'NPCStats.py',		'Dest': '../NewConquest'}
NewFiles[36]     = {'File': 'obj_def.py',		'Dest': '../NewConquest'}
NewFiles[37]     = {'File': 'TextureMaterials.py',	'Dest': '../NewConquest'}
NewFiles[38]     = {'File': 'PlayerTypes.py',		'Dest': '../NewConquest'}
NewFiles[39]     = {'File': 'InitNewChars.py',		'Dest': '../NewConquest'}
NewFiles[40]     = {'File': 'KeyFuncs.py',		'Dest': '../NewConquest'}
NewFiles[41]     = {'File': 'Positions.py',		'Dest': '../NewConquest'}
NewFiles[42]     = {'File': 'EnemyNPCTypes.py',		'Dest': '../NewConquest'}
NewFiles[43]     = {'File': 'ghosect.sf',		'Dest': '../NewConquest'}
NewFiles[44]     = {'File': 'AcidGolemIcon.bmp',	'Dest': '../NewConquest'}
NewFiles[45]     = {'File': 'DefAnims.py',	        'Dest': '../NewConquest'}
NewFiles[46]     = {'File': 'sulfur.mmp',	        'Dest': '../NewConquest'}
NewFiles[47]     = {'File': 'bolaks.mmp',	        'Dest': '../NewConquest'}
NewFiles[48]     = {'File': 'KgtKnightshade.jpg',	'Dest': '../NewConquest'}
NewFiles[49]     = {'File': 'BarKnightshade.jpg',       'Dest': '../NewConquest'}
NewFiles[50]     = {'File': 'AmzKnightshade.jpg',       'Dest': '../NewConquest'}
NewFiles[51]     = {'File': 'DwfKnightshade.jpg',       'Dest': '../NewConquest'}
NewFiles[52]     = {'File': 'darkskel.mmp',	        'Dest': '../NewConquest'}
NewFiles[53]     = {'File': 'ConqLava.py',	        'Dest': '../NewConquest'}
NewFiles[54]     = {'File': 'bcatdoor.mmp',	        'Dest': '../NewConquest'}

inststuff=0

if inststuff==0:
	execfile("../../BODLoader/Mods/NewConquest/Installnewstuff.py")
      	instuff=1
