from CharData import CharMaxLifeValue
from CharData import CharDamageData
from CharData import CharDefenseData
from CharData import CharResistances
from CharData import CharExperienceCost
from CharData import CharExperienceReward
from CharData import CharAccuracy
from CharData import CharMaxEnergyValue


## This file to modify char statistics


CharExperienceReward['Salamander'] = [100, 200, 400, 800, 1600, 3200, 6400, 12800, 25600, 51200, 70000, 90000, 110000, 130000, 150000, 170000, 190000, 210000, 240000, 260000]

CharMaxLifeValue['Salamander']=          [   150,    200,    250,    550,    650,    5000,    8500,    9500,   10500,   11500,   12500,   13500,   14500,   15500,   16500,   17500,   18500,   19500,   20000,   25000]



CharExperienceReward['Ork'] = [40, 50, 60, 120, 240, 480, 960, 2500, 5000, 8000, 15360, 30720, 61440, 122880, 135000, 150000, 170000, 190000, 210000, 240000]



CharMaxLifeValue['Dark_Ork']=              [    10,     30,     50,     70,    120,    220,    350,    470,    790,    930,   1250,   1480,   1600,   1800,   2000,   2100,   2200,   2300,   2400,   2500]
CharMaxLifeValue['Gold_Ork']=              [    10,     30,     50,     70,    120,    220,    350,    470,    790,    930,   1250,   1480,   1600,   1800,   2000,   2100,   2200,   2300,   2400,   2500]

CharDamageData['Dark_Ork']=                [     1,      5,     10,     15,     20,     25,     40,     45,     50,     55,     60,     65,     70,     75,     80,     85,     90,     95,    100,    110]
CharDamageData['Gold_Ork']=                [     1,      5,     10,     15,     20,     25,     40,     45,     50,     55,     60,     65,     70,     75,     80,     85,     90,     95,    100,    110]

CharExperienceReward['Dark_Ork']=               [     5,     10,     15,     20,     40,     80,    160,    320,    640,   1280,   2560,   5120,  10240,  20480,  40960,  60000,  80000, 100000, 120000, 150000]
CharExperienceReward['Gold_Ork']=               [     5,     10,     15,     20,     40,     80,    160,    320,    640,   1280,   2560,   5120,  10240,  20480,  40960,  60000,  80000, 100000, 120000, 150000]

CharAccuracy['Dark_Ork']=                 [   0.1,    0.1,    0.2,    0.2,    0.3,    0.3,    0.4,    0.4,    0.5,    0.5,    0.6,    0.6,    0.6,    0.7,    0.7,    0.7,    0.8,    0.8,    0.9,    0.9]
CharAccuracy['Gold_Ork']=            [   0.1,    0.1,    0.2,    0.2,    0.3,    0.3,    0.4,    0.4,    0.5,    0.5,    0.6,    0.6,    0.6,    0.7,    0.7,    0.7,    0.8,    0.8,    0.9,    0.9]


##############  ########

CharResistances['Vamp']= {'Impale': 0.98, 'Venom': 1.0, 'Slash': 0.85, 'Crush': 0.85, 'Ice': 0.2, 'Fire': 0.2, 'Light': -0.2, 'Drain': 1.0, 'Electric': -0.40}

CharResistances['Spidersmall']= {'Impale': 0.00, 'Venom': 1.00, 'Slash': 0.00, 'Crush': 0.00, 'Ice': 0.00, 'Fire': 1.00, 'Light': 0.00, 'Drain': 1.00}

CharResistances['Golem_stone']= {'Impale': 0.90, 'Venom': 1.00, 'Slash': 0.70, 'Crush': 0.50, 'Ice': -0.20, 'Fire': -0.20, 'Light': 0.80, 'Drain': 1.00}

CharResistances['Dark_Knight']= {'Impale': 0.80, 'Venom': 1.00, 'Slash': 0.95, 'Crush': 0.90, 'Ice': 0.60, 'Fire': 0.60, 'Light': -0.30, 'Drain': 1.00, 'Electric': 0.70}

CharResistances['Great_Demon']= {'Impale': 0.00, 'Venom': 1.00, 'Slash': 0.30, 'Crush': 0.80, 'Ice': -0.90, 'Fire': 0.98, 'Light': -0.40, 'Drain': 1.00}

CharResistances['DarkSkel']= {'Impale': 0.00, 'Venom': 1.00, 'Slash': -0.20, 'Crush': 0.10, 'Ice': -0.90, 'Fire': 0.98, 'Light': -0.60, 'Drain': 1.00}

CharResistances['Great_Ork']= {'Impale': 0.80, 'Venom': 0.70, 'Slash': 0.60, 'Crush': 0.70, 'Ice': 0.60, 'Fire': 0.00, 'Light': -1.00, 'Drain': 0.60}

CharResistances['FireSkeleton']= {'Impale': 0.60, 'Venom': 1.00, 'Slash': 0.60, 'Crush': 0.20, 'Ice': 0.30, 'Fire': 0.30, 'Light': 0.90, 'Drain': 1.00}

CharResistances['ChaosSkeleton']= {'Impale': 1.00, 'Venom': 1.00, 'Slash': 0.95, 'Crush': 0.85, 'Ice': 0.50, 'Fire': 0.50, 'Light': 0.00, 'Drain': 1.00}

CharResistances['DalGurak']= {'Impale': 1.00, 'Venom': 1.00, 'Slash': 0.90, 'Crush': 0.95, 'Ice': -0.15, 'Fire': -0.15, 'Light': 1.00, 'Drain': 1.00, 'Electric': -0.15}

CharResistances['Salamander']= {'Impale': 0.00, 'Venom': 1.00, 'Slash': 0.00, 'Crush': 0.00, 'Ice': 1.0, 'Fire': 1.0, 'Light': -0.50, 'Drain': 1.00}

CharResistances['ChaosKnight']= {'Impale': 1.00, 'Venom': 1.00, 'Slash': 0.90, 'Crush': 0.60, 'Ice': 1.00, 'Fire': 1.00, 'Light': -0.20, 'Drain': 1.00, 'Electric': -0.15}

CharResistances['Little_Demon']= {'Impale': 0.20, 'Venom': 1.0, 'Slash': -0.20, 'Crush': 0.20, 'Ice': -0.60, 'Fire': 0.98, 'Light': 0.0, 'Drain': 1.00}

CharResistances['Troll_Dark']= {'Impale': 0.40, 'Venom': -0.60, 'Slash': 0.10, 'Crush': 0.20, 'Ice': -0.60, 'Fire': -0.60, 'Light': -1.00, 'Drain': 0.80}

CharResistances['Minotaur']= {'Impale': 0.60, 'Venom': -0.20, 'Slash': 0.40, 'Crush': 0.60, 'Ice': -0.50, 'Fire': -0.80, 'Light': -0.90, 'Drain': 0.90}




CharMaxLifeValue['Vamp']=                [  2500,   3500,   4500,   5500,   6500,   7500,   5300,   5600,   5900,   6200,   6500,   6800,   7100,   7400,   7700,   8000,   8300,   8600,   30000,   30000]

CharMaxLifeValue['ChaosKnight']=         [  5000,   6000,   7000,   8000,   9000,  10000,  11000,  12000,  13000,  14000,  15000,  16000,  17000,  18000,  19000,  20000,  21000,  22000,  23000,  24000]




CharMaxEnergyValue['Dwarf_N']=     [20, 40, 80,  140, 220, 380, 540, 640, 885,  1210, 1650, 2000, 2400, 3000, 3800, 4700, 6200, 8600,  14200, 20000, 30000, 30000]

CharMaxEnergyValue['Barbarian_N']= [40, 80, 140, 220, 380, 540, 640, 885, 1210, 1650, 2000, 2400, 3000, 3800, 4700, 6200, 8600, 14200, 20000, 20000, 30000, 30000]

import Reference

Reference.DefaultObjectData['Salamander']=           [Reference.OBJ_WEAPON,  500,  0, 1.0,  Reference.THR_SPINNING, []]
Reference.DefaultObjectData['Little_Demon']=         [Reference.OBJ_WEAPON,  500,  0, 1.0,  Reference.THR_SPINNING, [],['Drain']]
Reference.DefaultObjectData['Spidersmall']=          [Reference.OBJ_WEAPON,   200, 0, 1.0,  Reference.THR_SPINNING, [],['Venom',+90.0]]