######################################################################################	
# NewConquest Menu
######################################################################################	

PlayerType = "Knight"
PlayerModel = 0

try:
	execfile("../../Config/newconquest.cfg")
except:
	pass

def SaveConfiguration():
	cfgfile = open("../../Config/newconquest.cfg", "w")
	cfgfile.write('PlayerType = "' + str(PlayerType) + '"\n')
	cfgfile.write('PlayerModel = ' + str(PlayerModel) + '\n')
	cfgfile.close()

def GetCharType():
	import NetMisc
	return NetMisc.Caracteres[PlayerType][0]

def SetCharType(option):
	import netwidgets
	import NetMisc
	global PlayerType
	global PlayerModel
	PlayerType = option
	PlayerModel = 0
	netwidgets.ChangePlayer(NetMisc.Caracteres[PlayerType][PlayerModel+2])
	SaveConfiguration();

def GetCharStatus():
	import NetMisc
	return NetMisc.Caracteres[PlayerType][PlayerModel+2]

def NextSkin(menu_class):
	import netwidgets
	import NetMisc
	global PlayerModel
	size = len(NetMisc.Caracteres[PlayerType])-2
	PlayerModel = PlayerModel + 1
	if PlayerModel >= size:
		PlayerModel = 0
	netwidgets.ChangePlayer(NetMisc.Caracteres[PlayerType][PlayerModel+2])
	SaveConfiguration();

def PreviousSkin(menu_class):
	import netwidgets
	import NetMisc
	global PlayerModel
	size = len(NetMisc.Caracteres[PlayerType])-2
	PlayerModel = PlayerModel - 1
	if PlayerModel < 0:
		PlayerModel = size - 1
	netwidgets.ChangePlayer(NetMisc.Caracteres[PlayerType][PlayerModel+2])
	SaveConfiguration();


def StartNewConquest(option):
	import Bladex
	Bladex.LoadLevel("NewConquest");

import Menu
import MenuWidget
import MenuText
import netwidgets
import NetMisc

ModMenu = [{"Name":MenuText.GetMenuText("Character:"),
 			"Font":Menu.MenuFontMed,
			"Kind":MenuWidget.B_MenuItemOption,
			"Options":[MenuText.GetMenuText("Knight"),MenuText.GetMenuText("Barbarian"),MenuText.GetMenuText("Dwarf"),MenuText.GetMenuText("Amazon")],
			"SelOptionFunc":GetCharType,
			"Command":SetCharType,
			"VSep":50,
		   },
		   {"Name":"Lista de jugadores",
			"Kind":netwidgets.B_ImageListWidget,
			"ImageList":NetMisc.CharBitmaps,
			"GetCharType":GetCharStatus,
			"VSep":30
		   },
		   {"Name":"< "+MenuText.GetMenuText("Next Skin")+" >",
			"VSep":30,
			"Command":NextSkin,
			"LeftCommand":NextSkin,
			"RightCommand":PreviousSkin,
		   },
		   {"Name":MenuText.GetMenuText("Start"),
			"VSep":30,
			"Command":StartNewConquest,
		   },
		   {"Name":MenuText.GetMenuText("Back"),
			"VSep":30,
			"Command":Menu.BackMenu,
		   },
		   {"Name":"Back",
			"Kind":MenuWidget.B_BackBlank
		   }
		  ]
