import Bladex
import Sparks
import Auras
import ItemTypes
import Objects
import AuxFuncs



######################### Planets

o=Bladex.CreateEntity("Pluto","BoladePiedra",128000,40000,-40000,"Physic")
o.Scale=1
o.Static=1
o.SelfIlum=0.1
o.Orientation=0.7,0.7,0,0
AuraParams=(140, 1, 1, 0, 0, 1)
AuraGradient=(2, 0.8, 0.6, 0.0, 0.6, 0.0, 0.8, 0.1, 0.0, 0.0, 0.6)
aura=Auras.MakeAura(o.Name, 100000, AuraParams, (), (), AuraGradient)
luzP=Bladex.CreateEntity("LuzP","Entity Spot",128000, 40000, -40000)
luzP.Color=255, 120, 0
luzP.Intensity=25
luzP.Precission=0.5 #0.125
luzP.CastShadows=1
luzP.Visible=0
luzP.Flick=0   
luzP.SizeFactor = 0.5
luzP.AngVel=0.1
luzP.GlowTexture="SunFlare"
o.Link(luzP)
dinobj = Objects.CreateDinamicObject(o.Name)
Objects.RotateObject(dinobj, 3.14159*500000, 2, 1, (0, 1, 0), (0, 0, 1), Objects.REL, "", "", "","",(),"",())



o=Bladex.CreateEntity("Asteroid1","EsferaGemaVerde",128000,40000,-43000,"Physic")
o.Scale=2
o.Static=1
o.SelfIlum=1
o.Orientation=0.7,0.7,0,0
Venomglow2("Asteroid1",500000)
dinobj = Objects.CreateDinamicObject(o.Name)
Objects.RotateObject(dinobj,3.14159*50000,1,3,(128000,40000,-40000),(0, 1, 0),Objects.ABS,"","","","",(),"",())

#############
o=Bladex.CreateEntity("Asteroid2","EsferaGemaRoja",128000,37000,-40000,"Physic")
o.Scale=2
o.Static=1
o.SelfIlum=1
o.Orientation=0.7,0.7,0,0
Venomglow2("Asteroid2",500000)
dinobj = Objects.CreateDinamicObject(o.Name)
Objects.RotateObject(dinobj,3.14159*50000,1,3,(128000,40000,-40000),(1, 0, 0),Objects.ABS,"","","","",(),"",())



###########



o=Bladex.CreateEntity("Asteroid3","EsferaGemaAzul",128000,43000,-40000,"Physic")
o.Scale=1
o.Static=1
o.SelfIlum=1
o.Orientation=0.7,0.7,0,0
Venomglow2("Asteroid3",500000)
dinobj = Objects.CreateDinamicObject(o.Name)
Objects.RotateObject(dinobj,3.14159*50000,1,3,(128000,40000,-40000),(0, 0, 1),Objects.ABS,"","","","",(),"",())


o=Bladex.CreateEntity("orbit","PowerupGold",134000,40000,-50600,"Physic")
o.Scale=2
o.SelfIlum=5
o.Orientation=0.7,0.7,0,0
o.Static=1
o.Solid=1

o=Bladex.CreateEntity("orbit2","PowerupGold",122000,40000,-30400,"Physic")
o.Scale=2
o.SelfIlum=5
o.Orientation=0.7,0.7,0,0
o.Static=1
o.Solid=1

o=Bladex.CreateEntity("orbit3","PowerupGold",128000,40000,-45000,"Physic")
o.Scale=2
o.SelfIlum=5
o.Orientation=0.7,0.7,0,0
o.Static=1
o.Solid=1



o=Bladex.CreateEntity("Doom","Orbe",246000, 38600, -59500,"Weapon")
o.Static=1
o.Scale=0.75
o.SelfIlum=0.2
o.Orientation=0.7,0.7,0,0
ItemTypes.ItemDefaultFuncs (o)
AuraParams=(40, 1, 1, 0, 0, 1)
AuraGradient=(2, 0.8, 0.6, 0.0, 0.6, 0.0, 0.8, 0.1, 0.0, 0.0, 0.6)
aura=Auras.MakeAura(o.Name, 100000, AuraParams, (), (), AuraGradient)
luzD=Bladex.CreateEntity("LuzD","Entity Spot",246000, 38600, -59500)
luzD.Color=255, 120, 0
luzD.Intensity=25
luzD.Precission=0.5 #0.125
luzD.CastShadows=1
luzD.Visible=0
luzD.Flick=0   
luzD.SizeFactor = 0.2
luzD.AngVel=0.1
luzD.GlowTexture="SunFlare"
o.Link(luzD)

o=Bladex.CreateEntity("DoomX","Orbe",247000, 38600, -59500,"Weapon")
o.Static=1
o.Scale=0.5
o.SelfIlum=0
o.Orientation=0.7,0.7,0,0
ItemTypes.ItemDefaultFuncs (o)


o=Bladex.CreateEntity("Altar1","Altar",244000, 34100, -60000,"Physic")
o.Scale=1
o.SelfIlum=0
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

########################### Altar Items ################################

o=Bladex.CreateEntity("Book1","Libroabierto",243600, 33200, -60000,"Weapon")
o.Scale=1.5
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1

o=Bladex.CreateEntity("BloodBowl1","Bloodbol",243500, 33120, -61350,"Weapon")
o.Scale=0.8
o.Orientation=0.707,0.707,0,0
o.Static=1

o=Bladex.CreateEntity("Chalice1","Caliz",243800, 33100, -59100,"Weapon")
o.Scale=1.5
o.Orientation=0.707,0.707,0,0
o.Static=1

o=Bladex.CreateEntity("SacBottle1","BotellaSagrada",244100, 32800, -59000,"Weapon")
o.Scale=1.5
o.Orientation=0.707,0.707,0,0
o.Static=1


########################### Stair Column & Lights ####################
import Torchs

o=Bladex.CreateEntity("StairCol1","Columnaestrecha",249500, 33500, -60000,"Physic")
o.Scale=2
o.SelfIlum=0
o.Orientation=0.7,0.7,0,0
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)





o=Bladex.CreateEntity("Columnaestrecha_267","Columnaestrecha",244263.543339,37802.9529594,-57033.4675737, Reference.ObjType("Columnaestrecha"))
o.Scale=2.6
o.Orientation=(0.707106769085,-0.707106769085,0.0,0.0)


o=Bladex.CreateEntity("Columnaestrecha_268","Columnaestrecha",244263.543339,37802.9529594,-63033.4675737, Reference.ObjType("Columnaestrecha"))
o.Scale=2.6
o.Orientation=(0.707106769085,-0.707106769085,0.0,0.0)




o=Bladex.CreateEntity("Garg1","Gargola02",231500, 33000, -49500,"Physic")
o.Scale=3
o.SelfIlum=0
o.Orientation=0.7,0.7,0,0
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)


o=Bladex.CreateEntity("GarFire1","Hoguera",231500, 34900, -51000,"Physic")
o.Scale=1.25
o.Orientation=0.7,0.7,0,0
o.Lights=[ (20,0.05,(255,180,96)) ]

o=Bladex.CreateEntity("Garg2","Gargola02",231500, 33000, -70500,"Physic")
o.Scale=3
o.SelfIlum=0
o.Orientation=0,0,0.5,-0.5
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)


o=Bladex.CreateEntity("GarFire2","Hoguera",231500, 34900, -69000,"Physic")
o.Scale=1.25
o.Orientation=0.7,0.7,0,0
o.Lights=[ (20,0.05,(255,180,96)) ]

########################## Wall Tapestries ###########################

o=Bladex.CreateEntity("Tapest1","TapizAurelio",242200, 26500, -60250,"Physic")
o.Scale=6
o.Orientation=-0.5,-0.5,-0.5,0.5
o.Static=1

o=Bladex.CreateEntity("Tapest2","Tapiz5",244500, 32000, -53000,"Physic")
o.Scale=4
o.Orientation=-0.5,-0.5,-0.5,0.5
o.Static=1

o=Bladex.CreateEntity("Tapest3","Tapiz6",244500, 32000, -67500,"Physic")
o.Scale=4
o.Orientation=-0.5,-0.5,-0.5,0.5
o.Static=1




#################################### Side Crypts ################

o=Bladex.CreateEntity("Altar2","Altar",202000, 39800, -43000,"Physic")
o.Scale=1
o.SelfIlum=0
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

o=Bladex.CreateEntity("AltarStone2","LapidaCaballero",202000, 38800, -43000,"Physic")
o.Scale=0.8
o.SelfIlum=0
o.Orientation=0.707,0.707,0,0
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

o=Bladex.CreateEntity("AGrid2","Rastrillo",202000, 37000, -47000,"Physic")
o.Scale=1.1
o.SelfIlum=0
o.Orientation=0.707,0.707,0,0
o.Static=1

o=Bladex.CreateEntity("Sh2","Blason2",202000, 36500, -39500,"Physic")
o.Scale=1.5
o.SelfIlum=0
o.Orientation=0.707,0.707,0,0
o.Static=1

o=Bladex.CreateEntity("Skl1","Skull",202300, 38600, -43500,"Physic")
o.Scale=1.4
o.SelfIlum=0.1
o.Orientation=0.7,0.5,0,0
o.Static=0
o.Impulse(0,0,0)

################################################ Left Crypt (Amazon) ######

o=Bladex.CreateEntity("Altar3","Altar",202000, 39800, -77000,"Physic")
o.Scale=1
o.SelfIlum=0
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

o=Bladex.CreateEntity("AltarStone3","LapidaAmazona",202000, 38800, -77000,"Physic")
o.Scale=0.8
o.SelfIlum=0
o.Orientation=0.707,0.707,0,0
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

o=Bladex.CreateEntity("AGrid3","Rastrillo",202000, 37000, -73000,"Physic")
o.Scale=1.1
o.SelfIlum=0
o.Orientation=0.707,0.707,0,0
o.Static=1

o=Bladex.CreateEntity("Sh3","Blason3",202000, 36500, -80500,"Physic")
o.Scale=1.5
o.SelfIlum=0
o.Orientation=0.707,0.707,0,0
o.Static=1




################################# King/Queen tombs #####################

o=Bladex.CreateEntity("King1","Reyaurelio",191000, 38500, -49500,"Physic")
o.Scale=2
o.SelfIlum=0
o.Orientation=0.7,0.7,0,0
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

o=Bladex.CreateEntity("Queen1","ReinaAurelio",191000, 38500, -70500,"Physic")
o.Scale=2
o.SelfIlum=0
o.Orientation=0,0,0.5,-0.5
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)


o=Bladex.CreateEntity("Altar4","Altar",191000, 39800, -52500,"Physic")
o.Scale=1
o.SelfIlum=0
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

o=Bladex.CreateEntity("AltarStone4","Lapidareina",191000, 38800, -52500,"Physic")
o.Scale=1
o.SelfIlum=0
o.Orientation=0.707,0.707,0,0
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)


o=Bladex.CreateEntity("Altar5","Altar",191000, 39800, -67500,"Physic")
o.Scale=1
o.SelfIlum=0
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

o=Bladex.CreateEntity("AltarStone5","Lapidarey",191000, 38800, -67500,"Physic")
o.Scale=1
o.SelfIlum=0
o.Orientation=0.707,0.707,0,0
o.Static=1
o.Solid=1
Sparks.SetStoneSparkling(o.Name)

############################### Suits Armour ############################

o=Bladex.CreateEntity("Armsuit1","Armadura",206500, 38800, -48500,"Physic")
o.Scale=1
o.Orientation=0.707107,0.707107,0.000000,0.000000

o=Bladex.CreateEntity("Armsuit3","Armadura",226500, 38800, -48500,"Physic")
o.Scale=1
o.Orientation=0.707107,0.707107,0.000000,0.000000

o=Bladex.CreateEntity("Armsuit4","Armadura",236500, 38800, -48500,"Physic")
o.Scale=1
o.Orientation=0.707107,0.707107,0.000000,0.000000


######################################################################

############################ Thrones Chairs ######################################

o=Bladex.CreateEntity("tron1","Trono",244000, 37000, -50500,"Physic")
o.Scale=2
o.Orientation=-0.5,-0.5,-0.5,0.5
o.Static=1
o.Solid=1

o=Bladex.CreateEntity("tron2","Trono",244000, 37000, -69500,"Physic")
o.Scale=2
o.Orientation=-0.5,-0.5,-0.5,0.5
o.Static=1
o.Solid=1

################################# Red Chairs ########################

o=Bladex.CreateEntity("Chair1","ButacaMago",228500, 38300, -49500,"Physic")
o.Scale=2
o.Orientation=0.707,0.707,0,0
o.Static=1
o.Solid=1
o=Bladex.CreateEntity("Chair2","ButacaMago",231500, 38300, -49500,"Physic")
o.Scale=2
o.Orientation=0.707,0.707,0,0
o.Static=1
o.Solid=1
o=Bladex.CreateEntity("Chair3","ButacaMago",234500, 38300, -49500,"Physic")
o.Scale=2
o.Orientation=0.707,0.707,0,0
o.Static=1
o.Solid=1
#####################################

o=Bladex.CreateEntity("Chair4","ButacaMago",228500, 38300, -71500,"Physic")
o.Scale=2
o.Orientation=0,0,0.5,-0.5
o.Static=1
o.Solid=1
o=Bladex.CreateEntity("Chair5","ButacaMago",231500, 38300, -71500,"Physic")
o.Scale=2
o.Orientation=0,0,0.5,-0.5
o.Static=1
o.Solid=1
o=Bladex.CreateEntity("Chair6","ButacaMago",234500, 38300, -71500,"Physic")
o.Scale=2
o.Orientation=0,0,0.5,-0.5
o.Static=1
o.Solid=1

################################## Benches ##################################

o=Bladex.CreateEntity("Ben1","Banco",221500, 39400, -49000,"Physic")
o.Scale=1.5
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
o=Bladex.CreateEntity("Ben2","Banco",211500, 39400, -49000,"Physic")
o.Scale=1.5
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
o=Bladex.CreateEntity("Ben3","Banco",241500, 39400, -49000,"Physic")
o.Scale=1.5
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1

o=Bladex.CreateEntity("Ben1","Banco",221500, 39400, -71000,"Physic")
o.Scale=1.5
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
o=Bladex.CreateEntity("Ben2","Banco",211500, 39400, -71000,"Physic")
o.Scale=1.5
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1
o=Bladex.CreateEntity("Ben3","Banco",241500, 39400, -71000,"Physic")
o.Scale=1.5
o.Orientation=0.5,0.5,-0.5,0.5
o.Static=1
o.Solid=1


################# DOOM lamps #####################################################



####################
dl1=Bladex.CreateEntity("DoomLamp7","Lamparaegipto", 206500, 38500, -50000)
dl1.Static=1
dl1.Scale=1
dl1.Orientation=0.707107,0.707107,0.000000,0.000000
lo=AuxFuncs.GetSpot(dl1)
lo.CastShadows=0

####################
dl2=Bladex.CreateEntity("DoomLamp8","Lamparaegipto", 206500, 38500, -70000)
dl2.Static=1
dl2.Scale=1
dl2.Orientation=0.707107,0.707107,0.000000,0.000000
lo=AuxFuncs.GetSpot(dl2)
lo.CastShadows=0

##################
dl3=Bladex.CreateEntity("DoomLamp9","Lamparaegipto", 196500, 38500, -50000)
dl3.Static=1
dl3.Scale=1
dl3.Orientation=0.707107,0.707107,0.000000,0.000000
lo=AuxFuncs.GetSpot(dl3)
lo.CastShadows=0

####################
dl4=Bladex.CreateEntity("DoomLamp10","Lamparaegipto", 196500, 38500, -70000)
dl4.Static=1
dl4.Scale=1
dl4.Orientation=0.707107,0.707107,0.000000,0.000000
lo=AuxFuncs.GetSpot(dl4)
lo.CastShadows=0

