import Bladex
import Doors
import Levers
import Locks
import Objects
import Sounds
import AuxFuncs
import darfuncs
import Stars
import stone
import heavyObjects





sdoor2d=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-piedra-deslizando-2.wav","StoneDesliz2")
sdoor2d.MaxDistance=20000
sdoor2d.MinDistance=1000
sdoor2d.Volume=1

sdoor2g=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-piedra-golpe2.wav","StoneGolpe2")
sdoor2g.MaxDistance=20000
sdoor2g.MinDistance=2000
sdoor2g.Volume=1


deslizrasanexo=Sounds.CreateEntitySound("..\\..\\Sounds\\rastrillo.wav", "DeslizRasanexo")
deslizrasanexo.Volume=0.8
deslizrasanexo.MinDistance=5000
deslizrasanexo.MaxDistance=20000

golperasanexo=Sounds.CreateEntitySound("..\\..\\Sounds\\golpe-metal-mediano.wav", "GolpeRasanexo")
golperasanexo.Volume=0.8
golperasanexo.MinDistance=5000
golperasanexo.MaxDistance=20000


###### planets and magic path exits

plgate=Bladex.CreateEntity("PlanetsExitGate","Rastrillo10",142154.915948,38232.081541,-28016.1449811, Reference.ObjType("Rastrillo10"))
plgate.Scale=0.6
plgate.Orientation=(0.5,0.5,-0.5,0.5)
plgate.Frozen=1
plgatedin=Objects.CreateDinamicObject("PlanetsExitGate")

mpgate=Bladex.CreateEntity("MagicPathExitGate","Rastrillo10",144180.254075,38432.1119166,-87320.9818065, Reference.ObjType("Rastrillo10"))
mpgate.Scale=0.6
mpgate.Orientation=(0.5,0.5,-0.5,0.5)
mpgate.Frozen=1
mpgatedin=Objects.CreateDinamicObject("MagicPathExitGate")


############################# spider cave

o=Bladex.CreateEntity("Menhir1_335","Menhir1",-109668.800727,37669.5193743,8476.68323763, Reference.ObjType("Menhir1"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.701057374477,0.701057434082,0.0922959670424,-0.0922959595919)


o=Bladex.CreateEntity("Menhir1_336","Menhir1",-107268.800727,38269.5193743,12876.6832376, Reference.ObjType("Menhir1"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.653281509876,0.653281509876,0.270598053932,-0.27059802413)


spdoor=Bladex.CreateEntity("SpiderDoor","LapidaBarbaro",-108053.20295,38651.8627012,10469.893987, Reference.ObjType("LapidaBarbaro"))
spdoor.Scale=1.8
spdoor.Orientation=(0.5,0.0,0.866,0.0)
spdoordin=Objects.CreateDinamicObject("SpiderDoor")




################################ Breakable wall

derr1=Bladex.GetSector(246000, 38000, -58000)
derr1.Active=0
derr2=Bladex.GetSector(246000, 38000, -60000)
derr2.Active=0



#derr1.InitBreak((250.0, 0.0, 0.0), (1250.0, 100.0, 0.0), (0.0, 0.0, 0.0))
#derr2.InitBreak((250.0, 0.0, 0.0), (1750.0, 100.0, 0.0), (0.0, 0.0, 0.0))


derr1.InitBreak((350,0,0),(0,1000,0),(0, 200,1500))
derr2.InitBreak((350,0,0),(0,1000,0),(0, 200,1500))



############################# Extra doors by Pro

# mino cave




mindoor1=Doors.CreateDoor("MinoDoor1", (-4250, 26000,-40750), (0,0,-1), 0, 2500, Doors.CLOSED)
mindoor1.opentype=Doors.UNIF
mindoor1.o_med_vel=-500
mindoor1.o_med_displ=2500
mindoor1.closetype=Doors.AC
mindoor1.c_init_displ=2500
mindoor1.c_med_vel=8000
mindoor1.SetWhileOpenSound(sdoor2d)
mindoor1.SetEndOpenSound(sdoor2g)


mindoor1lvr=Levers.PlaceLever("MinoDoor1lever", Levers.LeverType2, (-5571,27236,-39258), (0.5,0.5,0.5,-0.5), 1.0)
mindoor1lvr.mode=2
mindoor1lvr.OnTurnOnFunc=UnhideMin1
mindoor1lvr.OnTurnOnArgs=()






# up is 33209

ksgate=Bladex.CreateEntity("KSGate","Rastrillo10",-67823,35809,-58099, Reference.ObjType("Rastrillo10"))
ksgate.Scale=2.0
ksgate.Orientation=(0.706433773041,-0.706433773041,-0.0308435689658,-0.0308435559273)
ksgatedin=Objects.CreateDinamicObject("KSGate")



prodoor2=Doors.CreateDoor("ProDoor2", (187750, 38000,-61000), (0,1,0), 0, 6500, Doors.OPENED)

prodoor2.opentype=Doors.UNIF
prodoor2.o_med_vel=-500
prodoor2.o_med_displ=6500

prodoor2.closetype=Doors.AC
prodoor2.c_init_displ=6500
prodoor2.c_med_vel=12000







prodoor1=Doors.CreateDoor("ProDoor1", (-3750, 4000,-11250), (0,1,0), 1000, 4000, Doors.CLOSED)

prodoor1.opentype=Doors.UNIF
prodoor1.o_med_vel=-500
prodoor1.o_med_displ=3000

prodoor1.closetype=Doors.AC
prodoor1.c_init_displ=3000
prodoor1.c_med_vel=8000

prodoor1.SetWhileOpenSound(sdoor2d)
prodoor1.SetEndOpenSound(sdoor2g)




gate1loc=Locks.PlaceLock("PitGateLock","Cerraduracobox",(-4778.0,12816.0,-30185.0),(0.0922,0.0922,0.701,-0.701), 2.0)
gate1loc.key="PitKey"
darfuncs.SetHint(gate1loc.obj,"Pit Lock")
gate1loc.OnUnLockFunc=OpenPitGate
gate1loc.OnUnLockArgs=()

gate1=Bladex.CreateEntity("PitGate","Rastrillo10",-5756,13091,-31477, Reference.ObjType("Rastrillo10"))
gate1.Scale=0.6
gate1.Orientation=(0.707,-0.707,0.0,0.0)
gate1.Frozen=1
gate1din=Objects.CreateDinamicObject("PitGate")





stake1=Bladex.CreateEntity("EstacaFernando_102","EstacaFernando",5158.6388416,39184.9516413,1800.15211993)
stake1.Scale=1.2
stake1.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
stake1din=Objects.CreateDinamicObject("EstacaFernando_102")


stake2=Bladex.CreateEntity("EstacaFernando_103","EstacaFernando",5358.6388416,38884.9516413,2400.15211993)
stake2.Scale=1.2
stake2.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
stake2din=Objects.CreateDinamicObject("EstacaFernando_103")

stake3=Bladex.CreateEntity("EstacaFernando_104","EstacaFernando",5558.6388416,38884.9516413,3100.15211993)
stake3.Scale=1.2
stake3.Orientation=(0.353553473949,0.353553444147,-0.612372398376,0.612372398376)
stake3din=Objects.CreateDinamicObject("EstacaFernando_104")

stake4=Bladex.CreateEntity("EstacaFernando_105","EstacaFernando",5558.6388416,38884.9516413,3700.15211993)
stake4.Scale=1.0
stake4.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
stake4din=Objects.CreateDinamicObject("EstacaFernando_105")

stake5=Bladex.CreateEntity("EstacaFernando_106","EstacaFernando",5558.6388416,39484.9516413,4300.15211993)
stake5.Scale=1.4
stake5.Orientation=(0.560985565186,0.560985565186,-0.430459290743,0.430459290743)
stake5din=Objects.CreateDinamicObject("EstacaFernando_106")




stakelvr=Levers.PlaceLever("Stakeslever", Levers.LeverType3, (2368,38781,5343), (0.707,0.707,0.0,0.0), 1.0)
stakelvr.mode=2
stakelvr.OnTurnOnFunc=OpenColonyBarrier
stakelvr.OnTurnOnArgs=()





bridgeloc=Locks.PlaceLock("BridgeGateLock","Cerraduracutre",(6120,38830,-9578),(0.353,-0.353,0.612,0.612), 2.4)
bridgeloc.key="BridgeKey"
darfuncs.SetHint(bridgeloc.obj,"Bridge Lock")
bridgeloc.OnUnLockFunc=OpenBridgeGate
bridgeloc.OnUnLockArgs=()

brgate1=Bladex.CreateEntity("BridgeGate","Rastrillo10",4767,38200,-8494, Reference.ObjType("Rastrillo10"))
brgate1.Scale=0.6
brgate1.Orientation=(0.0922,0.0922,-0.701,0.701)
brgate1.Frozen=1
brgate1din=Objects.CreateDinamicObject("BridgeGate")



mzgate1=Bladex.CreateEntity("MazeGate","Rastrillo10",34666,39028,-2029, Reference.ObjType("Rastrillo10"))
mzgate1.Scale=0.6
mzgate1.Orientation=(0.5,-0.5,-0.5,-0.5)
mzgate1.Frozen=1
mzgate1din=Objects.CreateDinamicObject("MazeGate")




# close hight 37983

# open hight 40596


stake6=Bladex.CreateEntity("EstacaFernando_135","EstacaFernando",-57531,40596,-24887)
stake6.Scale=1.0
stake6.Orientation=(0.707,0.707,0.0,0.0)
stake6din=Objects.CreateDinamicObject("EstacaFernando_135")

stake7=Bladex.CreateEntity("EstacaFernando_136","EstacaFernando",-57931,40596,-25087)
stake7.Scale=1.0
stake7.Orientation=(0.5,0.5,-0.5,0.5)
stake7din=Objects.CreateDinamicObject("EstacaFernando_136")


stake8=Bladex.CreateEntity("EstacaFernando_137","EstacaFernando",-58191,40596,-25317)
stake8.Scale=1.0
stake8.Orientation=(0.707,0.707,0.0,0.0)
stake8din=Objects.CreateDinamicObject("EstacaFernando_137")


stake9=Bladex.CreateEntity("EstacaFernando_138","EstacaFernando",-58591,40596,-25717)
stake9.Scale=1.0
stake9.Orientation=(0.707,0.707,0.0,0.0)
stake9din=Objects.CreateDinamicObject("EstacaFernando_138")




######### entrance to lava cave

door1=Doors.CreateDoor("door1", (61000, 36000,-31000), (0,1,0), 0, 4000, Doors.CLOSED)
door1.opentype=Doors.UNIF
door1.o_med_vel=-1000
door1.o_med_displ=4000
door1.closetype=Doors.AC
door1.c_init_displ=4000
door1.c_med_vel=8000
door1.SetWhileOpenSound(sdoor2d)
door1.SetEndOpenSound(sdoor2g)

##### exit from lava cave

door8=Doors.CreateDoor("door8", (62000, 39000, -58000), (0,1,0), 0, 6000, Doors.CLOSED)
door8.opentype=Doors.UNIF
door8.o_med_vel=-1200
door8.o_med_displ=6000
door8.closetype=Doors.AC
door8.c_init_displ=6000
door8.c_med_vel=10000
door8.SetWhileOpenSound(sdoor2d)
door8.SetEndOpenSound(sdoor2g)


############ Exit CK room


door2=Doors.CreateDoor("Door2", (77000, 38000, -65000), (0,0,-1), 200, 2000, Doors.CLOSED)
door2.opentype=Doors.UNIF
door2.o_med_vel=-1000
door2.o_med_displ=1800
door2.closetype=Doors.AC
door2.c_init_displ=1800
door2.c_med_vel=8000
door2.SetWhileOpenSound(sdoor2d)
door2.SetEndOpenSound(sdoor2g)

door2a=Doors.CreateDoor("Door2a", (77000, 38000, -67000), (0,0,1), 200, 2000, Doors.CLOSED)
door2a.opentype=Doors.UNIF
door2a.o_med_vel=-1000
door2a.o_med_displ=1800
door2a.closetype=Doors.AC
door2a.c_init_displ=1800
door2a.c_med_vel=8000



######### Tomb Door

palanm3=Levers.PlaceLever("PALAm3",Levers.LeverType3,(-40100,38500,13000),(0.495618,0.504344,-0.495618,0.504344),0.8)
palanm3.mode=2
palanm3.OnTurnOnFunc=Abredoor3
palanm3.OnTurnOnArgs=()


palanm3a=Levers.PlaceLever("PALAm3a",Levers.LeverType3,(-42000,38500,-51500),(0,0,0.5,-0.5),0.8)
palanm3a.mode=2
palanm3a.OnTurnOnFunc=Tomb3a
palanm3a.OnTurnOnArgs=()


palanm3b=Levers.PlaceLever("PALAm3b",Levers.LeverType3,(52250,32500,24000),(0,0,0.5,-0.5),0.8)
palanm3b.mode=2
palanm3b.OnTurnOnFunc=Tomb3b
palanm3b.OnTurnOnArgs=()


palanm3c=Levers.PlaceLever("PALAm3c",Levers.LeverType3,(-37000,31500,-21000),(0,0,0.5,-0.5),0.8)
palanm3c.mode=2
palanm3c.OnTurnOnFunc=Tomb3c
palanm3c.OnTurnOnArgs=()

tomb=0
tomba=0
tombb=0
tombc=0
tombx=0


door3=Doors.CreateDoor("door3", (30000, 36000,-1500), (0,1,0), 0, 4000, Doors.CLOSED)
door3.opentype=Doors.UNIF
door3.o_med_vel=-800
door3.o_med_displ=4000
door3.closetype=Doors.AC
door3.c_init_displ=4000
door3.c_med_vel=8000


########################### Stairs 

stair1=Doors.CreateDoor("stair1", (212500, 38000,-60000), (0,-1,0), 0, 1000, Doors.CLOSED)
stair1.opentype=Doors.UNIF
stair1.o_med_vel=-600
stair1.o_med_displ=1000
stair1.closetype=Doors.AC
stair1.c_init_displ=1000
stair1.c_med_vel=8000
stair1.SetEndOpenSound(sdoor2g)

stair2=Doors.CreateDoor("stair2", (213500, 38000,-60000), (0,-1,0), 0, 2000, Doors.CLOSED)
stair2.opentype=Doors.UNIF
stair2.o_med_vel=-600
stair2.o_med_displ=2000
stair2.closetype=Doors.AC
stair2.c_init_displ=2000
stair2.c_med_vel=8000



stair3=Doors.CreateDoor("stair3", (214500, 38000,-60000), (0,-1,0), 0, 3000, Doors.CLOSED)
stair3.opentype=Doors.UNIF
stair3.o_med_vel=-600
stair3.o_med_displ=3000
stair3.closetype=Doors.AC
stair3.c_init_displ=3000
stair3.c_med_vel=8000


stair4=Doors.CreateDoor("stair4", (216500, 38000,-60000), (0,1,0), 0, 3400, Doors.CLOSED)
stair4.opentype=Doors.UNIF
stair4.o_med_vel=-1100
stair4.o_med_displ=3400
stair4.closetype=Doors.AC
stair4.c_init_displ=3400
stair4.c_med_vel=2000
stair4.SetEndOpenSound(sdoor2g)
stair4.OpenDoor()

#######################################################################################################
########## cathedral doors

ldoor=Bladex.CreateEntity("FinDoorL","PuertaFernando",186500, 33000, -56800)
ldoor.Scale=1
ldoor.Orientation=-0.5,-0.5,-0.5,0.5
ldoor.Solid=1
ldoordin = Objects.CreateDinamicObject("FinDoorL")

rdoor=Bladex.CreateEntity("FinDoorR","PuertaFernando",186500, 33000, -63800)
rdoor.Scale=1
rdoor.Orientation=0.5,0.5,-0.5,0.5
rdoor.Solid=1
rdoordin = Objects.CreateDinamicObject("FinDoorR")


###########################################################################################################





p=8000,1000,-12500
r=0.707107,0.707107,0.000000,0.000000
o=heavyObjects.CreateHeavyObject("Boulder","BoladePiedra",p,r,1.0, heavyObjects.StoneHitEvent )
o.Scale=0.95
o.Static=0
o.OnStopFunc= StoneFinished
stone.lock( o.Name, stone.DROPDARKDUST, 0, 1100, 0.0, 0.6, 20.0, stone.STONESOUND, 1 ) 






######### vamp room ent

door4a=Doors.CreateDoor("Door4a", (85250, 36000, -62500), (0,1,0), 200, 4000, Doors.OPENED)
door4a.opentype=Doors.UNIF
door4a.o_med_vel=-2000
door4a.o_med_displ=3800
door4a.closetype=Doors.AC
door4a.c_init_displ=3800
door4a.c_med_vel=8000


door4=Doors.CreateDoor("Door4", (90000, 36000, -62500), (0,1,0), 200, 4000, Doors.CLOSED)
door4.opentype=Doors.UNIF
door4.o_med_vel=-1000
door4.o_med_displ=3800
door4.closetype=Doors.AC
door4.c_init_displ=3800
door4.c_med_vel=4000
door4.SetWhileOpenSound(sdoor2d)
door4.SetEndOpenSound(sdoor2g)


palanm4=Levers.PlaceLever("PALAm4",Levers.LeverType3,(88500,39000,-58100),(0.707000,0.707000,0.0,0.0),0.8)
palanm4.mode=1
palanm4.OnTurnOnFunc=Abredoor4
palanm4.OnTurnOnArgs=()




### magic path room

door6=Doors.CreateDoor("door6", (115000, 36000,-65000), (0,1,0), 0, 4000, Doors.CLOSED)
door6.opentype=Doors.UNIF
door6.o_med_vel=-1000
door6.o_med_displ=4000
door6.closetype=Doors.AC
door6.c_init_displ=4000
door6.c_med_vel=8000
door6.SetWhileOpenSound(sdoor2d)
door6.SetEndOpenSound(sdoor2g)


palanm6=Levers.PlaceLever("PALAm1",Levers.LeverType3,(115100,38500,-64000),(0.5,0.5,-0.5,0.5),0.5)
palanm6.mode=1
palanm6.OnTurnOnFunc=Abredoor6
palanm6.OnTurnOnArgs=()


################################# planets room


door16=Doors.CreateDoor("door16", (115000, 38000,-54500), (0,1,0), 0, 4000, Doors.CLOSED)
door16.opentype=Doors.UNIF
door16.o_med_vel=-1000
door16.o_med_displ=4000
door16.closetype=Doors.AC
door16.c_init_displ=4000
door16.c_med_vel=8000
door16.SetWhileOpenSound(sdoor2d)
door16.SetEndOpenSound(sdoor2g)


palanm16=Levers.PlaceLever("PALAm16",Levers.LeverType3,(115100,38500,-56000),(0.5,0.5,-0.5,0.5),0.5)
palanm16.mode=1
palanm16.OnTurnOnFunc=Abredoor16
palanm16.OnTurnOnArgs=()


#############################################################################
######### Vamp exit


door5=Doors.CreateDoor("door5", (112750, 38000, -60500), (0,1,0), 0, 4000, Doors.CLOSED)
door5.opentype=Doors.UNIF
door5.o_med_vel=-600
door5.o_med_displ=4000
door5.closetype=Doors.AC
door5.c_init_displ=4000
door5.c_med_vel=4000
door5.SetWhileOpenSound(sdoor2d)
door5.SetEndOpenSound(sdoor2g)

#####################
"""
doorX=Doors.CreateDoor("doorX", (230000, 44000,-60000), (0,-1,0), 0, 6000, Doors.CLOSED)
doorX.opentype=Doors.UNIF
doorX.o_med_vel=-1000
doorX.o_med_displ=6000

doorX.closetype=Doors.AC
doorX.c_init_displ=6000
doorX.c_med_vel=1000
"""


doorX=Doors.CreateDoor("doorX", (230000, 44000,-60000), (0,-1,0), 0, 6000, Doors.CLOSED)
doorX.opentype=Doors.AC_UNIF_DEC
doorX.o_init_vel=0
doorX.o_init_displ=500
doorX.o_med_vel=-1000
doorX.o_med_displ=5000
doorX.o_end_vel=0
doorX.o_end_displ=500

doorX.closetype=Doors.AC_UNIF_DEC
doorX.c_init_vel=0
doorX.c_init_displ=500
doorX.c_med_vel=1000
doorX.c_med_displ=5000
doorX.c_end_vel=0
doorX.c_end_displ=500

doorX.OnEndCloseFunc=DoorXFin
doorX.OnEndCloseArgs=()


centcol=Bladex.CreateEntity("MiddleColumn","Columnaestrecha",231500,39000,-60000, Reference.ObjType("Columnaestrecha"))
centcol.Scale=1.2
centcol.Orientation=(0.707,-0.707,0.0,0.0)
centcoldin=Objects.CreateDinamicObject("MiddleColumn")

sphbowl=Bladex.CreateEntity("SphereBowl","Palangana",231500,37950,-60000, Reference.ObjType("Palangana"))
sphbowl.Scale=1.0
sphbowl.Orientation=(0.707,0.707,0.0,0.0)
sphbowl.FiresIntensity=[ 8.0 ]
sphbowl.Lights = [(5.0, 0.1, (255, 196, 128))]
sphbowldin=Objects.CreateDinamicObject("SphereBowl")







